#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#include<ext/pb_ds/tree_policy.hpp>
using namespace __gnu_pbds;
using namespace std;

#define int ll

using ll = long long;
using ld = long double;
#define all(x) x.begin(), x.end()

//using ordered_set = tree<ll, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;
//
//struct sparse_table {
//    vector<vector<pair<int, int>>> spt;
//    vector<int> lg;
//
//    void build(vector<int> a) {
//        int n = a.size();
//        lg.assign(n + 1, 0);
//        for (int i = 2; i <= n; ++i) lg[i] = lg[i >> 1] + 1;
//        spt.assign(n, vector<pair<int, int>>(lg.back() + 1));
//        for (int i = 0; i < n; ++i) spt[i][0] = {a[i], i};
//        for (int k = 0; (1 << k) < n; ++k) {
//            for (int i = 0; i + (1 << k) < n; ++i) {
//                spt[i][k + 1] = min(spt[i][k], spt[i + (1 << k)][k]);
//            }
//        }
//    }
//
//    pair<int, int> get(int l, int r) {
//        int k = lg[r - l + 1];
//        return min(spt[l][k], spt[r - (1 << k) + 1][k]);
//    }
//};

const int MOD = 1e9+7;

int32_t main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n, m;
    cin >> n >> m;

    vector<vector<int>> dp(n + 1, vector<int>(m + 1)), cnt(n + 1, vector<int>(m + 1));
    vector<vector<int>> prefcnt(n + 1, vector<int>(m + 1)), prefjcnt(n + 1, vector<int>(m + 1));
    vector<vector<int>> pref(n + 1, vector<int>(m + 1)), prefj(n + 1, vector<int>(m + 1));

    for (int i = 1; i <= n; i++) {
        cnt[i][1] = 1;
        prefcnt[i][1] = cnt[i][1];
        prefjcnt[i][1] = cnt[i][1];
    }
    for (int j = 1; j <= m; j++) {
        cnt[1][j] = 1;
        prefcnt[1][j] = prefcnt[1][j - 1] + cnt[1][j];
        prefjcnt[1][j] = prefjcnt[1][j - 1] + cnt[1][j] * j;
        prefcnt[1][j] %= MOD;
    }

    for (int i = 2; i <= n; i++) {
        for (int j = 2; j <= m; j++) {
            cnt[i][j] = 1;
            for (int i2 = 1; i2 + 2 <= i; i2++) {
                cnt[i][j] += (prefcnt[i2][j - 2] * (i - i2 - 1)) % MOD * (j - 1);
                cnt[i][j] %= MOD;
                cnt[i][j] -= (prefjcnt[i2][j - 2] * (i - i2 - 1)) % MOD;
                cnt[i][j] %= MOD;
                if (cnt[i][j] < 0) cnt[i][j] += MOD;
            }
            prefcnt[i][j] = prefcnt[i][j - 1] + cnt[i][j];
            prefjcnt[i][j] = prefjcnt[i][j - 1] + cnt[i][j] * j;
            prefcnt[i][j] %= MOD;
            prefjcnt[i][j] %= MOD;
        }
    }

//    for (int i = 0; i <= n; i++) {
//        for (int j = 0; j <= m; j++) {
//            cout << cnt[i][j] << " ";
//        }
//        cout << "\n";
//    }
//    cout << "\n";
//    for (int i = 0; i <= n; i++) {
//        for (int j = 0; j <= m; j++) {
//            cout << prefcnt[i][j] << " ";
//        }
//        cout << "\n";
//    }
//    cout << "\n";
//
//    for (int i = 0; i <= n; i++) {
//        for (int j = 0; j <= m; j++) {
//            cout << prefjcnt[i][j] << " ";
//        }
//        cout << "\n";
//    }


    for (int i = 1; i <= n; i++) {
        dp[i][1] = i;
        pref[i][1] = pref[i][0] + dp[i][1];
        prefj[i][1] = pref[i][0] + dp[i][1] * 1;
    }
    for (int j = 1; j <= m; j++) {
        dp[1][j] = j;
        pref[1][j] = pref[1][j - 1] + dp[1][j];
        prefj[1][j] = prefj[1][j - 1] + dp[1][j] * j;
        prefj[1][j] %= MOD;
    }

    for (int i = 2; i <= n; i++) {
        for (int j = 2; j <= m; j++) {
            dp[i][j] = i * j;
            for (int i2 = 1; i2 + 2 <= i; i2++) {
                dp[i][j] += (pref[i2][j - 2] * (i - i2 - 1)) % MOD * (j - 1);
                dp[i][j] %= MOD;
                dp[i][j] -= (prefj[i2][j - 2] * (i - i2 - 1)) % MOD;
                dp[i][j] %= MOD;
                if (dp[i][j] < 0) dp[i][j] += MOD;

                dp[i][j] += (prefcnt[i2][j - 2] * (i - i2 - 1)) % MOD * ((j - 1) * i * j) % MOD;
                dp[i][j] %= MOD;
                dp[i][j] -= (prefjcnt[i2][j - 2] * (i - i2 - 1)) % MOD * i * j;
                dp[i][j] %= MOD;
                if (dp[i][j] < 0) dp[i][j] += MOD;
            }
            pref[i][j] = (pref[i][j - 1] + dp[i][j]) % MOD;
            prefj[i][j] = (prefj[i][j - 1] + dp[i][j] * j) % MOD;
        }
    }

//    for (int i = 0; i <= n; i++) {
//        for (int j = 0; j <= m; j++) {
//            cout << dp[i][j] << " ";
//        }
//        cout << "\n";
//    }

    cout << dp[n][m];

}