#include <bits/stdc++.h>

using namespace std;

#define int long long
#define ld long double
#define VI vector<int>
#define PAR pair<int,int>
#define VP vector<PAR>
#define x first
#define y second
#define INF ((int)1e9+7)

template<class T>
istream& operator>>(istream& in, vector<T>& v) {
    for (int i = 0; i < v.size(); ++i) {
        in >> v[i];
    }
    return in;
}

int n;
vector<VP> g;

#define MOD 1000000007LL

void deikstra(int s, VI& vcnt, VI& dist) {
    set<PAR> q;
    q.emplace(0, s);
    dist.assign(n, INF*INF);
    vcnt.assign(n, 0);
    dist[s] = 0;
    vcnt[s] = 1;
    while (!q.empty()) {
        auto v = *q.begin();
        q.erase(v);
        for (auto u : g[v.second]) {
            if (dist[u.first] > dist[v.second] + u.second) {
                dist[u.first] = dist[v.second] + u.second;
                vcnt[u.first] = vcnt[v.second];
                q.emplace(dist[u.first], u.first);
            } else if (dist[u.first] == dist[v.second] + u.second) {
                vcnt[u.first] += vcnt[v.second];
                vcnt[u.first] %= MOD;
            }
        }
    }
}

signed main() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(false);
    cout.precision(16);
    int m;
    cin >> n >> m;
    g.resize(n);
    int s, t, l;
    cin >> s >> t >> l;
    --s;
    --t;
    for (int i = 0; i < m; ++i) {
        int a, b, w;
        cin >> a >> b >> w;
        --a;
        --b;
        g[a].emplace_back(b, w);
        g[b].emplace_back(a, w);
    }

    VI dist1(n), dist2(n), vcnt1(n), vcnt2(n);
    deikstra(s, vcnt1, dist1);
    deikstra(t, vcnt2, dist2);

    int res = 0;

    for (int i = 0; i < n; ++i) {
        if (dist1[i] + dist2[i] > dist1[t] || i == t) continue;
        for (auto u : g[i]) {
            if (dist1[i] + u.second + dist2[u.first] == l) {
                res += vcnt1[i] * vcnt2[u.first] % MOD;
                res %= MOD;
            }
        }
    }

    cout << res << endl;
    return 0;
}
