#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
#define F first
#define S second
#define PB push_back

ll n, m, t, l;

void solve() {
    ll h, w;
    cin >> h >> w;
    vector <vector<int>> mas;
    mas.resize(h, vector<int>(w));
    for (int i = 0; i < h; i++) {
        string s;
        cin >> s;
        for (int j = 0; j < w; j++) {
            if (s[j] == '.') {
                mas[i][j] = 1;
            }
        }
    }
    vector<vector<int>> used;
    used.resize(h, vector <int> (w));
    queue <pair<int, int>> q;
    for (int i = 1; i < h - 1; i++) {
        if (mas[i][0]) {
            q.push({i, 0});
        }
        if (mas[i][w - 1]) {
            q.push({i, w - 1});
        }
    }
    for (int i = 0; i < w; i++) {
        if (mas[0][i]) {
            q.push({0, i});
        }
        if (mas[h - 1][i]) {
            q.push({h - 1, i});
        }
    }
    while (!q.empty()) {
        auto p = q.front();
        q.pop();
        if (!used[p.F][p.S]) {
            used[p.F][p.S]++;
            if (p.F > 0 && !used[p.F - 1][p.S] && mas[p.F - 1][p.S]) {
                q.push({p.F - 1, p.S});
            }
            if (p.F < h - 1 && !used[p.F + 1][p.S] && mas[p.F + 1][p.S]) {
                q.push({p.F + 1, p.S});
            }
            if (p.S > 0 && !used[p.F][p.S - 1] && mas[p.F][p.S - 1]) {
                q.push({p.F, p.S - 1});
            }
            if (p.S < w - 1 && !used[p.F][p.S + 1] && mas[p.F][p.S + 1]) {
                q.push({p.F, p.S + 1});
            }
        }
    }
    for (int i = 0; i < h; i++) {
        for (int j = 0; j < w; j++) {
            if (!mas[i][j]) {
                int f = 0;
                int a = 0, b = 0, c = 0, d = 0;
                if (i > 0 && mas[i - 1][j] && !used[i - 1][j]) {
                    f = 2;
                    a = 1;
                }
                if (i < h - 1 && mas[i + 1][j] && !used[i + 1][j]) {
                    f = 2;
                    b = 1;
                }
                if (j > 0 && mas[i][j - 1] && !used[i][j - 1]) {
                    f = 2;
                    c = 1;
                }
                if (j < w - 1 && mas[i][j + 1] && !used[i][j + 1]) {
                    f = 2;
                    d = 1;
                }
                if (a + b + c + d != 3) {
                    used[i][j] = f;
                    q.push({i, j});
                }
                if (!f) {
                    if (i > 0 && j > 0 && mas[i - 1][j - 1] && !used[i - 1][j - 1]) {
                        f = 2;
                    }
                    if (i > 0 && j < w - 1 && mas[i - 1][j + 1] && !used[i - 1][j + 1]) {
                        f = 2;
                    }
                    if (i < h - 1 && j > 0 && mas[i + 1][j - 1] && !used[i + 1][j - 1]) {
                        f = 2;
                    }
                    if (i < h - 1 && j < w - 1 && mas[i + 1][j + 1] && !used[i + 1][j + 1]) {
                        f = 2;
                    }
                    used[i][j] = f;
                    q.push({i, j});
                }
            }
        }
    }
    map <pair<ll, ll>, ll> mp;
    while (!q.empty()) {
        auto el = q.front();
        q.pop();
        mp[el]++;
        if (mp[el] == 2) {
            break;
        }
        if (el.F < h - 1 && mas[el.F + 1][el.S] && !used[el.F + 1][el.S]) {
            if (el.F > 0 && !mas[el.F - 1][el.S]) {
                if (el.S > 0 && mas[el.F][el.S - 1] && !used[el.F][el.S - 1]) {
                    if (el.S < w - 1 && !mas[el.F][el.S + 1]) {
                        used[el.F][el.S] = 0;
                        used[el.F - 1][el.S] = 2;
                        used[el.F][el.S + 1] = 2;
                        q.push({el.F - 1, el.S});
                        q.push({el.F, el.S + 1});
                    }
                }
                if (el.S > 0 && !mas[el.F][el.S - 1]) {
                    if (el.S < w - 1 && mas[el.F][el.S + 1] && !used[el.F][el.F + 1]) {
                        used[el.F][el.S] = 0;
                        used[el.F - 1][el.S] = 2;
                        used[el.F][el.S - 1] = 2;
                        q.push({el.F - 1, el.S});
                        q.push({el.F, el.S - 1});
                    }
                }
            }
        }
        if (el.F > 0 && mas[el.F - 1][el.S] && !used[el.F - 1][el.S]) {
            if (el.F < h - 1 && !mas[el.F + 1][el.S]) {
                if (el.S > 0 && mas[el.F][el.S - 1] && !used[el.F][el.S - 1]) {
                    if (el.S < w - 1 && !mas[el.F][el.S + 1]) {
                        used[el.F][el.S] = 0;
                        used[el.F + 1][el.S] = 2;
                        used[el.F][el.S + 1] = 2;
                        q.push({el.F + 1, el.S});
                        q.push({el.F, el.S + 1});
                    }
                }
                if (el.S > 0 && !mas[el.F][el.S - 1]) {
                    if (el.S < w - 1 && mas[el.F][el.S + 1] && !used[el.F][el.F + 1]) {
                        used[el.F][el.S] = 0;
                        used[el.F + 1][el.S] = 2;
                        used[el.F][el.S - 1] = 2;
                        q.push({el.F + 1, el.S});
                        q.push({el.F, el.S - 1});
                    }
                }
            }
        }
        if (el.F < h - 1 && el.F > 0 && el.S > 0 && el.S < w - 1) {
            int a = 0, b = 0, c = 0, d = 0;
            if (mas[el.F + 1][el.S] && !used[el.F + 1][el.S]) {
                a = 1;
            }
            if (mas[el.F - 1][el.S] && !used[el.F + 1][el.S]) {
                b = 1;
            }
            if (mas[el.F][el.S + 1] && !used[el.F][el.S + 1]) {
                c = 1;
            }
            if (mas[el.F][el.S + 1] && !used[el.F][el.S + 1]) {
                d = 1;
            }
            if (a + b + c + d == 1) {
                used[el.F][el.S] = 0;
            }
        }
        if (used[el.F][el.S] == 2) {
            q.push(el);
        }
    }
    for (int i = 0; i < h; i++) {
        for (int j = 0; j < w; j++) {
            if (used[i][j] == 2) {
                cout << '#';
            }
            else {
                cout << '.';
            }
        }
        cout << "\n";
    }
}


int main() {
    int tt = 1;
//    cin >> t;
    while (tt --) {
        solve();
    }
}
