#include <bits/stdc++.h>
using namespace std;

#define int long long
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

template<typename T>
ostream& operator<<(ostream& s, vector<T>& a) {
    for (T x : a) s << x << " ";
    s << endl;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n,q;
    cin >> n >> q;
    vector<int> a(n + 1);
    for (int i = 0; i < n; i++) cin >> a[i];
    a[n] = INT_MAX;
    vector<pair<int,int>> req(q);
    for (int i = 0; i < q; i++) {
        int k;
        cin >> k;   
        req[i] = {k, i};
    }
    sort(req.begin(), req.end());
    vector<int> ans(q, -1);
    int j = 0;
    int k_proc = 0;
    int last = -1;
    for (int i = 0; i <= n; i++) {
        int missing = a[i] - last - 1;
        while (j < q && k_proc + missing >= req[j].first) {
            ans[req[j].second] = last + req[j].first - k_proc;
            j++;
        }
        k_proc += missing;
        last = a[i];
    }
    cout << ans;
}