#include <bits/stdc++.h>
using namespace std;

#define int long long
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

const int INF = 1e18;

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int h, w;
    cin >> h >> w;
    vector<string> a(h);
    for (int i = 0; i < h; ++i) {
        cin >> a[i];
    }
    vector<vector<int>> col(h, vector<int>(w));
    auto check = [&](int i, int j) {
        return i >= 0 && i < h && j >= 0 && j < w;
    };
    vector<int> di = {-1, 0, 1, 0};
    vector<int> dj = {0, 1, 0, -1};
    function<void(int, int, int)> dfs = [&](int i, int j, int c) {
        col[i][j] = c;
        for (int k = 0; k < 4; ++k) {
            int ni = i + di[k], nj = j + dj[k];
            if (!check(ni, nj) || col[ni][nj] != 0 || a[ni][nj] != '.') continue;
            dfs(ni, nj, c);
        }
    };
    int c = 0;
    for (int i = 0; i < h; ++i) {
        for (int j = 0; j < w; ++j) {
            if (col[i][j] == 0 && a[i][j] == '.') {
                dfs(i, j, ++c);
            }
        }
    }
//    for (int i = 0; i < h; ++i) {
//        for (int j = 0; j < w; ++j) {
//            cout << col[i][j];
//        }
//        cout << '\n';
//    }
    vector<int> imin(c + 1, INF), imax(c + 1), jmin(c + 1, INF), jmax(c + 1);
    for (int i = 0; i < h; ++i) {
        for (int j = 0; j < w; ++j) {
            imin[col[i][j]] = min(imin[col[i][j]], i);
            imax[col[i][j]] = max(imax[col[i][j]], i);
            jmin[col[i][j]] = min(jmin[col[i][j]], j);
            jmax[col[i][j]] = max(jmax[col[i][j]], j);
        }
    }
    vector<vector<char>> ans(h, vector<char>(w, '.'));
    for (int k = 1; k <= c; ++k) {
        if (imin[k] == 0 || imax[k] == h - 1 || jmin[k] == 0 || jmax[k] == w - 1) continue;
//        cout << imin[k] << ' ' << imax[k] << ' ' << jmin[k] << ' ' << jmax[k] << '\n';
        for (int i = imin[k] - 1; i <= imax[k] + 1; ++i) {
            ans[i][jmin[k] - 1] = '#';
            ans[i][jmax[k] + 1] = '#';
        }
        for (int j = jmin[k] - 1; j <= jmax[k] + 1; ++j) {
            ans[imin[k] - 1][j] = '#';
            ans[imax[k] + 1][j] = '#';
        }
        for (int i = 0; i < h; ++i) {
            for (int j = 0; j < w; ++j) {
                cout << ans[i][j];
            }
            cout << '\n';
        }
        return 0;
    }
}