#include <bits/stdc++.h>
#define ff first
#define ss second
#define int long long
#define pb push_back
#define  all(x) x.begin(), x.end()
#define err(x) cerr << "["#x"] " << (x) << "\n"
#define errv(x) {cerr << "["#x"] "; for(auto &_ : (x)) cerr << _ << ", "; cerr << "\n";}
#define errvn(x, n) {cerr << "["#x"] "; for(int _ = 0;_ < n;_++) cerr << (x)[_] << ", "; cerr << "\n";}

using namespace std;
using ll = long long;
const int MOD = 1e9 + 7;
mt19937 rnd(std::chrono::high_resolution_clock::now().time_since_epoch().count());

template <typename T1, typename T2>
inline bool relaxmi(T1 &a, const T2 &b) {
    return a > b ? a = b, true : false;
}
const int N = 2e5 + 5;
int dist[N], dist2[N];
vector<pair<int, int>> g[N];
vector<int> g2[N], g3[N];
bool used[N], used2[N];

void dfsik(int v, vector<int> &path) {
    used[v] = true;
    for(auto i : g2[v])
        if(!used[i])
            dfsik(i, path);
    path.pb(v);
}

void dfsik2(int v, vector<int> &path) {
    used2[v] = true;
    for(auto i : g3[v])
        if(!used2[i])
            dfsik2(i, path);
    path.pb(v);
}

int dp[N], dp2[N];

struct edge {
    int a, b, w;
};

bool cango[N];

void solve() {
    int n, m;
    cin >> n >> m;
    int s, t, L;
    cin >> s >> t >> L;
    vector<edge> ed;
    for (int i = 0;i < m;i++) {
        int a, b, w;
        cin >> a >> b >> w;
        a--, b--;
        ed.pb({a, b, w});
        g[a].pb({b, w});
        g[b].pb({a, w});
    }
    s--, t--;
    for(int i = 0;i < N;i++)
        dist[i] = dist2[i] = MOD * MOD;
    dist[s] = 0;
    priority_queue<pair<int, int>, vector<pair<int, int>>, greater<pair<int, int>>> q;
    q.push({0, s});
    while(!q.empty()) {
        auto [w, v] = q.top();
        q.pop();
        if(dist[v] != w) continue;
        for (auto[i, w2] : g[v]) {
            if(dist[i] > w + w2) {
                dist[i] = w + w2;
                q.push({w + w2, i});
            }
        }
    }

    dist2[t] = 0;
    q.push({0, t});
    while(!q.empty()) {
        auto [w, v] = q.top();
        q.pop();
        if(dist2[v] != w) continue;
        for (auto[i, w2] : g[v]) {
            if(dist2[i] > w + w2) {
                dist2[i] = w + w2;
                q.push({w + w2, i});
            }
        }
    }

    for(int i = 0;i < n;i++) {
        for(auto [j, w] : g[i]) {
            if (dist[i] + w + dist2[j] == dist[t]) {
//                cout << "aa " << i << endl;
                cango[i] = true;
            }
            if(dist[j] == w + dist[i]) {
                g2[i].pb(j);
            }
            if(dist2[j] == w + dist2[i]) {
                g3[i].pb(j);
            }
        }
    }
    vector<int> paths, patht;
    dfsik(s, paths);
    dfsik2(t, patht);
    reverse(all(paths));
    reverse(all(patht));
    dp[s] = 1, dp2[t] = 1;
//    errv(paths);
//    errv(patht);
    for(auto i : paths) {
        for(auto j : g2[i]) {
            dp[j] += dp[i];
            dp[j] %= MOD;
        }
    }
    for(auto i : patht) {
        for(auto j : g3[i]) {
            dp2[j] += dp2[i];
            dp2[j] %= MOD;
        }
    }
    if(dist[t] == L) {
        cout << dp[t];
        return;
    }
    //[dist] 4, 2, 4, 6, 0, 12,
    //[dist2] 12, 10, 16, 6, 12, 0,
    //[dp] 1, 1, 1, 1, 1, 1,
    //[dp2] 1, 0, 0, 1, 0, 1,
//    errvn(dist, n);
//    errvn(dist2, n);
//    errvn(dp, n);
//    errvn(dp2, n);
    int res = 0;
    for(auto [a, b, w] : ed) {
        int w1 = dist[a] + dist2[b];
        int w2 = dist2[a] + dist[b];
        if(w1 < w2) {
            if (!cango[a]) {
//                cout << a << endl;
                continue;
            }
            if(w1 + w == L) {
                res += (1ll * dp[a] * dp2[b]) % MOD;
//                cout << a << " " << b << " " << (1ll * dp[a] * dp2[b]) % MOD << endl;
            }
            if(w1 + 3 * w == L && a != t && b != t && dist[t] == w1 + w && cango[b]) {
                res += (dp[a] * dp2[b]) % MOD;
//                cout << a << " " <<  (dp[a] * dp2[b]) % MOD << endl;
            }
            res %= MOD;
        } else {
            if (!cango[b]) {
//                cout << b << endl;
                continue;
            }
            if(w2 + w == L) {
                res += (1ll * dp2[a] * dp[b]) % MOD;
//                cout << a << " " << b << " " << (1ll * dp2[a] * dp[b]) % MOD << endl;
            }
            if(w2 + 3 * w == L && a != t && b != t && w2 + w == dist[t] && cango[a]) {
                res += (dp2[a] * dp[b]) % MOD;
//                cout << a << " " <<  (dp[a] * dp2[b]) % MOD << endl;
            }
            res %= MOD;
        }
    }
    cout << res;
}


signed main() {
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr);
    cin.tie(nullptr);
    solve();
}