#include <bits/stdc++.h>

#define all(x) (x).begin(), (x).end()
#define rep(i, a, b) for( auto i = a; i < b; i++)
#define forall(i, x) for(auto& i: x)
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) ((int)x.size())

using ll = long long;
using ld = long double;
using ull = unsigned long long;

using namespace std;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

int test = 0;

void fast() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
}

const ll N = 405;
const ll mod = 1e9 + 7;
ll h, w, dp[N][N], ans[N][N], pref[N][N], pref2[N][N], pref3[N][N], pref4[N][N];


ll add(ll a, ll b) {
    if (a + b > mod)
        return a + b - mod;
    return a + b;
}

ll dec(ll a, ll b) {
    if (a - b < 0)
        return a - b + mod;
    return a - b;
}

ll mul(ll a, ll b) {
    return a * b % mod;
}

ll fact[N];
ll rfact[N];

ll binpow(ll a, ll b) {
    if (b == 0) return 1;
    if (b & 1) return a * binpow(a, b ^ 1) % mod;
    ll t = binpow(a, b >> 1);
    return t * t % mod;
}

ll c(ll n, ll k) {
    return fact[n] * rfact[n - k] % mod * rfact[k] % mod;
}

void solve() {
    fact[0] = 1;
    rep(i, 1, N) {
        fact[i] = fact[i - 1] * i % mod;
    }
    rfact[N - 1] = binpow(fact[N - 1], mod - 2);
    for (int i = N - 2; i >= 0; i--) {
        rfact[i] = rfact[i + 1] * (i + 1) % mod;
    }

    cin >> h >> w;
    for (ll h1 = 1; h1 <= h; h1++) {
        for (ll w1 = 1; w1 <= w; w1++) {
            dp[h1][w1] = 1;
            for (ll h2 = 1; h2 <= h1 - 2; h2++) {
                ll wk = w1 - 2;
                if (wk < 1)
                    continue;
                ll count = (h1 - 1 - h2);
                ll first = mul(pref[h2][wk], dec(w1, 1));
                ll second = pref2[h2][wk];
                ll res = mul(dec(first, second), count);
                dp[h1][w1] = add(dp[h1][w1], res);

                first = mul(pref3[h2][wk], dec(w1, 1));
                second = pref4[h2][wk];
                res = mul(dec(first, second), count);
                ans[h1][w1] = add(ans[h1][w1], res);
            }

            ans[h1][w1] = add(ans[h1][w1], mul(dp[h1][w1], mul(h1, w1)));

            pref[h1][w1] = add(pref[h1][w1 - 1], dp[h1][w1]);
            pref2[h1][w1] = add(pref2[h1][w1 - 1], mul(dp[h1][w1], w1));
            pref3[h1][w1] = add(pref3[h1][w1 - 1], ans[h1][w1]);
            pref4[h1][w1] = add(pref4[h1][w1 - 1], mul(ans[h1][w1], w1));
        }
    }
    cout << ans[h][w];
}

int main() {
    fast();
    int t = 1;
    if (test) cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
