#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <string>
#include <iomanip>
#include <set>
#include <map>

using namespace std;
using ll = long long;
using ld = long double;
#define int long long
const ll inf = ll(1e18) * 2 + 36;

#define all(x) (x).begin(), (x).end()
#define fast() ios::sync_with_stdio(0); cin.tie(0)
#define rall(x) (x).rbegin(), (x).rend()

signed main() {
	fast();
	int n;
	cin >> n;
	vector<int>a(n);
	for (int i = 0; i < n; i++) cin >> a[i];
	vector<int>p(n);
	multiset<int>s;
	for (int i = 1; i < n; i++) {
		p[i] = n - i;
		if (s.size() == n / 2) continue;
		s.insert(a[i] + a[p[i]]);
	}
	auto i1 = s.begin();
	auto i2 = s.end();
	i2--;
	int ans = abs(*i1 - *i2);
	for (int i = 1; i < n; i++) {
		s.erase(s.find(a[i] + a[p[i]]));
		p[i - 1] = p[i];
		p[p[i]] = i - 1;
		s.insert(a[i - 1] + a[p[i - 1]]);
		i1 = s.begin();
		i2 = s.end();
		i2--;
		ans = min(ans, abs(*i1 - *i2));
	}
	cout << ans;
 	return 0;
}
