#include <bits/stdc++.h>

using namespace std;

#define ll long long
//#define int long long
#define pb push_back

const int N = 5005;

vector<pair<int, int>> geteven(int n, int m) {
    vector<pair<int, int>> res = {{0, 0}};
    for (int i = 1; i < n; ++i) {
        if (i & 1) {
            for (int j = 0; j < m - 1; ++j) {
                res.push_back({i, j});
            }
        } else {
            for (int j = m - 2; j >= 0; --j) {
                res.push_back({i, j});
            }
        }
    }
    for (int i = n - 1; i >= 0; --i) {
        res.push_back({i, m - 1});
    }
    for (int j = m - 2; j > 0; --j) {
        res.push_back({0, j});
    }
    return res;
}

vector<pair<int, int>> getodd(int n, int m) {
    vector<pair<int, int>> res;
    res.push_back({0, 0});
    for (int i = 1; i < n - 2; ++i) {
        if (i & 1) {
            for (int j = 0; j < m - 1; ++j) {
                res.push_back({i, j});
            }
        } else {
            for (int j = m - 2; j >= 0; --j) {
                res.push_back({i, j});
            }
        }
    }
    for (int j = 0; j < m - 1; ++j) {
        if (j & 1) {
            res.push_back({n - 1, j});
            res.push_back({n - 2, j});
        } else {
            res.push_back({n - 2, j});
            res.push_back({n - 1, j});
        }
    }
    for (int i = n - 2; i >= 0; --i) {
        res.push_back({i, m - 1});
    }
    for (int j = m - 2; j > 0; --j) {
        res.push_back({0, j});
    }
    return res;
}

int n, m, ar, ac, br, bc;
int w[N][N];

void solve() {
    cin >> n >> m >> ar >> ac >> br >> bc;
    --ar;
    --ac;
    --br;
    --bc;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> w[i][j];
        }
    }
    vector<pair<int, int>> cycle;
    if (n % 2 == 0) {
        cycle = geteven(n, m);
    } else if (m % 2 == 0) {
        cycle = geteven(m, n);
        for (int i = 0; i < (int)cycle.size(); ++i) {
            swap(cycle[i].first, cycle[i].second);
        }
    } else {
        if ((ar != n - 1 || ac != m - 1) && (br != n - 1 || bc != m - 1)) {
            cycle = getodd(n, m);
        } else if ((ar != 0 || ac != 0) && (br != 0 || bc != 0)) {
            cycle = getodd(n, m);
            for (int i = 0; i < (int)cycle.size(); ++i) {
               cycle[i].first = n - cycle[i].first - 1;
               cycle[i].second = m - cycle[i].second - 1;
            }
        } else if ((ar != n - 1 || ac != 0) && (br != n - 1 || bc != 0)) {
            cycle = getodd(n, m);
            for (int i = 0; i < (int)cycle.size(); ++i) {
                cycle[i].second = m - cycle[i].second - 1;
            }
        } else if ((ar != 0 || ac != m - 1) && (br != 0 || bc != m - 1)) {
            cycle = getodd(n, m);
            for (int i = 0; i < (int)cycle.size(); ++i) {
                cycle[i].first = m - cycle[i].first - 1;
            }
        } else {
            assert(false);
        }
    }
//    vector<vector<int>> when(n, vector<int>(m, -1));
    int sz = cycle.size();
//    for (int i = 0; i < sz; ++i) {
//        when[cycle[i].first][cycle[i].second] = i;
//    }
//    for (int i = 0; i < n; ++i) {
//        for (int j = 0; j < m; ++j) {
//            cout << when[i][j] + 1 << " ";
//        }
//        cout << endl;
//    }
    int inda = 0;
    while (cycle[inda].first != ar || cycle[inda].second != ac) {
        ++inda;
    }
    int indb = 0;
    while (cycle[indb].first != br || cycle[indb].second != bc) {
        ++indb;
    }
    if (inda > indb) {
        inda = sz - inda - 1;
        indb = sz - indb - 1;
        reverse(cycle.begin(), cycle.end());
    }
    ll sum1 = 0, sum2 = 0;
    for (int i = inda; i <= indb; ++i) {
        sum1 += w[cycle[i].first][cycle[i].second];
    }
    for (int i = 0; i <= inda; ++i) {
        sum2 += w[cycle[i].first][cycle[i].second];
    }
    for (int i = indb; i < sz; ++i) {
        sum2 += w[cycle[i].first][cycle[i].second];
    }
    vector<pair<int, int>> ans;
    if (sum1 >= sum2) {
        for (int i = inda; i <= indb; ++i) {
            ans.push_back(cycle[i]);
        }
    } else {
        for (int i = inda; i >= 0; --i) {
            ans.push_back(cycle[i]);
        }
        for (int i = sz - 1; i >= indb; --i) {
            ans.push_back(cycle[i]);
        }
    }
    string kek = "";
    for (int i = 1; i < (int)ans.size(); ++i) {
        if (ans[i].first == ans[i - 1].first + 1) {
            kek += "D";
        }
        if (ans[i].first == ans[i - 1].first - 1) {
            kek += "U";
        }
        if (ans[i].second == ans[i - 1].second + 1) {
            kek += "R";
        }
        if (ans[i].second == ans[i - 1].second - 1) {
            kek += "L";
        }
    }
    cout << kek << "\n";
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios::sync_with_stdio(false);
    cin.tie(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}