#include <bits/stdc++.h>

using namespace std;

#define int long long
#define ll long long
#define pii pair<int, int>
#define dl double
#define all(v) v.begin(), v.end()
#define sz(v) (int)v.size()

const ll inf = 1e12, mod = 1e9 + 7, maxn = 2e5 + 1;
int n, N;
vector<pii > t;
vector<int> x, p;

void build() {
    N = 1;
    while (N <= n)N *= 2;
    t.resize(2 * N, {inf, n});
    for (int i = 0; i < n; ++i) {
        t[i + N] = {p[i], i};
    }
    for (int i = N - 1; i > 0; --i) {
        t[i] = min(t[i * 2], t[i * 2 + 1]);
    }
}

pii get(int lq, int rq, int v = 1, int l = 0, int r = N) {
    if(lq == rq)return {inf, n};
    if (lq == n) return {inf, n};
    if (rq <= l || r <= lq)return {inf, n};
    if (lq <= l && r <= rq)return t[v];
    int m = (l + r) / 2;
    return min(get(lq, rq, v * 2, l, m), get(lq, rq, v * 2 + 1, m, r));
}

int find_min_r(int i) {
    if (get(i + 1, n).first > p[i])return n;
    int l = i, r = n - 1;
    while (l < r - 1) {
        int m = (l + r) / 2;
        auto [val, ind] = get(m, n);
        if (val <= p[i]) r = m;
        else l = m;
    }
    return r;
}

void solve() {
    int B, C;
    cin >> n >> B >> C;
    x.resize(n + 1), p.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> x[i] >> p[i];
    }
    x[n] = inf;
    build();
    cout << get(1, 1).second << '\n';
    int ind = 0, bought = 0, lastCity = 0;
    while (ind < n && B / p[ind] > 0) {
        int l1 = min(C, B / p[ind]), l2 = C - (bought - x[ind]), l3 = x[find_min_r(ind)] - x[ind];
        int L = min({l1, l2, l3});
        L = max(0ll, L);
        bought += L;
        B -= L * p[ind];
        int l = lastCity, r = n;
        while (l + 1 < r) {
            int s = (l + r) / 2;
            if (x[s] <= bought)l = s;
            else r = s;
        }
        lastCity = l;
        if (l3 <= l1 && l3 <= l2) {
            ind = find_min_r(ind);
        } else {
            ind = get(ind + 1, lastCity + 1).second;
        }
    }
    cout << bought << endl;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int _ = 1;
   // cin>>_;
    while (_--) {
        solve();
    //    cout << endl;
    }
}
/*
 3 10 5
0 3
1 1
4 2

 1 1000000000 10
0 3
 */