#include <bits/stdc++.h>

using namespace std;

#define int long long
#define ll long long
#define pii pair<int, int>
#define dl double
#define all(v) v.begin(), v.end()
#define sz(v) (int)v.size()

const ll inf = 1e12, mod = 1e9 + 7, maxn = 400 + 1;
int H, W;
vector<vector<int>> dp, c;

class F {
    vector<vector<int>> f;
public:
    void build(vector<vector<int>> q) {
        f.clear();
        f.resize(H + 1, vector<int>(W + 1));
        for (int i = 0; i <= H; ++i) {
            for (int j = 0; j <= W; ++j) {
                upd(i, j, q[i][j]);
            }
        }
    }

    void upd(int i, int j, int val) {
        for (int x = i; x <= H; x = ((x + 1) | x)) {
            for (int y = j; y <= W; y = ((y + 1) | y)) {
                f[x][y] += val;
                f[x][y] %= mod;
            }
        }
    }

    int get(int ri, int rj) {
        int ans = 0;
        for (int i = ri; i > 0; i = ((i + 1) & i) - 1) {
            for (int j = rj; j > 0; j = ((j + 1) & j) - 1) {
                ans += f[i][j];
                ans %= mod;
            }
        }
        return ans;
    }

    int get(int li, int lj, int ri, int rj) {
        return (get(ri, rj) - get(li - 1, lj - 1) + mod) % mod;
    }
};

void solve() {
    cin >> H >> W;
    dp.resize(H + 1, vector<int>(W + 1));
    c.resize(H + 1, vector<int>(W + 1));
    c[H][W] = 1, dp[H][W] = H * W;
    F DP, C;
    int ans = H * W;
    ans %= mod;
    DP.build(dp), C.build(c);
    for (int k = 2; k <= min(H, W); ++k) {
        dp.clear(), c.clear();
        dp.resize(H + 1, vector<int>(W + 1));
        c.resize(H + 1, vector<int>(W + 1));
        for (int i = 1; i <= H - k; ++i) {
            for (int j = 1; j <= W - k; ++j) {
                dp[i][j] += DP.get(i + 2, j + 2, H, W);
                dp[i][j] += ((C.get(i + 2, j + 2, H, W) * i) % mod * j) % mod;
                dp[i][j] %= mod;
                int endH = H - k + 2 - i + 1, endW = W - k + 2 - j + 1;
                int sh = (1 + endH) * endH / 2;
                sh %= mod;
                int sw = (1 + endW) * endW / 2;
                sw %= mod;
                c[i][j] = (sh * sw) % mod;
            }
        }
        int res = 0;
        for (int i = 1; i <= H; ++i) {
            for (int j = 1; j <= W; ++j) {
                ans += dp[i][j];
                res += dp[i][j], res%=mod;
                ans %= mod;
            }
        }
      //  cout<<res<<'\n';
        DP.build(dp), C.build(c);
    }
    cout <<ans;
}


signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int _ = 1;
    // cin>>_;
    while (_--) {
        solve();
        //    cout << endl;
    }
}
/*
 3 10 5
0 3
1 1
4 2

 1 1000000000 10
0 3
 */