#pragma GCC optimize("Ofast")

#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

const int N = 1e5 + 333;
const int L = 18;
const int INF = 2e9 + 5;

int x[N], p[N];
int ind[N];

pair<int, int> t[N][L];
int Log[N];

pair<int, int> get(int l, int r){
    assert(l <= r);
    int lg = Log[r - l + 1];
    return min(t[l][lg], t[r - (1 << lg) + 1][lg]);
}

int main() {
    ios_base::sync_with_stdio(false);

    int n, B, C;
    cin >> n >> B >> C;

    for (int i = 1; i <= n; i++){
        cin >> x[i] >> p[i];
    }

    for (int i = 2; i <= n; i++) Log[i] = Log[i / 2] + 1;

    for (int i = 1; i <= n; i++) t[i][0] = make_pair(p[i], i);

    for (int j = 1; j < L; j++) {
        for (int i = 1; i <= n; i++) {
            if (i + (1 << j) - 1 > n) continue;
            t[i][j] = min(t[i][j - 1], t[i + (1 << (j - 1))][j - 1]);
        }
    }

    vector<int> st = {n + 1};
    p[n + 1] = -INF;
    for (int i = n; i >= 1; i--){
        while (p[st.back()] > p[i]) st.pop_back();
        ind[i] = st.back();
        st.push_back(i);
    }

    int ans = 0;

    int i = 1;
    int have = 0;
    while (i <= n){
        int can_buy = min(C - have, B / p[i]);
        int d = x[i] + have + can_buy;

        ans = max(ans, d);

        int j = ind[i];
        if (j <= n && x[j] <= d){
            int mn = min(have, x[j] - x[i]);
            int cur = x[i] + mn;
            have -= mn;

            if (cur != x[j]){
                B -= (x[j] - cur) * p[i];
            }

            i = j;
        } else {
            int k = min(B / p[i], C - have);
            B -= k * p[i];
            have += k;

            int pos = upper_bound(x + 1, x + n + 1, x[i] + have) - x - 1;
            if (i == pos) break;
            j = get(i + 1, pos).second;
            have -= x[j] - x[i];
            i = j;
        }

    }

    cout << ans << endl;

    return 0;
}

/*
3 10 5
0 3
1 1
4 2

 */