#include<bits/stdc++.h>

using namespace std;

#define vt vector
#define all(s) s.begin(), s.end()
#define rall(s) s.end(), s.begin()
#define pb push_back
#define sz(s) (int)s.size()
#define nl '\n'
#define int long long
#define f first
#define s second

using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

const int inf = 1e18, N = 5e5 + 5, mod = 1e9 + 7;

vt<pii> g[N];

int n, m;

int dt(int s, int t) {
    set<pii> st;
    vt<int> d(n + 1, inf);
    d[s] = 0;
    st.insert({0, s});
    while (!st.empty()) {
        int u = (*st.begin()).s;
        st.erase(st.begin());
        for (auto [to, w]: g[u]) {
            if (d[to] > d[u] + w) {
                st.erase({d[to], to});
                d[to] = d[u] + w;
                st.insert({d[to], to});
            }
        }
    }
    return d[t];
}

signed main() {
    cin.tie(0) -> sync_with_stdio(0);
    cin >> n >> m;
    int s, t, l;
    cin >> s >> t >> l;
    while (m--) {
        int u, v, w;
        cin >> u >> v >> w;
        g[u].pb({v, w});
        g[v].pb({u, w});
    }
    int dst = dt(s, t);
    set<pii> st;
    vt<pii> d(n + 1, {inf, 0});
    d[s] = {0, 1};
    st.insert({0, s});
    while (!st.empty()) {
        int u = (*st.begin()).s;
        st.erase(st.begin());
        for (auto [to, w]: g[u]) {
            if (d[to].f > d[u].f + w) {
                st.erase({d[to].f, to});
                d[to] = {d[u].f + w, d[u].s};
                st.insert({d[to].f, to});
            }else if (d[to].f == d[u].f + w) {
                d[to].s = (d[to].s + d[u].s) % mod;
            }
        }
    }
    if (l == dst) {
        cout << d[t].s;
        return 0;
    }
    vt<pii> d2(n + 1, {inf, 0});
    d2[t] = {0, 1};
    st.insert({0, t});
    while (!st.empty()) {
        int u = (*st.begin()).s;
        st.erase(st.begin());
        for (auto [to, w]: g[u]) {
            if (d2[to].f > d2[u].f + w) {
                st.erase({d2[to].f, to});
                d2[to] = {d2[u].f + w, d2[u].s};
                st.insert({d2[to].f, to});
            }else if (d2[to].f == d2[u].f + w) {
                d2[to].s = (d2[to].s + d2[u].s) % mod;
            }
        }
    }
    cout << dst << nl;
    int ans = 0;
    for (int i = 1; i <= n; i++) {
        for (auto [to, w]: g[i]) {
            if (d[i].f + d2[to].f + w == l && d[i].f + d2[i].f == dst) {
                cout << i << ' ' << to << ' ' << d[i].f << ' ' << d2[to].f << ' ' << d[i].s << ' ' << d2[to].s << nl;
                ans = (ans + (d[i].s * d2[to].s) % mod) % mod;
            }
        }
    }
    cout << ans;
}

