#include<bits/stdc++.h>

using namespace std;

#define vt vector
#define all(s) s.begin(), s.end()
#define rall(s) s.end(), s.begin()
#define pb push_back
#define sz(s) (int)s.size()
#define nl '\n'
#define int long long
#define f first
#define s second

using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

const int inf = 1e18, N = 4e2 + 5, mod = 1e9 + 7;

vt<pii> dir = {{-1, 0}, {1, 0}, {0, -1}, {0, 1}, {-1, 1}, {-1, -1}, {1, -1}, {1, 1}};

int n, m;

bool is(int i, int j) {
    if (i < 1 || i > n) return false;
    if (j < 1 || j > m) return false;
    return true;
}

signed main() {
    cin.tie(0) -> sync_with_stdio(0);
    cin >> n >> m;
    char c[n + 1][m + 1];
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            cin >> c[i][j];
        }
    }
    int cnt[n + 1][m + 1];
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            cnt[i][j] = 0;
        }
    }
    int cnt1 = 0, cnt2 = 0;
    char c1[n + 1][m + 1];
    for (int i = 1; i <= n; i++) {
        int v = 0;
        for (int j = 1; j <= m; j++) {
            if (c[i][j] == '#') v = 1;
            cnt[i][j] += v;
        }
        v = 0;
        for (int j = m; j >= 1; j--) {
            if (c[i][j] == '#') v = 1;
            cnt[i][j] += v;
        }
    }
    for (int i = 1; i <= m; i++) {
        int v = 0;
        for (int j = 1; j <= n; j++) {
            if (c[j][i] == '#') v = 1;
            cnt[j][i] += v;
        }
        v = 0;
        for (int j = n; j >= 1; j--) {
            if (c[j][i] == '#') v = 1;
            cnt[j][i] += v;
        }
    }
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            c1[i][j] = c[i][j];
            if (c[i][j] == '.' && cnt[i][j] == 4) {
                c1[i][j] = ',';
            }
        }
    }
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            if (c1[i][j] != '#') continue;
            bool ok = 0;
            for (auto [x, y]: dir) {
                int a = i + x, b = j + y;
                if (!is(a, b)) {
                    ok = 1;
                    continue;
                }
                if (c1[a][b] == '.') ok = 1;
            }
            if (!ok) c1[i][j] = ',';
        }
    }
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            if (c1[i][j] != '#') continue;
            bool ok = 0;
            for (auto [x, y]: dir) {
                int a = i + x, b = j + y;
                if (!is(a, b)) continue;
                if (c1[a][b] == ',') ok = 1;
            }
            if (!ok) c1[i][j] = '.';
        }
    }
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            if (c1[i][j] == ',') c1[i][j] = '.';
            if (c1[i][j] == '#') cnt1++;
        }
    }
    char c2[n + 1][m + 1];
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            c2[i][j] = c[i][j];
            if (c[i][j] == '.' && cnt[i][j] == 4) {
                c2[i][j] = ',';
            }
        }
    }
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            if (c2[i][j] != '#') continue;
            bool ok = 0;
            for (auto [x, y]: dir) {
                int a = i + x, b = j + y;
                if (!is(a, b)) continue;
                if (c2[a][b] == ',') ok = 1;
            }
            if (!ok) c2[i][j] = '.';
        }
    }
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            if (c2[i][j] != '#') continue;
            bool ok = 0;
            for (auto [x, y]: dir) {
                int a = i + x, b = j + y;
                if (!is(a, b)) {
                    ok = 1;
                    continue;
                }
                if (c2[a][b] == '.') ok = 1;
            }
            if (!ok) c2[i][j] = ',';
        }
    }
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            if (c2[i][j] == ',') c2[i][j] = '.';
            if (c2[i][j] == '#') cnt2++;
        }
    }
    cout << nl;
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            if (cnt1 < cnt2) cout << c1[i][j];
            else cout << c2[i][j];
        }
        cout << nl;
    }
    return 0;
}

