#include <bits/stdc++.h>
#define int long long
#define f first
#define s second
using namespace std;
typedef long long ll;
typedef pair<long long, long long> pii;
#define ent "\n";

const int maxn = 2e5 + 100;
const int MOD = 1e9 + 7;
const int dx[] = {1, 0, -1, 0};
const int dy[] = {0, 1, 0, -1};

vector<pii> e[maxn];
vector<pii> g[maxn];
int d[2][maxn];
int dp[2][maxn];
int n, m;

void dijkstra(int v,int p){
    for(int i=1;i<=n;i++)d[p][i]=1e18,dp[p][i]=0;
    dp[p][v]=1;
    d[p][v]=0;
    set<pair<int,int>> s;
    s.insert({0,v});
    while(s.size()) {
        int x = s.begin()->s;
        s.erase(s.begin());
        for (auto to: g[x]) {
            if (d[p][x] + to.s < d[p][to.f]) {
                dp[p][to.f] = dp[p][x];
                s.erase({d[p][to.f], to.f});
                d[p][to.f] = to.s + d[p][x];
                s.insert({d[p][to.f], to.f});
            } else if (d[p][x] + to.s == d[p][to.f])dp[p][to.f] = (dp[p][to.f]+dp[p][x])%MOD;
        }
    }
}

signed main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    int s,t,k;
    cin>>n>>m>>s>>t>>k;
    while(m--){
        int a,b,c;
        cin>>a>>b>>c;
        g[a].push_back({b,c});
        g[b].push_back({a,c});
    }
    dijkstra(s,0);
    dijkstra(t,1);
    if(k==d[0][t]){
        cout<<dp[0][t]<<ent;
        return 0;
    }
    int ans=0;
    for(int i=1;i<=n;i++){
        if(d[0][i]+d[1][i]!=d[0][t] || i-t==0)continue;
        for(pii to:g[i]){
            if(d[0][i]+d[1][to.f]+to.s!=k)continue;
            ans=(ans+dp[0][i]*dp[1][to.f])%MOD;
        }
    }
    cout<<ans<<ent;
}