#include "bits/stdc++.h"
using namespace std;
//#pragma comment(linker,"/stack:200000000")
//#pragma GCC optimize("Ofast")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,tune=native")
using ll = long long;
using ld = long double;
#define pb push_back
#define ff first
#define ss second
#define sz(x) (ll)(x).size()
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
const ll MX = LLONG_MAX;
const ll MN = LLONG_MIN;
const ll inf = (ll)1e18+7;
const ll mod = (ll)1e9+7;
const ll N = (ll)3e5+5;
ll x[N], p[N], mnright[N], t[N*4];

void build(ll v, ll tl, ll tr) {
    if(tl==tr) {
        t[v] = p[tl];
        return;
    }
    ll tm = (tl+tr)/2;
    build(v*2, tl, tm);
    build(v*2+1, tm+1, tr);
    t[v] = min(t[v*2], t[v*2+1]);
}

ll get(ll v, ll tl, ll tr, ll l, ll r) {
    if(r<tl || tr<l) return MX;
    if(l<=tl && tr<=r) return t[v];
    ll tm = (tl+tr)/2;
    return min(get(v*2, tl, tm, l, r), get(v*2+1, tm+1, tr, l, r));
}

void Barca() {
    ll n, m, c;
    cin>>n>>m>>c;
    for(ll i=1; i<=n; i++) cin>>x[i]>>p[i];
    build(1, 1, n);
    for(ll i=1; i<=n; i++) {
        ll l = i, r = n, pos;
        while(l<=r) {
            ll m = l+(r-l)/2;
            if(get(1, 1, n, i, m)<=p[i]) r = m-1, pos = m;
            else l = m+1;
        }
        mnright[i] = (pos==i ? inf : pos);
    }
    ll lt = 0, ans = 0;
    for(ll i=1; i<=n; i++) {
        if(ans>x[i]) continue;
        ll cnt = min(m / p[i], c);
        if (cnt == 0) {
            cout << ans;
            return;
        }
        ll nxt = x[i] + cnt;
        if (mnright[i] <= nxt) {
            ans = mnright[i];
            m -= p[i] * (mnright[i] - x[i]);
        }
        else {
            ll l = i, r = n, pos;
            while(l<=r) {
                ll mid = l+(r-l)/2;
                if(x[mid]>nxt) r = mid-1;
                else l = mid+1, pos = mid;
            }
            if(pos==i) {
                cout<<nxt<<"\n";
                return;
            }
            ll mn = get(1, 1, n, i, pos);
            l = i, r = pos;
            while(l<=r) {
                ll mid = l+(r-l)/2;
                if(get(1, 1, n, i, mid)>mn) l = mid+1;
                else r = mid-1, pos = mid;
            }
            ans = x[pos];
            ll cnt2 = x[pos] - x[i];
            m -= cnt2 * p[i];
        }
    }
    return;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    ll tt = 1;
    //cin>>tt;
    for(ll i=1; i<=tt; i++) Barca();
}
