#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#define ll long long
#define int ll
#define ld long double
#define ins insert
#define emin(x, y) (x = min(x, y))
#define emax(x, y) (x = max(x, y))
#define ss size()
#define fi first
#define se second
#define pb push_back
#define FOR(x, y, z) for (int x = y; x <= z; x++)
#define ROF(x, y, z) for (int x = y; x >= z; x--)

using namespace std;
using namespace __gnu_pbds;

typedef tree < int, null_type, less < int >, rb_tree_tag, tree_order_statistics_node_update > ordered_set;

const ll INF = 1e18;
const int N = 5e5 + 40, T = 4 * N, inf = 1e9 + 7;

int n, m, e, l, r, id, mn = inf, mx, w;

set < pair < int, int > > S;
int d[3][N], cnt[3][N], L, st, en, us[N];
vector < int > g[N];
map < int, int > M[N];

ll f;

void calc(int i, int x)
{
    FOR (j, 1, n) d[i][j] = INF;
    d[i][x] = 0;
    cnt[i][x] = 1;
    S.clear();
    S.ins({d[i][x], x});
    while (S.ss)
    {
        auto cur = *S.begin();
        S.erase(cur);
        int v = cur.se;
        for (auto to : g[v])
        {
            if (d[i][to] > d[i][v] + M[v][to])
            {
                auto it = S.find({d[i][to], to});
                if (it != S.end()) S.erase(*it);
                d[i][to] = d[i][v] + M[v][to];
                S.ins({d[i][to], to});
                cnt[i][to] = 0;
            }
            if (d[i][to] == d[i][v] + M[v][to])
            {
                cnt[i][to] += cnt[i][v];
                cnt[i][to] %= inf;
            }
        }
    }
}

void dfs(int v)
{
    if (us[v]) return;
    us[v] = 1;
    for (auto to : g[v])
    {
        if (d[1][v] + d[2][to] + M[v][to] == L)
        {
            f += cnt[2][to];
            f %= inf;
        }
        if (d[1][to] + d[2][to] == mn)
        {
            dfs(to);
        }
    }
}

void solve()
{
    int x = 0, y = 0, z = 0;

    cin >> n >> m;
    cin >> st >> en >> L;
    FOR (i, 1, m)
    {
        cin >> x >> y >> w;
        g[x].pb(y);
        g[y].pb(x);
        M[x][y] = w;
        M[y][x] = w;
    }

    calc(1, st);
    calc(2, en);

    mn = d[1][en];
    //cout << mn << endl;
    if (mn == L)
    {
        cout << cnt[2][st];
        return;
    }

    us[en] = 1;
    dfs(st);
    cout << f;
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // LOCAL

    solve();
}
