#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#define ll long long
#define int ll
#define ins insert
#define FOR(x, y, z) for (int x = y; x <= z; x++)

using namespace std;
using namespace __gnu_pbds;

typedef tree < int, null_type, less < int >, rb_tree_tag, tree_order_statistics_node_update > ordered_set;

const int N = 5e5 + 40, T = 4 * N, inf = 1e9 + 7;

int n, m, e, l, r;

int a[N];
ordered_set S;

ll f;

int calc(int x)
{
    return x - S.order_of_key(x);
}

bool ch(int mi, int x)
{
    int cnt = calc(mi);

    return cnt <= x;
}

void solve()
{
    int x = 0, y = 0, z = 0;

    cin >> n >> m;
    FOR (i, 1, n)
    {
        cin >> a[i];
        S.ins(a[i]);
    }

    FOR (i, 1, m)
    {
        cin >> x;
        x--;

        l = 1;
        r = inf + n;

        while (l <= r)
        {
            int mi = (l + r) / 2;
            if (ch(mi, x))
            {
                f = mi;
                l = mi + 1;
            }
            else
            {
                r = mi - 1;
            }
        }

        cout << f << " ";
    }
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // LOCAL

    solve();
}
