#include <bits/stdc++.h>

#define pb push_back
#define pf push_front
#define ss second
#define ff first
#define all(v) (v).begin(), (v).end()
#define sz(a) (int)(a).size()
#define int long long

using namespace std;
using ll = long long;
using pii = pair<int, int>;
const int N = 1e5+500;
int n;
ll B, C, ans, cur_c, cur_b, x[N], p[N], t[N*5];

void build(int v = 1, int tl = 1, int tr = n){
    if(tl == tr){
        t[v] = p[tl];
        return;
    }
    int tm = tl + tr >> 1;
    build(v+v, tl, tm);
    build(v+v+1, tm+1, tr);
    t[v] = min(t[v+v], t[v+v+1]);
}

ll get(int l, int r, int v = 1, int tl = 1, int tr = n){
    if(tl > r || tr < l) return LLONG_MAX;
    if(tl >= l && tr <= r) return t[v];
    int tm = tl + tr >> 1;
    ll s1 = get(l, r, v+v, tl, tm);
    ll s2 = get(l, r, v+v+1, tm+1, tr);
    return min(s1, s2);
}

map<int, vector<int>> mp;
main(){
    ios_base::sync_with_stdio(0);
    cin >> n >> B >> C;
    for(int i = 1; i <= n; ++i){
        cin >> x[i] >> p[i];
        mp[p[i]].pb(i);
    }
    cur_b = B;
    build();
    for(int pos = 1;;){
        ans = max(ans, x[pos] + min(C, cur_c + cur_b / p[pos]));
        if(pos == n) break;
        int l = pos+1, r = n, k = -1;
        while(l <= r){
            int mid = l + r >> 1;
            if(x[mid] - x[pos] <= min(C, cur_c + cur_b / p[pos])) k = mid, l = mid + 1;
            else r = mid - 1;
        }
        if(k == -1) break;
        ans = max(ans, x[k]);
        l = pos+1, r = k;
        int pos_2 = -1;
        while(l <= r){
            int mid = l + r >> 1;
            if(get(pos+1, mid) <= p[pos]) pos_2 = mid, r = mid - 1;
            else l = mid + 1;
        }
        if(pos_2 == -1){
            ll mn = get(pos+1, k);
            k = mp[mn][sz(mp[mn]) - 1];
            ll new_c = min(C, cur_c + cur_b / p[pos]);
            cur_b -= (new_c - cur_c) * p[pos];
            cur_c = new_c - (x[k] - x[pos]);
            pos = k;
        }
        if(pos_2 != -1){
            ll cost = max(0ll, (x[pos_2] - x[pos] - cur_c) * p[pos]);
            cur_b -= cost;
            cur_c = min(C, x[pos_2] - x[pos] + cur_c);
            if(cur_c < x[pos_2] - x[pos]) break;
            cur_c -= x[pos_2] - x[pos];
            pos = pos_2;
        }
    }
    cout << ans << '\n';
}
