#include <bits/stdc++.h>

using namespace std;
using ll = long long;
const ll MOD = 1e9 + 7;

ll n, m;
vector<vector<pair<ll, ll>>> g;
vector<ll> dist, dist1;

void solve(){
    cin >> n >> m;
    ll s, t, L;
    cin >> s >> t >> L;
    s--, t--;
    g = vector<vector<pair<ll, ll>>>(n);
    dist1 = dist = vector<ll>(n, 1e17);
    for (int i = 0; i < m; i++) {
        ll u, v, w;
        cin >> u >> v >> w;
        u--, v--;
        g[u].push_back({v, w});
        g[v].push_back({u, w});
    }
    priority_queue<pair<ll, ll>> pq;
    pq.push({0, t});
    dist1[s] = dist[t] = 0;
    vector<ll> pcnt(n, 0);
    pcnt[t] = 1;
    while (pq.size()) {
        auto p = pq.top();
        ll u = p.second, d = p.first;
        d *= -1;
        pq.pop();
        if(dist[u] < d) continue;
        for(auto v : g[u]){
            if(dist[v.first] > dist[u] + v.second){
                dist[v.first] = dist[u] + v.second;
                pq.push({-dist[v.first], v.first});
                pcnt[v.first] = pcnt[u];
            } else if (dist[v.first] == dist[u] + v.second) {
                pcnt[v.first] = (pcnt[v.first] + pcnt[u]) % MOD;
            }
        }
    }
    vector<ll> pcnt1(n, 0);
    pcnt1[s]= 1;
    pq.push({0,s });
    while (pq.size()) {
        auto p = pq.top();
        ll u = p.second, d = p.first;
        d *= -1;
        pq.pop();
        if(dist1[u] < d) continue;
        for(auto v : g[u]){
            if(dist1[v.first] > dist1[u] + v.second){
                dist1[v.first] = dist1[u] + v.second;
                pq.push({-dist1[v.first], v.first});
                pcnt1[v.first] = pcnt1[u];
            }
            else if (dist1[v.first] == dist1[u] + v.second) {
                pcnt1[v.first] = (pcnt1[v.first] + pcnt1[u]) % MOD;
            }
        }
    }
    // for(int i = 0; i < n; i++) cout << pcnt1[i] << " "; cout << endl;
    // for(int i = 0; i < n; i++) cout << pcnt[i] << " "; cout << endl;
    ll cnt = 0;
    if(L == dist1[t]){
        cout << pcnt1[t] << endl;
        return;
    }
    for (int i = 0; i < n; i++) {
        if (dist1[i] + dist[i] == dist[s]) {
            for (pair<ll, ll> p : g[i]) {
                ll v = p.first;
                ll w = p.second;
                if (dist1[i] + w + dist[v] == L) cnt = (((1ll * pcnt1[i] * pcnt[p.first]) % MOD) + cnt) % MOD ;
            }
        }
    }
    cout << cnt << endl;
    //for (int x : dist) cout << x << " ";
}

int main() {
    // cout << ceil(5.2) <<endl;
    ios_base::sync_with_stdio(0);
    cin.tie(NULL), cout.tie(NULL);
    // int t; cin >> t; while (t--)
        solve();
}
