#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <iostream>
#include <cstring>
#include <cassert>
#include <chrono>
#include <random>
#include <bitset>
#include <cstdio>
#include <vector>
#include <string>
#include <stack>
#include <tuple>
#include <queue>
#include <ctime>
#include <cmath>
#include <list>
#include <map>
#include <set>
 
using namespace std;
 
#define ll long long
#define pii pair<int, int>
#define mp make_pair
 
const int N = 1e5 + 2;
const int inf = 1e9 + 7;

int n, q;
int a[N], k[N];
int pref[N];

int binary_search(int x){
   int ansi = lower_bound(pref, pref + n + 1, x) - pref - 1;
   return a[ansi] + (x - pref[ansi]);
}

void solve() {
   cin >> n >> q;
   a[0] = -1;
   for(int i = 1; i <= n; i++){
      cin >> a[i];
      pref[i] = a[i] - i + 1;
   }

   for(int i = 0; i < q; i++){
      cin >> k[i];
      cout << binary_search(k[i]) << endl;
   }
}
  
int main() {
   ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
   cout.precision(9);
   cout << fixed; 
 
   int tt = 1;
   //cin >> tt;
   while (tt--)
      solve();
 
   return 0;
} 