#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#include <deque>
#include <set>
#include <queue>
#define int long long
#define all(x) x.begin(), x.end()
#define IOS ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define pii pair<int,int>
using namespace std;
int n, m;
const int INF = 1e18;
const int mod = 1e9 + 7;
void dfs(int v, vector<vector<int>>& g, vector<int>&calc, vector<int>&vis) {
	if (vis[v]) return;
	vis[v] = 1;
	for (auto& c : g[v]) {
		dfs(c, g, calc, vis);
		calc[v] += calc[c];
		calc[v] %= mod;
	}
}
vector<int> dei(int s, int t, vector<vector<pii>>& g){
	vector<int>d(n,INF);
	d[s] = 0;
	priority_queue<pii>q;
	q.push({ -d[s],s });
	vector<int>vis(n);
	while (!q.empty()) {
		pii cur = q.top();
		q.pop();
		if (vis[cur.second]) continue;
		vis[cur.second] = 1;
		for (auto& c : g[cur.second]) {
			if (d[c.first] > d[cur.second] + c.second) {
				d[c.first] = d[cur.second] + c.second;
				q.push({ -d[c.first] , c.first });
			}
		}
	}
	return d;
	}
void dfs1(int v, vector<vector<int>>& g, vector<int>& ch, int tar, int p = -1) {
	if (v == tar) {
		ch[v] = 1;
		return;
	}
	for (auto& c : g[v]) {
		if (c!=p){
			dfs1(c, g, ch, tar, v);
			if (ch[c]) ch[v] = 1;
		}
	}
}
int32_t main()
{
	IOS;
	cin >> n >> m;
	int s, t, l;
	cin >> s >> t >> l;
	s--; 
	t--;
	vector<vector<pii>>g(n);
	struct st {
		int u, v, w;
	};
	vector<st>edge;
	for (int i = 0; i < m; i++) {
		int v, u, w;
		cin >> v >> u >> w;
		v--;
		u--;
		g[u].push_back({ v,w });
		g[v].push_back({ u,w });
		edge.push_back({ u,v,w });
	}
	vector<int>ds = dei(s, t, g);
	vector<int>dt = dei(t, s, g);
	vector<int>calcs(n);
	vector<int>calct(n);
	vector<vector<int>>bsg(n);
	{
		vector<vector<int>>sg(n);
		for (auto& c : edge) {
			if (ds[c.u] + c.w == ds[c.v]) {
				sg[c.v].push_back(c.u);
				bsg[c.u].push_back(c.v);
			}
			if (ds[c.v] + c.w == ds[c.u]) {
				sg[c.u].push_back(c.v);
				bsg[c.v].push_back(c.u);
			}
		}
		vector<int>vis(n);
		calcs[s] = 1;
		vis[s] = 1;
		for (int i = 0; i < n; i++) {
			dfs(i, sg, calcs, vis);
		}
	}
	{
		vector<vector<int>>tg(n);
		for (auto& c : edge) {
			if (dt[c.u] + c.w == dt[c.v]) {
				tg[c.v].push_back(c.u);
			}
			if (dt[c.v] + c.w == dt[c.u]) {
				tg[c.u].push_back(c.v);
			}
		}
		vector<int>vis(n);
		calct[t] = 1;
		vis[t] = 1;
		for (int i = 0; i < n; i++) {
			dfs(i, tg, calct, vis);
		}
	}
	int ans = 0;
	queue<int>q;
	vector<int>vis(n);
	q.push(s);
	vector<int>ch(n);
	dfs1(s, bsg, ch, t);
	while (!q.empty()) {
		int val = q.front();
		q.pop();
		for (auto& c : g[val]) {
			if (ds[val] + c.second + dt[c.first] == l && val!=t && c.first != t) {
				//cout << val + 1 << " " << c.first + 1 << "\n";
				ans += calcs[val] * calct[c.first];
				ans %= mod;
			}
		}
		for (auto& c : bsg[val]) {
			if (ch[c]) q.push(c);
			//q.push(c);
		}
	}
	//for (int i = 0; i < n; i++) {
	//	for (auto& c : g[i]) {
	//		int u = i;
	//		int v = c.first;
	//		int w = c.second;
	//		if (ds[u] + dt[v] + w == l && v!=t && u!=t) {
	//			ans += calcs[u] * calct[v];
	//			cerr << u + 1 << " " << v + 1 << "\n";
	//		}
	//	}
	//}
	cout << ans << "\n";
}
