#include <bits/stdc++.h>

using namespace std;

#define X first
#define Y second
#define all(a) (a).begin(), (a).end()

typedef long double ld;
typedef long long ll;
#define int ll

const int MAXN = 2e5 + 1337;

vector<pair<int, int>> g[MAXN];

const int INF = LLONG_MAX;

const int MOD = 1e9 + 7;

int32_t main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    int n, m;
    int s, t, L;
    cin >> n >> m >> s >> t >> L;
    for (int i = 0, x, y, w; i < m; ++i) {
        cin >> x >> y >> w;
        g[x].emplace_back(y, w);
        g[y].emplace_back(x, w);
    }
    auto gets = [&]() -> vector<pair<int, int>> {
        priority_queue<pair<int, int>, vector<pair<int, int>>, greater<>> q;
        vector<pair<int, int>> d(n + 1, {INF, 0});
        d[s] = {0, 1};
        // d[i] = {dist, cnt_dist}
        q.push({0, s});
        while (!q.empty()) {
            auto [curd, v] = q.top();
            q.pop();
            if (curd > d[v].X) continue;
            for (auto &[to, w] : g[v]) {
                if (to == t) continue;
                if (d[v].X + w < d[to].X) {
                    d[to] = {d[v].X + w, d[v].Y};
                    q.push({d[to].X, to});
                } else if (d[v].X + w == d[to].X) {
                    d[to].Y += d[v].Y;
                    d[to].Y %= MOD;
                }
            }
        }
        return d;
    };
    auto gett = [&]() -> vector<pair<int, int>> {
        priority_queue<pair<int, int>, vector<pair<int, int>>, greater<>> q;
        vector<pair<int, int>> d(n + 1, {INF, 0});
        d[t] = {0, 1};
        // d[i] = {dist, cnt_dist}
        q.push({0, t});
        while (!q.empty()) {
            auto [curd, v] = q.top();
            q.pop();
            if (curd > d[v].X) continue;
            for (auto &[to, w] : g[v]) {
                if (d[v].X + w < d[to].X) {
                    d[to] = {d[v].X + w, d[v].Y};
                    q.push({d[to].X, to});
                } else if (d[v].X + w == d[to].X) {
                    d[to].Y += d[v].Y;
                    d[to].Y %= MOD;
                }
            }
        }
        return d;
    };
    auto ds = gets();
    auto dt = gett();
    int ans = 0;
    int mn = dt[s].X;
    if (mn == L) {
        ans += dt[s].Y;
        ans %= MOD;
    }
    for (int i = 1; i <= n; ++i) {
        for (auto &[to, w] : g[i]) {
            if (i > to) continue;
            if (ds[i].X + w + dt[to].X == L && ds[i].X + w + dt[to].X != mn) {
                ans += ds[i].Y * dt[to].Y;
                ans %= MOD;
            }
        }
    }
    cout << ans;
}