#include <bits/stdc++.h>

using namespace std;

#define X first
#define Y second
#define all(a) (a).begin(), (a).end()

typedef long double ld;
typedef long long ll;
#define int ll

const int MAXN = 2e5 + 1337;

vector<pair<int, int>> g[MAXN];

const int INF = LLONG_MAX / 10;

const int MOD = 1e9 + 7;

int n, m;
int s, t, L;

vector<int> rg[MAXN], rev[MAXN];

vector<int> usd(MAXN, -1);

vector<int> ord;
vector<pair<int, int>> ds, dt;

int mn;

void dfs(int v) {
    usd[v] = true;
    for (auto &to : rg[v]) {
        if (!usd[to]) {
            dfs(to);
        }
    }
    ord.push_back(v);
}

void update(int start, vector<pair<int, int>> &d) {
    usd.assign(MAXN, false);
    ord.clear();
    for (int i = 1; i <= n; ++i) {
        rg[i].clear();
        rev[i].clear();
    }
    for (int i = 1; i <= n; ++i) {
        for (auto &[to, w] : g[i]) {
            if (d[i].X + w == d[to].X) {
                if (start == s && ds[i].X + w + dt[to].X == mn || start == t) {
                    rg[i].push_back(to);
//                    cerr << i << ' ' << to << ' ' << ds[i].X << ' ' << dt[to].X << ' ' << w << ' ' << mn << endl;
                    rev[to].push_back(i);
                }
            }
        }
    }
    dfs(start);
    reverse(all(ord));
    vector<int> cnt(n + 1, 0);
    cnt[start] = 1;
    for (auto v : ord) {
        for (auto &to : rev[v]) {
            cnt[v] += cnt[to];
            cnt[v] %= MOD;
        }
    }
    for (int i = 1; i <= n; ++i) {
        d[i].Y = cnt[i];
    }
}

int32_t main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    cin >> n >> m >> s >> t >> L;
    for (int i = 0, x, y, w; i < m; ++i) {
        cin >> x >> y >> w;
        g[x].emplace_back(y, w);
        g[y].emplace_back(x, w);
    }
    auto gets = [&]() -> vector<pair<int, int>> {
        priority_queue<pair<int, int>, vector<pair<int, int>>, greater<>> q;
        vector<pair<int, int>> d(n + 1, {INF, -1});
        d[s] = {0, 1};
        // d[i] = {dist, cnt_dist}
        q.push({0, s});
        while (!q.empty()) {
            auto [curd, v] = q.top();
            q.pop();
            if (curd > d[v].X) continue;
            for (auto &[to, w] : g[v]) {
                if (to == t) continue;
                if (d[v].X + w < d[to].X) {
                    d[to] = {d[v].X + w, -1};
                    q.push({d[to].X, to});
                }
            }
        }
        return d;
    };
    auto gett = [&]() -> vector<pair<int, int>> {
        priority_queue<pair<int, int>, vector<pair<int, int>>, greater<>> q;
        vector<pair<int, int>> d(n + 1, {INF, -1});
        d[t] = {0, 1};
        // d[i] = {dist, cnt_dist}
        q.push({0, t});
        while (!q.empty()) {
            auto [curd, v] = q.top();
            q.pop();
            if (curd > d[v].X) continue;
            for (auto &[to, w] : g[v]) {
                if (d[v].X + w < d[to].X) {
                    d[to] = {d[v].X + w, -1};
                    q.push({d[to].X, to});
                }
            }
        }
        return d;
    };
    ds = gets();
    dt = gett();
    mn = dt[s].X;
    update(s, ds);
    update(t, dt);
    int ans = 0;
    if (mn == L) {
        ans += dt[s].Y;
        ans %= MOD;
        cout << ans;
        return 0;
    }
    for (int i = 1; i <= n; ++i) {
        for (auto &[to, w] : g[i]) {
            if (ds[i].Y == -1 || dt[to].Y == -1) continue;
            if (ds[i].X + w + dt[to].X == L) {
                ans += ds[i].Y * dt[to].Y;
                ans %= MOD;
//                cerr << i << ' ' << to << endl;
            }
        }
    }
    cout << ans;
}

