#include <bits/stdc++.h>

#define ve vector
#define endl '\n'
#define all(x) x.begin(),x.end()
#define int int64_t
#define ins insert
#define pii pair<int, int>
#define PB push_back
#define F first
#define S second

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<ll,ll> pll;

const ll INF=1e18+2;
const ll N=2e5+12;
const ll mod=1e9+7;

ve<pll> gr[N];
tuple<ll,ll,ll> ed[N];
ll dist[2][N],dp[2][N];
char used[N];
ve<ll> v[2];
ll n;

void calc_dist(ll k, ll st)
{
    priority_queue<pll> pq;
    fill(dist[k],dist[k]+n,INF);
    fill(used,used+n,0);
    pq.push({0,st});
    dist[k][st]=0;

    while(!pq.empty())
    {
        ll x=pq.top().S;
        pq.pop();

        if(used[x]) continue;
        used[x]=1;
        v[k].PB(x);

        for(pll i:gr[x])
        {
            if(dist[k][i.F]>dist[k][x]+i.S)
            {
                dist[k][i.F]=dist[k][x]+i.S;
                pq.push({-dist[k][i.F],i.F});
            }
        }
    }
}

void calc_dp(ll k, ll st)
{
    dp[k][st]=1;

    for(ll x:v[k])
    {
        for(pll i:gr[x])
        {
            if(dist[k][i.F]==dist[k][x]+i.S)
            {
                dp[k][i.F]+=dp[k][x];
                dp[k][i.F]%=mod;
            }
        }
    }
}

void solve()
{
    ll m,s,t,l;
    cin>>n>>m>>s>>t>>l;
    s--, t--;

    for(ll i=0;i<m;i++)
    {
        ll a,b,w;
        cin>>a>>b>>w;
        a--, b--;
        gr[a].PB({b,w});
        gr[b].PB({a,w});
        ed[i]={a,b,w};
    }

    calc_dist(0,s);
    calc_dist(1,t);
    calc_dp(0,s);
    calc_dp(1,t);

    if(dist[0][t]==l)
    {
        cout<<dp[0][t];
        return;
    }

    ll ans=0;

    for(ll i=0;i<m;i++)
    {
        ll a,b,w;
        tie(a,b,w)=ed[i];

        if(dist[0][a]+w+dist[1][b]==l&&dist[0][a]+dist[1][a]==dist[0][t]&& dist[0][b]+dist[1][b]!=dist[0][t])
        {
            ans+=dp[0][a]*dp[1][b];
            ans%=mod;
        }

        swap(a,b);

        if(dist[0][a]+w+dist[1][b]==l&&dist[0][a]+dist[1][a]==dist[0][t] && dist[0][b]+dist[1][b]!=dist[0][t])
        {
            ans+=dp[0][a]*dp[1][b];
            ans%=mod;
        }
    }

    cout<<ans;
}

int32_t main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    solve();
    return 0;
}
