#include <bits/stdc++.h>
#define fi first
#define se second
#define pii pair<int,int>
#define pll pair<long long,long long>
#define mpp make_pair
#define ve vector
#define pb push_back
#define sz(x)       (int)((x).size())
#define all(x)      (x).begin(),(x).end()
#define ll long long
const ll inf = 1e18;
const int iinf = 1e9;
using namespace std;
template<typename T> inline bool chmin(T& a, T b) { return (a > b ? a = b, 1 : 0); }

const pii di[8] = {{-1, 0}, {0, 1}, {1, 0}, {0, -1}, {1, 1}, {1, -1}, {-1, 1}, {-1, -1}};
const pii di1[4] = {{-1, 0}, {0, 1}, {1, 0}, {0, -1}};

map<int,int> to = {{1, 0}, {3, 1}, {0, 2}, {4, 3}, {2, iinf}};

inline void solve() {
    int n, m;
    cin >> n >> m;
    ve<ve<char>> a(n, ve<char> (m));
    for (auto &i : a) for (auto &j : i) cin >> j;
    auto valid = [&](int x, int y) { return x >= 0 && x < n && y >= 0 && y < m; };

    queue<pii> q;
    ve<ve<int>> used(n, ve<int> (m));
    ve<ve<int>> C(n, ve<int> (m));

    pair<int,ve<pii>> ans = mpp(iinf, ve<pii>(0));

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (used[i][j] || a[i][j] == '#') continue;

            bool fl = 1;

            ve<pii> bl;
            used[i][j] = 1;
            q.push({i, j});

            while (sz(q)) {
                auto [x, y] = q.front(); q.pop();
                for (auto &[dx, dy] : di) {
                    int xx = x + dx, yy = y + dy;
                    if (!valid(xx, yy)) {
                        fl = 0;
                        break;
                    }

                    if (a[xx][yy] == '#') {
                        bl.pb({xx, yy});
                        used[xx][yy] = 0;
                    }
                    else if (!used[xx][yy]) {
                        used[xx][yy] = 1;
                        q.push({xx, yy});
                    }
                }
            }
/*
6 7
#######
#.#.#.#
#.....#
#.....#
#.#.#.#
#######
*/
            sort(all(bl));
            bl.erase(unique(all(bl)), bl.end());

            if (!fl) continue;
            if (!sz(bl)) continue;

            int x = bl[0].fi, y = bl[0].se;
            for (int i = 1; i < n; ++i) {
                if (bl[i].se < y || (bl[i].se == y && bl[i].fi < x)) {
                    x = bl[i].fi;
                    y = bl[i].se;
                }
            }

            set<pii> al(all(bl));
            set<pair<int,pii>> st;
            for (auto [x, y] : bl) {
                int cnt = 0;
                for (auto [dx, dy] : di1) {
                    int xx = x + dx, yy = y + dy;
                    if (!valid(xx, yy) || !al.count({xx, yy})) continue;
                    ++cnt;
                }
                st.insert({to[cnt], {x, y}});
                C[x][y] = cnt;
            }

//            for (auto [C, _] : st) {
//                cout << C << " " << _.fi << " " << _.se << '\n';
//            }
//            cout << endl;

            while (1) {
                auto [c, _] = *st.begin();
                if (c == iinf) break;

                auto [x, y] = _;
                st.erase(st.begin());

                if (!C[x][y]) continue;

                for (auto [dx, dy] : di1) {
                    int xx = x + dx, yy = y + dy;
                    if (valid(xx, yy) && a[xx][yy] == '#') {
                        st.erase(mpp(to[C[xx][yy]], mpp(xx, yy)));
                        --C[xx][yy];
                        if (!C[xx][yy]) break;
                        st.insert(mpp(to[C[xx][yy]], mpp(xx, yy)));
                    }
                }
            }

            ve<pii> cur;
            for (auto &[_, __] : st) {
                cur.pb(__);
            }
//
            pair<int,ve<pii>> c = mpp(sz(cur), cur);
            chmin(ans, c);
        }
    }

    for (int i = 0; i + 2 < n; ++i) {
        for (int j = 0; j + 2 < m; ++j) {
            bool fl = 1;
            for (int x = i; x <= i + 2; ++x) {
                for (int y = j; y <= j + 2; ++y) {
                    fl &= (a[x][y] == '#');
                }
            }
            if (fl) {
                ve<pii> hui;
                hui.pb({i, j});
                hui.pb({i, j + 1});
                hui.pb({i, j + 2});
                hui.pb({i + 1, j + 2});
                hui.pb({i + 2, j + 2});
                hui.pb({i + 2, j + 1});
                hui.pb({i + 2, j});
                hui.pb({i + 1, j});
                chmin(ans, mpp(sz(hui), hui));
            }
        }
    }

    ve<ve<char>> f(n, ve<char> (m, '.'));
    for (auto &[x, y] : ans.se) f[x][y] = '#';

    for (auto &i : f) {
        for (auto &j : i) cout << j;
        cout << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    int q = 1; // cin >> q;
    while (q--) solve();
}
