#include <bits/stdc++.h>
#define fi first
#define se second
#define pii pair<int,int>
#define pll pair<long long,long long>
#define mpp make_pair
#define ve vector
#define pb push_back
#define sz(x)       (int)((x).size())
#define all(x)      (x).begin(),(x).end()
#define ll long long
const ll inf = 1e18;
using namespace std;
template<typename T> inline bool chmin(T& a, T b) { return (a > b ? a = b, 1 : 0); }

constexpr int md = 1e9 + 7;
inline int add(int a, int b) { a += b; if (a >= md) a -= md; return a; }
inline int sub(int a, int b) { a -= b; if (a < 0) a += md; return a; }
inline int mul(int a, int b) { return a * 1ll * b % md; }

struct fenw {
    int n, m;
    ve<ve<int>> f;
    fenw(int N, int M) : n(N + 10), m(M + 10) {
        f.resize(n, ve<int> (m));
    };
    inline void upd(int i, int j, int d) {
        for (int x = i + 2; x < n; x += x & -x) {
            for (int y = j + 2; y < m; y += y & -y) {
                f[x][y] = add(f[x][y], d);
            }
        }
    }
    inline int get(int i, int j) {
        int ans = 0;
        for (int x = i + 2; x; x -= x & -x) {
            for (int y = j + 2; y; y -= y & -y) {
                ans = add(ans, f[x][y]);
            }
        }
        return ans;
    }
    inline g(int i, int j) {
        int answer = get(i, j);
        answer = sub(answer, get(i - 1, j));
        answer = sub(answer, get(i, j - 1));
        answer = add(answer, get(i - 1, j - 1));
        return answer;
    }
};

inline void solve() {
    int n, m;
    cin >> n >> m;

    fenw dp(n, m);
    fenw idp(n, m);
    fenw jdp(n, m);
    fenw ijdp(n, m);

    fenw cnt(n, m);
    fenw icnt(n, m);
    fenw jcnt(n, m);
    fenw ijcnt(n, m);

    auto st = [&](int i, int j, int dpv, int cntv) {
        dp.upd(i, j, dpv);
        idp.upd(i, j, mul( i, dpv ));
        jdp.upd(i, j, mul( j, dpv ));
        ijdp.upd(i, j, mul( mul(i, j), dpv ));

        cnt.upd(i, j, cntv);
        icnt.upd(i, j, mul(i, cntv));
        jcnt.upd(i, j, mul(j, cntv));
        ijcnt.upd(i, j, mul(mul(i, j), cntv));
    };

    for (int x = 1; x <= n; ++x) st(x, 1, x, 1);
    for (int y = 2; y <= m; ++y) st(1, y, y, 1);

    for (int x = 1; x <= n; ++x) {
        for (int y = 1; y <= m; ++y) {
            if (x == 1 || y == 1) continue;

            /**
            dp[x][y] = add(dp[x][y], mul(mul(x - i - 1, y - j - 1), dp[i][j]));
            dp[x][y] = add(dp[x][y], mul(mul(x, y), mul(mul(x - i - 1, y - j - 1), cnt[i][j])));
            cnt[x][y] = add(cnt[x][y], mul(mul(x - i - 1, y - j - 1), cnt[i][j]));
            */

            int val = 0;
            int X = x - 1, Y = y - 1;

            val = add(val, mul(mul(X, Y), dp.get(x - 2, y - 2)) );
            val = sub(val, mul(X, jdp.get(x - 2, y - 2)));
            val = sub(val, mul(Y, idp.get(x - 2, y - 2)));
            val = add(val, ijdp.get(x - 2, y - 2));

            int cval = 0;
            cval = add(cval, mul(mul(X, Y), cnt.get(x - 2, y - 2)) );
            cval = sub(cval, mul(X, jcnt.get(x - 2, y - 2)));
            cval = sub(cval, mul(Y, icnt.get(x - 2, y - 2)));
            cval = add(cval, ijcnt.get(x - 2, y - 2));

            val = add(val, mul(mul(x, y), cval));

            val = add(val, mul(x, y));
            cval = add(cval, 1);

            st(x, y, val, cval);
        }
    }

    /**
    ve<ve<int>> dp(n + 1, ve<int> (m + 1));
    ve<ve<int>> cnt(n + 1, ve<int> (m + 1));
    for (int i = 1; i <= n; ++i) dp[i][1] = i, cnt[i][1] = 1;
    for (int i = 2; i <= m; ++i) dp[1][i] = i, cnt[1][i] = 1;

    for (int x = 1; x <= n; ++x) {
        for (int y = 1; y <= m; ++y) {
            if (x == 1 || y == 1) continue;

            dp[x][y] = x * y;
            cnt[x][y] = 1;

            for (int i = 1; i <= x - 2; ++i) {
                for (int j = 1; j <= y - 2; ++j) {
                    dp[x][y] = add(dp[x][y], mul(mul(x - i - 1, y - j - 1), dp[i][j]));
                    dp[x][y] = add(dp[x][y], mul(mul(x, y), mul(mul(x - i - 1, y - j - 1), cnt[i][j])));
                    cnt[x][y] = add(cnt[x][y], mul(mul(x - i - 1, y - j - 1), cnt[i][j]));
                }
            }
        }
    }

    for (int i = 1; i <= n; ++i) {
        for (int j = 1; j <= m; ++j) {
            cout << "(" << i << " * " << j << "): " << dp[i][j] << " " << cnt[i][j] << '\n';
        }
    }
*/
    cout << dp.g(n, m);
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    int q = 1; // cin >> q;
    while (q--) solve();
}
