#define pii pair < int, int >
#include <bits/stdc++.h>
#define pb push_back
#define ll long long
#define _ << ' ' <<
#define S second
#define F first
#define int ll

using namespace std;

bool fl1[300001], fl2[300001];
vector < pii > g[300001];
int k1[300001], k2[300001];
int rast1[300001], rast2[300001];

bool fl3[300001];

void DFS3(int v)
{
    for (auto to: g[v])
        if (rast1[to.F] + to.S == rast1[v] && fl3[to.F] == 0)
        {
            fl3[to.F] = 1;
            DFS3(to.F);
        }
}

int32_t main() {
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // LOCAL

    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    int n, m, s, t, L;
    cin >> n >> m >> s >> t >> L;
    s--;t--;
    for (int i = 0; i < m; i++)
    {
        int x, y, w;
        cin >> x >> y >> w;
        x--;y--;
        g[x].pb({y, w});
        g[y].pb({x, w});
    }
    priority_queue < pii > q;
    for (int i = 0; i < n; i++)
    {
        rast1[i] = 1e18;
        rast2[i] = 1e18;
    }
    rast1[s] = 0;
    q.push({0, s});
    while (!q.empty())
    {
        pii p = q.top();
        q.pop();
        if (rast1[p.S] < -p.F) continue;
        int v = p.S;
        for (auto to: g[v])
        {
            if (rast1[to.F] > rast1[v] + to.S)
            {
                rast1[to.F] = rast1[v] + to.S;
                q.push({-rast1[to.F], to.F});
            }
        }
    }
    rast2[t] = 0;
    q.push({0, t});
    while (!q.empty())
    {
        pii p = q.top();
        q.pop();
        if (rast2[p.S] < -p.F) continue;
        int v = p.S;
        for (auto to: g[v])
        {
            if (rast2[to.F] > rast2[v] + to.S)
            {
                rast2[to.F] = rast2[v] + to.S;
                q.push({-rast2[to.F], to.F});
            }
        }
    }
    vector < pii > V1, V2;
    for (int i = 0; i < n; i++)
        V1.pb({rast1[i], i});
    k1[s] = 1;
    k2[t] = 1;
    for (int i = 0; i < n; i++)
        V2.pb({rast2[i], i});
    sort(V1.begin(), V1.end());
    for (int i = 1; i < V1.size(); i++)
        for (auto to: g[V1[i].S])
            if (rast1[to.F] + to.S == rast1[V1[i].S]) k1[V1[i].S] = (k1[V1[i].S] + k1[to.F]) % 1000000007;
    sort(V2.begin(), V2.end());
    for (int i = 1; i < V2.size(); i++)
        for (auto to: g[V2[i].S])
            if (rast2[to.F] + to.S == rast2[V2[i].S]) k2[V2[i].S] = (k2[V2[i].S] + k2[to.F]) % 1000000007;
    /**
    for (int i = 0; i < n; i++)
        cout << k1[i] << ' ';
    cout << endl;
    for (int i = 0; i < n; i++)
        cout << k2[i] << ' ';
    cout << endl;
    **/
    fl1[s] = 1;
    fl2[t] = 1;
    if (L == rast1[t])
    {
        cout << k2[s];
        return 0;
    }
    DFS3(t);
    int ans = 0;
    for (int i = 0; i < n; i++)
    {
        if (fl3[i] == 0) continue;
        for (auto to: g[i])
            if (rast1[i] + to.S + rast2[to.F] == L)
            {
                ///cout << i << ' ' << to.F << ' ' << k1[i] * k2[to.F] << endl;
                ans = (ans + k1[i] * k2[to.F]) % 1000000007;
            }
    }
    cout << ans;
    return 0;
}
