#include <iostream>
#include <cmath>
#include <vector>
#include <set>
#include <algorithm>
#include<map>
using namespace std;
typedef long long ll;
void solve(){
    ll n, b, c;
    cin >> n >> b >> c;
    vector<pair<ll, ll>> nums(n);
    for(int i = 0; i < n; i++)
        cin >> nums[i].first >> nums[i].second;
    ll cur = 0, pos = 0, pos2 = 0;
    multiset<pair<ll, ll>> temp;
    for(int i = 0; i < n; i++){
        while(pos2 <= i){
            auto it = temp.find(make_pair(nums[pos2].second, nums[pos2].first));
            if(it != temp.end())
                temp.erase(it);
            pos2++;
        }
        pos = max(pos2, pos);
        while(pos < n && nums[pos].first - nums[i].first <= min(c, b / nums[i].second + cur)){
            temp.insert(make_pair(nums[pos].second, nums[pos].first));
            pos++;
        }
        if(temp.empty()){
            cout << nums[i].first + min(c, b / nums[i].second + cur);
            return;
        }
        pair<ll, ll> best = *temp.begin();
        if(best.first <= nums[i].second){
            for(int j = i; j < n; j++){
                if(nums[j].second <= nums[i].second && i != j){
                    i = j;
                    break;
                }
                ll dst = nums[j + 1].first - nums[j].first;
                if(dst <= cur)
                    cur -= dst;
                else {
                    b -= (dst - cur) * nums[i].second;
                    cur = 0;
                }
            }
        }
        else{
            best = *(--temp.lower_bound(make_pair(best.first + 1, INT_MIN)));
            ll need = min(c - cur, b / nums[i].second);
            b -= need * nums[i].second;
            cur += need;
            cur -= best.second - nums[i].first;
            while(i < n && nums[i].first < best.second)
                i++;
        }
        i--;
    }
}
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    ll t = 1;
    //cin >> t;
    while(t--)
        solve();
    return 0;
}