#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ld = long double;
#define int ll

int n;
vector<int> a,p;

struct segt {
    vector<int> t;
    int sz;
    int _0 = 1e9;

    int op(int i, int j) {
        if(i >= n) return j;
        if(j >= n) return i;
        if(p[i] < p[j]) return i;
        if(p[i] == p[j]) return min(i,j);
        return j;
    }

    segt(int n) {
        sz = 1; while(sz < n) sz<<=1;
        t.resize(sz*2-1);
    }

    void bld(int x, int lx, int rx) {
        if(rx-lx == 1) {
            t[x] = lx;
            return;
        }

        int m = (rx+lx)/2;
        bld(x*2+1,lx,m);
        bld(x*2+2,m,rx);
        t[x] = op(t[x*2+1], t[x*2+2]);
        return;
    }

    int get(int l, int r, int x, int lx, int rx) {
        if (lx >= l && rx <= r) return t[x];
        if (lx >= r || rx <= l) return _0;

        int m = (rx + lx) / 2;
        return op(get(l, r, x * 2 + 1, lx, m), get(l, r, x * 2 + 2, m, rx));
    }
};

void solve() {

    int b,c; cin >> n >> b >> c;
    a.resize(n), p.resize(n); for(int i = 0; i < n; ++i) cin >> a[i] >> p[i];
    segt t(n); t.bld(0,0,t.sz);

    int now = 0;
    for(int i = 0; i < n;) {
        int last = upper_bound(a.begin(),a.end(), a[i]+c)-a.begin()-1;

        int l = i, r = n;
        while(r-l > 1) {
            int m = (r+l)/2;

            if((a[m]-a[i]-now)*p[i] > b)
                r = m;
            else
                l = m;
        }
        last = l;
        int mni = t.get(i+1, last+1,0,0,t.sz);

        if(last == i) {
            now += b/p[i];
            cout << a[i] + now << '\n';
            return;
        }

        int cnt = (a[mni]-a[i]);
        if(p[mni] > p[i]) {
            cnt = c - now;
        }
        now += cnt;

        b-=cnt*p[i];
        now-=(a[mni]-a[i]);
        i = mni;
    }

    return;
}

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0);
#ifdef ischv
    freopen("../.in", "r", stdin);
    freopen("../.out", "w", stdout);
#endif

    solve();
}