#include <iostream>
#include <vector>
#include <set>
#include <string>
#include <algorithm>
#include <random>
#define all(a) a.begin(), a.end()

using namespace std;

typedef vector<int> vi;
typedef long long ll;
typedef vector<long long> vll;
typedef pair<int, int> pii;

//#define int long long 

const ll INF = 1e18;

ll f(const vll& v, int n) {
	vector<vll> dp(n, vll(2));
	for (int i = 0; i < n / 2; ++i) {
		dp[i][0] = v[i] + v[n - i - 1];
		dp[i][1] = v[i] + v[n - i - 2];
	}
	vector<pair<ll, ll>> p0(n);
	vector<pair<ll, ll>> p1(n);
	p0[0] = { dp[0][0], dp[0][0] };
	p1[n/2-1] = { dp[n/2-1][1], dp[n/2-1][1] };
	for (int i = 1; i < n / 2; ++i) {
		p0[i].first = min(p0[i - 1].first, dp[i][0]);
		p0[i].second = max(p0[i - 1].second, dp[i][0]);
	}
	for (int i = n / 2 - 2; i >= 0; --i) {
		p1[i].first = min(p1[i + 1].first, dp[i][1]);
		p1[i].second = max(p1[i + 1].second, dp[i][1]);
	}
	ll res = p1[0].second - p1[0].first;
	for (int i = 0; i < n / 2 - 1; ++i) {
		ll mx = max(p0[i].second, p1[i + 1].second);
		ll mn = min(p0[i].first, p1[i + 1].first);
		res = min(res, mx - mn);
	}
	return res;
}

void solve() {
	int n; cin >> n;
	vll v(n);
	for (int i = 0; i < n; ++i)
		cin >> v[i];
	ll mn = f(v, n);
	reverse(v.begin(), v.end());
	mn = min(mn, f(v, n));
	cout << mn;
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
	}
}
