#include <bits/stdc++.h>

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define int long long

using namespace std;

typedef long long ll;
typedef long double ld;

const int INF = 1e9 + 7;
const ld EPS = 1e-9;

void get_ans(vector<pair<int, int>> &w) {
    for (int i = 1; i < (int)w.size(); ++i) {
        if (w[i].second == w[i - 1].second) {
            if (w[i].first - 1 == w[i - 1].first)
                cout << 'D';
            else
                cout << 'U';
        }
        else {
            if (w[i].second - 1 == w[i - 1].second)
                cout << 'R';
            else
                cout << 'L';
        }
    }
    cout << '\n';
}

void solve() {
    int n, m;
    pair<int, int> a, b;
    cin >> n >> m >> a.first >> a.second >> b.first >> b.second;
    a.first--; a.second--; b.first--; b.second--;
    vector<pair<int, int>> way;
    if ((n & 1) && (m & 1)) {
        bool sw1 = false, sw2 = false;
        if (a != (pair<int, int>) {0, 0} && b != (pair<int, int>) {0, 0}) {}
        else if (a != (pair<int, int>) {n - 1, 0} && b != (pair<int, int>) {n - 1, 0})
            sw1 = true;
        else if (a != (pair<int, int>) {0, m - 1} && b != (pair<int, int>) {0, m - 1}) sw2 = true;
        way.reserve(n * m - 1);
        for (int i = n - 1; i > 1; i--) {
            if (i & 1) {
                for (int j = 0; j < m - 1; j++) way.emplace_back(i, j);
            } else {
                for (int j = m - 2; j > -1; j--) way.emplace_back(i, j);
            }
        }
        way.emplace_back(1, 0);
        for (int j = 1; j < m - 1; j++) {
            if (j & 1) {
                way.emplace_back(1, j);
                way.emplace_back(0, j);
            } else {
                way.emplace_back(0, j);
                way.emplace_back(1, j);
            }
        }
        for (int i = 0; i < n; i++) way.emplace_back(i, m - 1);
        if (sw1) {
            for (auto &i : way) i.first = n - i.first - 1;
        }
        if (sw2) {
            for (auto &i : way) i.second = m - i.second - 1;
        }
    } else {
        bool sw = false;
        if (n & 1) {
            sw = true;
            swap(n, m);
        }
        for (int i = n - 1; i > -1; i--) {
            if (i & 1) {
                for (int j = m - 2; j > -1; j--) way.emplace_back(i, j);

            } else {
                for (int j = 0; j < m - 1; j++) way.emplace_back(i, j);

            }
        }
        for (int i = 0; i < n; i++) way.emplace_back(i, m - 1);
        if (sw) {
            for (auto &i : way) swap(i.first, i.second);
            swap(n, m);
        }
    }
    vector<vector<int>> w(n, vector<int>(m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j)
            cin >> w[i][j];
    }
    int p1, p2;
    for (int i = 0; i < (int)way.size(); ++i) {
        if (way[i] == a)
            p1 = i;
        if (way[i] == b)
            p2 = i;
    }
    if (p1 > p2) {
        reverse(all(way));
        p1 = (int)way.size() - p1 - 1;
        p2 = (int)way.size() - p2 - 1;
    }
    int w1 = 0, w2 = 0;
    for (int i = p1; i <= p2; ++i)
        w1 += w[way[i].first][way[i].second];
    for (int i = p1; i >= 0; --i)
        w2 += w[way[i].first][way[i].second];
    for (int i = (int)way.size() - 1; i >= p2; --i)
        w2 += w[way[i].first][way[i].second];
    vector<pair<int, int>> res;
    if (w1 >= w2) {
        for (int i = p1; i <= p2; ++i)
            res.push_back(way[i]);
    }
    else {
        for (int i = p1; i >= 0; --i)
            res.push_back(way[i]);
        for (int i = (int)way.size() - 1; i >= p2; --i)
            res.push_back(way[i]);
    }
    get_ans(res);
}

signed main() {
    ios::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
    int t;
    cin >> t;
    while (t--)
        solve();
}

