#pragma GCC optimize("O3")
#pragma GCC target("avx2,bmi,bmi2")
#include <iostream>
#include <algorithm>
#include <numeric>
#include <cmath>
#include <set>
#include <vector>
#include <queue>
#include <array>
#include <chrono>
#define int uint64_t
#define int64_t uint64_t

constexpr int mod = 1e9 + 7;

int mul(int a, int b) {
	return a * 1ULL * b % mod;
}
int add(int a, int b) {
	return a + b - mod * (a + b >= mod);
}

constexpr int N = 402;
using namespace std;
//typedef int64_t ll;
//const ll MOD = 1e9 + 7;*/

int dp[2][N][N];

int prf[2][N + 1][N + 1];
int prf_i[2][N + 1][N + 1];
auto& cnt = dp[1];
//int prf_i[N][N];

signed main() {
	cin.tie(0)->sync_with_stdio(0);
	int n, m; cin >> n >> m;
	//vector<vector<int>> dp(n + 1, vector<int>(m + 1, 0));

	auto fuck = [&](int i, int j) {
		for (int k = 0; k < 2; k++) {
			prf[k][i][j] = prf[k][i][j - 1] + dp[k][i][j];
			prf_i[k][i][j] = prf_i[k][i][j - 1] + mul(dp[k][i][j], i);
		}
	};

	for (int i = 1; i < N; ++i) {
		for (int j = i; j < N; ++j) {
			if (i < 100 && j < 200) {
				//continue;
			}
			int64_t cur_ans = 0;
			int64_t cur_cnt = 1;

			for (int ni = 1; ni + 2 <= i; ++ni) {
				int64_t c1 = 0, c2 = 0;
				for (int nj = 1; nj + 2 <= j; ++nj) {
					//curans += ((((ll)(dp[ni][nj] + i * j) * (i - ni - 1)) % MOD) * (j - nj - 1) % MOD);
					//curans %= MOD;
					c1 += cnt[ni][nj] * 1ULL * (j - nj - 1);
					c2 += dp[0][ni][nj] * 1ULL * (j - nj - 1);
				}

				c1 *= (i - ni - 1);
				c2 *= (i - ni - 1);
				cur_ans += c2;
				cur_cnt += c1; 

				cur_ans %= mod;
				cur_cnt %= mod;
			}
			cur_ans = add(cur_ans, mul(cur_cnt, i * j));
			cnt[i][j] = cur_cnt;
			dp[0][i][j] = cur_ans;
			dp[0][j][i] = dp[0][i][j];
			cnt[j][i] = cnt[i][j];
		}
	}
	cout << dp[0][n][m] << "\n";
	//cerr << clock() * 1.0 / CLOCKS_PER_SEC << std::endl;

	return 0;
}
