#include <iostream>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <numeric>
#include <random>
#include <ctime>
#include <cassert>
#include <chrono>
#include <vector>
#include <string>
#include <deque>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <bitset>
using namespace std;
mt19937_64 rnd(time(NULL));

void solve()
{
	long long n;
	vector<long long> v;
	cin >> n;
	v.resize(n);
	for (long long i = 0; i < n; i++)
	{
		cin >> v[i];
	}

	vector<long long> mt(n, -1);
	multiset<long long> st;
	for (long long i = 1; i < n; i++)
	{
		if (mt[i] != -1)
		{
			break;
		}

		mt[i] = n - i;
		mt[n - i] = i;
		st.insert(v[i] + v[mt[i]]);
	}

	long long ans = *st.rbegin() - *st.begin();
	for (long long i = 1; i < n; i++)
	{
		st.erase(st.find(v[i] + v[mt[i]]));
		mt[i - 1] = mt[i];
		mt[mt[i]] = i - 1;
		mt[i] = -1;
		st.insert(v[i - 1] + v[mt[i - 1]]);
		ans = min(ans, *st.rbegin() - *st.begin());
	}
	cout << ans << "\n";
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	solve();

	return 0;
}

/*



















*/
