#include<iostream>
#include<cmath>
#include<algorithm>
#include<vector>
#include<set>
typedef long double ld;
typedef long long ll;
#define all(x) x.begin(),x.end()
using namespace std;
const ll inf = 1e18, mod = 1e9+7;
int n, m;
vector<vector<int>> b, used;
void dfs(int i, int j) {
    used[i][j] = 1;
    b[i][j] = 1;
    if (i != 0) {
        if (used[i-1][j] == 0 && b[i-1][j] != 2) dfs(i-1, j);
    }
    if (i != n+1) {
        if (used[i+1][j] == 0 && b[i+1][j] != 2) dfs(i+1, j);
    }
    if (j != 0) {
        if (used[i][j-1] == 0 && b[i][j-1] != 2) dfs(i, j-1);
    }
    if (j != m+1) {
        if (used[i][j+1] == 0 && b[i][j+1] != 2) dfs(i, j+1);
    }
}
int cnt(int i, int j) {
    if (b[i][j] != 2) return 0;
    int D = (b[i-1][j] == 2), U = (b[i+1][j] == 2), L = (b[i][j-1] == 2), R = (b[i][j+1] == 2);
    if ((b[i-1][j] != 1) && (b[i+1][j] != 1) && (b[i][j-1] != 1) && (b[i][j+1] != 1)) return 0;
    if (D+U+L+R == 1) return 5;
    if (D+U+L+R >= 3) return 0;
    if (D+R == 2) return 1;
    if (U+R == 2) return 2;
    if (U+L == 2) return 3;
    if (D+L == 2) return 4;
    return 0;
}
signed main() {
    cin >> n >> m;
    char c;
    b = vector<vector<int>>(n+2, vector<int>(m+2, 1));
    used = vector<vector<int>>(n+2, vector<int>(m+2, 0));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> c;
            if (c == '.') b[i+1][j+1] = 3;
            else b[i+1][j+1] = 2;
        }
    }
    dfs(0, 0);
    set<tuple<int, int, int>> s;
    for (int i = 0; i < n+2; i++) {
        for (int j = 0; j < m+2; j++) {
            if (cnt(i, j) != 0) s.insert({cnt(i, j), i, j});
        }
    }
    while (s.size() != 0) {
        auto [v, i, j] = *(--s.end());
        s.erase(--s.end());
        if (v == 5) {
            b[i][j] = 1;
        }
        if (v == 1 && b[i-1][j+1] != 3) {
            b[i][j] = 1;
        }
        if (v == 2 && b[i+1][j+1] != 3) {
            b[i][j] = 1;
        }
        if (v == 3 && b[i+1][j-1] != 3) {
            b[i][j] = 1;
        }
        if (v == 4 && b[i-1][j-1] != 3) {
            b[i][j] = 1;
        }
        if (b[i][j] == 1) {
            for (int i1 = i - 1; i1 <= i + 1; i1++) {
                for (int j1 = j - 1; j1 <= j + 1; j1++) {
                    if (cnt(i1, j1) != 0) s.insert({cnt(i1, j1), i1, j1});
                }
            }
        }
    }
    for (int i = 1; i < n+1; i++) {
        for (int j = 1; j < m+1; j++) {
            bool f = 1;
            for (int i1 = i - 1; i1 <= i + 1; i1++) {
                for (int j1 = j - 1; j1 <= j + 1; j1++) {
                    if (i == i1 && j == j1) continue;
                    f = f && (b[i1][j1] != 1);
                }
            }
            if (!f && b[i][j] == 2) cout << '#';
            else cout << '.';
        }
        cout << "\n";
    }
}