#include <iostream>
#include <vector>
#include <algorithm>
#include<set>
#include <map>

using namespace std;

#define  vec vector
#define int long long
#define all(a) a.begin(), a.end()

typedef vector<int> vi;
typedef pair<int, int> pi;
typedef vector<pi> vpi;
typedef vector<vi> vvi;
typedef vector<bool> vb;

template<typename T> void input(T& a, int i = 0, int j = -1) {
	if (j == -1)
		j = a.size() - 1;
	for (int k = i; k <= j; ++k)
		cin >> a[k];
}

const int MAX = 1e4 + 10;

vvi b[MAX];
map<pi, vpi> m;
map<pair<pi, pi>, vpi> m2;

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int n;
	cin >> n;
	vvi a = { {0, 0, 0} };
	for (int i = 1; i <= n; ++i) {
		int a1, b, c;
		cin >> a1 >> b >> c;
		a.push_back({ a1, b, c });
		sort(all(a[i]));
	}

	for (int i = 1; i <= n; ++i) {
		b[a[i][0]].push_back({ a[i][1], a[i][2], i });
		b[a[i][0]].push_back({ a[i][2], a[i][1], i });
		b[a[i][1]].push_back({ a[i][0], a[i][2], i });
		b[a[i][1]].push_back({ a[i][2], a[i][0], i });
		b[a[i][2]].push_back({ a[i][0], a[i][1], i });
		b[a[i][2]].push_back({ a[i][1], a[i][0], i });

		m[{a[i][0], a[i][1]}].push_back({ a[i][2], i });
		m[{a[i][0], a[i][2]}].push_back({ a[i][1], i });
		m[{a[i][1], a[i][2]}].push_back({ a[i][0], i });
	}
	for (auto& [tmp1, a] : m) {
		for (auto& [tmp2, b] : m) {
			sort(all(a));
			sort(all(b));
			int i = 0, j = 0;
			while (i < a.size() && j < b.size()) {
				if (a[i].first < b[j].first)
					i++;
				else if (a[i].first > b[j].first)
					j++;
				else {
					m2[{tmp1, tmp2}].push_back({ a[i].second, b[j].second });
					i++;
					j++;
				}
			}
		}
	}
	for (int i = 1; i <= n; ++i) {
		for (auto j : b[a[i][0]]) {
			if (j[2] == i)
				continue;
			vpi d = m2[{ {a[i][1], j[0]}, { a[i][2], j[1] }}];
			for (auto [x, y] : d) {
				if (x != i && x != j[2] && y != i && y != j[2]) {
					cout << "Yes\n";
					cout << i << ' ' << j[2] << " " << x << " " << y << "\n";
					return 0;
				}
			}
			d = m2[{ {a[i][2], j[0]}, { a[i][1], j[1] }}];
			for (auto [x, y] : d) {
				if (x != i && x != j[2] && y != i && y != j[2]) {
					cout << "Yes\n";
					cout << i << ' ' << j[2] << " " << x << " " << y << "\n";
					return 0;
				}
			}
		}
	}
	cout << "No";
	return 0;
}
