#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
#define rep(i, a, b) for(int i = (a); i < (b); i++)

using namespace std;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int n;
    ll B, C;
    cin >> n >> B >> C;

    ll x[n], p[n];
    rep(i, 0, n) cin >> x[i] >> p[i];

    multiset<pair<int, int> > can;

    ll L = 0, now = 0, last = 0, prev = -1;
    can.insert({p[0], 0});
    while (true) {
        for (int i = prev + 1; i <= now; i++) can.erase(can.find({p[i], i}));
        prev = now;

        while(last < n - 1 && x[last + 1] - x[now] <= C && (x[last + 1] - x[now] - L) * p[now] <= B) {
            last++;
            can.insert({p[last], last});
        }

        if (can.empty()) {
            ll will = min(C, L + B / p[now]);
            cout << x[now] + will << endl;
            return 0;
        }

        ll next = (*can.begin()).second;
        if (p[next] < p[now]) {
            ll need = max(0ll, x[next] - x[now] - L);
            B -= need * p[now];
            L = L + need - (x[next] - x[now]);
        } else {
            ll need = min(C - L, B / p[now]);
            L = L + need - (x[next] - x[now]);
            B -= need * p[now];
        }
        now = next;
    }

    return 0;
}