#include <bits/stdc++.h>

using namespace std;
#define ll long long
#define int long long
const int INF = 1e15;
const int mod = 1e9 + 7;

inline vector <pair <int, int>> djk(int n, int st, vector <vector <pair <int, int>>>& g) {
    vector <pair <int, int>> d(n, make_pair(INF, 0));
    d[st] = make_pair(0, 1);
    set <pair <int, int>> s;
    s.insert(make_pair(0, st));
    while (!s.empty()) {
        auto now = *s.begin();
        s.erase(now);
        int v = now.second;
        for (auto i : g[v]) {
            if (d[i.first].first > now.first + i.second) {
                s.erase(make_pair(d[i.first].first, i.first));
                d[i.first] = make_pair(now.first + i.second, d[v].second);
                s.insert(make_pair(d[i.first].first, i.first));
            } else if (d[i.first].first == now.first + i.second) {
                d[i.first].second = (d[i.first].second + d[v].second) % mod;
            }
        }
    }
    return d;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m, l, s, e;
    cin >> n >> m >> s >> e >> l; --s; --e;
    vector <vector <pair <int, int>>> g(n);
    for (int i = 0; i < m; ++i) {
        int x, y, w;
        cin >> x >> y >> w; --x; --y;
        g[x].emplace_back(y, w);
        g[y].emplace_back(x, w);
    }
    auto ds = djk(n, s, g);
    auto de = djk(n, e, g);
    if (ds[e].first > l) {
        cout << 0;
        return 0;
    }
    if (ds[e].first == l) {
        cout << ds[e].second;
        return 0;
    }
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        if (i == e || ds[i].first + de[i].first != ds[e].first) continue;
        for (auto j : g[i]) {
            if (ds[i].first + j.second + de[j.first].first == l) ans = (ans + ds[i].second * de[j.first].second) % mod;
        }
    }
    cout << ans;
    return 0;
}

/*
6 7
1 6 12
1 2 2
1 3 4
2 5 2
3 5 4
2 4 4
4 6 6
5 6 4

 */