#include <bits/stdc++.h>

using namespace std;

#define  sz(a) (int)(a.size())
#define  dbg(x) cout << #x << " = " << (x) << endl;
#define int long long
#define all(a) a.begin(), a.end()
#define ll long long
#define ld long double

struct event {
    int x;
    int type, w;
    event () {}
    event (int x, int type, int w) : x(x), type(type), w(w) {}
    bool operator < (const event & other) {
        if (other.x == x) {
            if (other.type == type) {
                return w < other.w;
            }
            return type < other.type;
        }
        return x < other.x;
    }
};

void solve() {
    int n, b, c;
    cin >> n >> b >> c;
    vector<event> events;
    for (int i = 0; i < n; i++) {
        int x, w;
        cin >> x >> w;
        int l = x;
        int r = x + c;
        events.emplace_back(l, 0, w);
        events.emplace_back(r, 1, w);
    }
    sort(all(events));
    int current_open = 0;
    multiset<int> W;
    int last = 0;
    for (auto x : events) {
        int need = (x.x - last);
        int cost = *W.begin();
        if (need * cost > b) {
            int can = b / cost;
            cout << last + can << endl;
            return;
        }
        b -= need * cost;
        if (x.type == 0) {
            current_open++;
            W.insert(x.w);
        } else {
            current_open--;
            W.erase(W.find(x.w));
        }
        if (current_open == 0) {
            cout << x.x << endl;
            return;
        }
        last = x.x;
    }
    cout << last << endl;
}

signed main() {
#ifdef home
    freopen("input.txt", "r", stdin);
#endif
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int test = 1;
    //cin >> test;
    while (test--) {
        solve();
    }
}