#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>

using namespace std;
template<typename A, typename B>
string to_string(pair<A, B> p);


string to_string(string s){
    return '"' + s + '"';
}

string to_string(const char *s){
    return to_string((string)s);
}

string to_string(bool a){
    return (a ? "true" : "false");
}

template<typename A, typename B>
string to_string(pair<A, B> p){
    return "(" + to_string(p.first) + ", " + to_string(p.second) + ")";
}

template<typename A>
string to_string(A v){
    bool f = 1;
    string res = "{";
    for(auto x : v){
        if (!f) res += ", ";
        res += to_string(x);
        f = 0;
    }
    res += "}";
    return res;
}

void debug_out(){
    cerr << endl;
}
template<typename Head, typename... Tail>
void debug_out(Head H, Tail... T){
    cerr << " " << to_string(H);
    debug_out(T...);
}
#ifdef LOCAL
#define debug(...) cerr << "[" << #__VA_ARGS__ << "]:", debug_out(__VA_ARGS__)
#else
#define debug(...)
#endif

#define sz(a)(ll)(a).size()
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define pikachu push_back
#define pll pair<ll, ll>
#define pii pair<int, int>
typedef long long ll;
typedef long double ld;


void run();
signed main() {
#ifdef LOCAL
    freopen("file.in", "r", stdin);
#endif
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    run();
}
void run(){
    ll n;
    cin >> n;
    vector<ll> a(n);
    for(auto& e: a) cin >> e;
    sort(a.begin(), a.end());
    multiset<ll> kek;
    for(ll i = 1; i <= n / 2; ++i){
        kek.insert(a[i] + a[n - i]);
    }
    ll ans = 1e18;
    auto clc = [&](){
        ll a = *(kek.begin());
        ll b = *(--kek.end());
        ans = min(ans, b - a);
    };
    clc();
    vector<int> p(n);
    for (int i = 1; i < n; ++i) {
        p[i] = n - i;
    }
    p[0] = -1;
    for (ll i = 1; i < n; ++i){
        auto pp = p[i];
        kek.erase(kek.find(a[i] + a[pp]));
        p[i] = -1;
        p[pp] = i - 1;
        p[i - 1] = pp;
        kek.insert(a[i - 1] + a[pp]);
        clc();
    }
    cout << ans;
}
