#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>

using namespace std;
template<typename A, typename B>
string to_string(pair<A, B> p);


string to_string(string s){
    return '"' + s + '"';
}

string to_string(const char *s){
    return to_string((string)s);
}

string to_string(bool a){
    return (a ? "true" : "false");
}

template<typename A, typename B>
string to_string(pair<A, B> p){
    return "(" + to_string(p.first) + ", " + to_string(p.second) + ")";
}

template<typename A>
string to_string(A v){
    bool f = 1;
    string res = "{";
    for(auto x : v){
        if (!f) res += ", ";
        res += to_string(x);
        f = 0;
    }
    res += "}";
    return res;
}

void debug_out(){
    cerr << endl;
}
template<typename Head, typename... Tail>
void debug_out(Head H, Tail... T){
    cerr << " " << to_string(H);
    debug_out(T...);
}
#ifdef LOCAL
#define debug(...) cerr << "[" << #__VA_ARGS__ << "]:", debug_out(__VA_ARGS__)
#else
#define debug(...)
#endif

#define sz(a)(ll)(a).size()
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define pikachu push_back
#define pll pair<ll, ll>
#define pii pair<int, int>
typedef long long ll;
typedef long double ld;


void run();
signed main() {
#ifdef LOCAL
    freopen("file.in", "r", stdin);
#endif
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    run();
}

const int P = 1'000'000'007;

ll mul(ll a, ll b){
    return (a * b) % P;
}

ll add(ll a, ll b){
    return (a + b) % P;
}

ll rev(ll a){
    return (P - a);
}
void run(){
    ll n, m;
    cin >> n >> m;
    vector<vector<ll>> dp(n + 1, vector<ll>(m + 1, 0));
    vector<vector<ll>> dp1(n + 1, vector<ll>(m + 1, 0));
    vector<vector<ll>> dp2(n + 1, vector<ll>(m + 1, 0));
    vector<vector<ll>> cnt(n + 1, vector<ll>(m + 1, 0));
    vector<vector<ll>> cnt1(n + 1, vector<ll>(m + 1, 0));
    vector<vector<ll>> cnt2(n + 1, vector<ll>(m + 1, 0));
    for (int i = 1; i <= n; ++i) {
        for (int j = 1; j <= m; ++j) {
            for (int k = 1; k < i - 1; ++k) {
                cnt[i][j] += mul(mul((i - 1 - k), (j - 1)), cnt1[k][max(j - 2, 0)]);
                cnt[i][j] %= P;
                cnt[i][j] += rev(mul(i - 1 - k, cnt2[k][max(j - 2, 0)]));
                cnt1[i][j] %= P;
            }
            cnt[i][j]++;
            cnt[i][j] %= P;
            cnt1[i][j] = add(cnt1[i][j - 1], cnt[i][j]);
            cnt2[i][j] = add(cnt2[i][j - 1], mul(j, cnt[i][j]));
        }
    }
    for (int i = 1; i <= n; ++i){
        for (int j = 1; j <= m; ++j){
            for (int k = 1; k < i - 1; ++k){
//                for (int l = 1; l < j - 1; ++l) {
//                    dp[i][j] += mul(mul((i - 1 - k), (j - 1 - l)), dp[k][l]);
//                    dp[i][j] %= P;
//                }
                dp[i][j] += mul(mul(i - 1 - k, j - 1), dp1[k][max(j - 2, 0)]);
                dp[i][j] %= P;
                dp[i][j] += rev(mul(i - 1 - k, dp2[k][max(j - 2, 0)]));
                dp[i][j] %= P;
            }
            dp[i][j] += mul(cnt[i][j], mul(i, j));
            dp[i][j] %= P;
            dp1[i][j] = add(dp1[i][j - 1], dp[i][j]);
            dp2[i][j] = add(dp2[i][j - 1], mul(j, dp[i][j]));
        }
    }
//    debug(dp);
//    debug(cnt);
    cout << dp[n][m] << endl;
}
