#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <set>

using namespace std;

typedef long long ll;

#define int ll

const int MOD = 1e9 + 7;
signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);

	int n, m;
	cin >> n >> m;;
	int s, t, l;
	cin >> s >> t >> l;
	s--, t--;
	vector<vector<pair<int, int>>> graph(n);
	for (int i = 0; i < m; i++) {
		int a, b, c;
		cin >> a >> b >> c;
		a--, b--;
		graph[a].push_back({ b, c });
		graph[b].push_back({ a, c });
	}
	set<pair<int, int>> ss;
	vector<pair<int, int>> dist1(n, { LLONG_MAX, 0 });
	dist1[s] = { 0, 1 };
	ss.insert({ dist1[s].first, s });
	while (!ss.empty()) {
		int v = ss.begin()->second;
		ss.erase(ss.begin());
		for (auto to : graph[v]) {
			if (dist1[to.first].first > dist1[v].first + to.second) {
				ss.erase({ dist1[to.first].first, to.first });
				dist1[to.first].first = dist1[v].first + to.second;
				dist1[to.first].second = dist1[v].second;
				ss.insert({ dist1[to.first].first, to.first });
			}
			else if (dist1[to.first].first == dist1[v].first + to.second) {
				dist1[to.first].second += dist1[v].second;
				dist1[to.first].second %= MOD;
			}
		}
	}
	vector<pair<int, int>> dist2(n, { LLONG_MAX, 0 });
	dist2[t] = { 0, 1 };
	ss.insert({ dist2[t].first, t });
	while (!ss.empty()) {
		int v = ss.begin()->second;
		ss.erase(ss.begin());
		for (auto to : graph[v]) {
			if (dist2[to.first].first > dist2[v].first + to.second) {
				ss.erase({ dist2[to.first].first, to.first });
				dist2[to.first].first = dist2[v].first + to.second;
				dist2[to.first].second = dist2[v].second;
				ss.insert({ dist2[to.first].first, to.first });
			}
			else if (dist2[to.first].first == dist2[v].first + to.second) {
				dist2[to.first].second += dist2[v].second;
				dist2[to.first].second %= MOD;
			}
		}
	}
	int ans = 0;
	for (int i = 0; i < n; i++) {
		for (auto to : graph[i]) {
			if (dist1[i].first + dist2[to.first].first == l) {
				ans += dist1[i].second * dist2[to.first].second % MOD;
				ans %= MOD;
			}
		}
	}
	cout << ans << '\n';
}