//#include <iostream>
//#include <vector>
//#include <algorithm>
//#include <set>
//typedef long long ll;
//typedef long double ld;
//#define all(a) a.begin(), a.end()
//#define ve vector
//#define ft first
//#define sd second
//using namespace std;
//ll MOD = 1e9 + 7;
//ll INF = 1e18;
//
//ll n, m;
//vector<string> g;
//vector<ll> dx = {0, 0, 1, -1};
//vector<ll> dy = {1, -1, 0, 0};
//
//bool in(ll x, ll y) {
//    if (min(x, y) < 0 || x >= n || y >= m) return false;
//    return true;
//}
//
//void bfs1(ll x, ll y) {
//    g[x][y] = '1';
//
//    for (ll k = 0; k < 4; ++k) {
//        ll new_x = x + dx[k];
//        ll new_y = y + dy[k];
//
//        if (!in(new_x, new_y) || g[new_x][new_y] != '.') continue;
//
//        bfs1(new_x, new_y);
//    }
//}
//
//ll real_bfs(ll x1, ll y1, ll x2, ll y2) {
//    vector<vector<ll>> dist(n, vector<ll> (m, INF));
//
//    dist[x1][y1] = 0;
//
//
//}
//int main() {
//    ios_base::sync_with_stdio(0);
//    cin.tie(0);
//    cout.tie(0);
//
//    cin >> n >> m;
//    g.resize(n);
//    for (ll i = 0; i < n; ++i) cin >> g[i];
//
//    for (ll i = 0; i < n; ++i) {
//        if (g[i][0] == '.') bfs1(i, 0);
//        if (g[i][m - 1] == '.') bfs1(i, m - 1);
//    }
//    for (ll i = 0; i < m; ++i) {
//        if (g[0][i] == '.') bfs1(0, i);
//        if (g[m - 1][i] == '.') bfs1(m - 1, i);
//    }
//
//    pair<ll, ll> left = {INF, INF};
//    pair<ll, ll> right = {-INF, -INF};
//    pair<ll, ll> up = {INF, INF};
//    pair<ll, ll> down = {-INF, -INF};
//
//    for (ll i = 0; i < n; ++i) {
//        for (ll j = 0; j < m; ++j) {
//            if (g[i][j] == '.') {
//                if (left.second > j) left = {i, j};
//                if (right.second < j) right = {i, j};
//                if (up.first > i) up = {i, j};
//                if (down.first < i) down = {i, j};
//            }
//        }
//    }
//
//    vector<string> iznach = g;
//
//    for (ll i = down.first + 1; i < n; ++i) {
//        g[i][down.second] = '.';
//    }
//
//    ll ans = real_bfs(left.first, left.second, right.first, right.second);
//
//    g = iznach;
//
//    for (ll i = 0; i < up.first; ++i) {
//        g[i][up.second] = '.';
//    }
//
//    ans += real_bfs(left.first, left.second, right.first, right.second);
//
//    cout << ans;
//    return 0;
//}

#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
typedef long long ll;
typedef long double ld;
#define all(a) a.begin(), a.end()
#define ve vector
#define ft first
#define sd second
#define int long long
using namespace std;
ll MOD = 1e9 + 7;
ll INF = 1e18;

ve<ve<pair<int, int> > > g;
ve<ll> w[2];


signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    g.resize(n);
    w[1].resize(n, INF);
    w[0].resize(n, INF);
    ll s, t, L;
    cin >> s >> t >> L;
    --s; --t;
    for (int i = 0; i < m; ++i) {
        int a, b, c;
        cin >> a >> b >> c;
        --a; --b;
        g[a].push_back({ b, c });
        g[b].push_back({ a, c });
    }
    ve<int> look[2];
    set <pair <int, int> > q;
    q.insert({ 0, s });
    w[0][s] = 0;
    ve<bool> used(n, 0);
    while (!q.empty()) {
        auto v = *q.begin();
        q.erase(q.begin());
        if (used[v.sd]) {
            continue;
        }
        look[0].push_back(v.sd);
        used[v.sd] = true;
        for (auto u : g[v.sd]) {
            if (w[0][u.ft] > w[0][v.sd] + u.sd) {
                q.insert({ w[0][v.sd] + u.sd, u.ft });
                w[0][u.ft] = w[0][v.sd] + u.sd;
            }
        }
    }
    used.assign(n, 0);
    q.insert({ 0, t });
    w[1][t] = 0;
    while (!q.empty()) {
        auto v = *q.begin();
        q.erase(q.begin());
        if (used[v.sd]) {
            continue;
        }
        look[1].push_back(v.sd);
        used[v.sd] = true;
        for (auto u : g[v.sd]) {
            if (w[1][u.ft] > w[1][v.sd] + u.sd) {
                q.insert({ w[1][v.sd] + u.sd, u.ft });
                w[1][u.ft] = w[1][v.sd] + u.sd;
            }
        }
    }
    ve <ll> cnt[2];
    for (int j = 0; j <= 1; ++j) {
        cnt[j].resize(n, 0);
        cnt[j][look[j][0]] = 1;
        for (auto i : look[j]) {
            for (auto u : g[i]) {
                if (w[j][u.ft] == w[j][i] - u.sd) {
                    cnt[j][i] += cnt[j][u.ft];
                    cnt[j][i] %= MOD;
                }
            }
        }
    }
    ll ans = 0;
    if (L == w[0][t]) {
        cout << cnt[0][t];
        return 0;
    }
    for (int i = 0; i < n; ++i) {
        if (i == t) continue;
        for (auto u : g[i]) {
            if (w[0][i] + w[1][u.ft] + u.sd == L && w[0][i] + w[1][i] == w[1][s]) {
                ans += cnt[0][i] * cnt[1][u.ft];
                ans %= MOD;
            }
        }
    }
    cout << ans;
    return 0;
}
/*
6 7
1 6 8
1 2 2
1 3 4
2 5 2
3 5 4
2 4 4
4 6 6
5 6 4*/