#include <bits/stdc++.h>
using namespace std;

const double eps = 1e-10;
typedef long long ll;
typedef pair< ll, ll> pll;
const int maxN = 1e5 + 9;
ll ans[maxN];

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0);
    vector<pll> qs;
    set<pll> segs;
    int n, q; cin >> n >> q;
    vector<ll> s(n);
    for(auto &i: s) {
        cin >> i;
    }
    s.push_back(-1);
    s.push_back(1e10);
    sort(s.begin(), s.end());
    ++n; ++n;
    for(int i = 0; i + 1 < n; ++i) {
        ll L = s[i] + 1;
        ll R = s[i + 1] - 1;
        if(L <= R) segs.insert({L, R});
    }

    for(int i = 0; i < q; ++i) {
        ll k; cin >> k;
        qs.push_back({k, i});
    }
    sort(qs.begin(), qs.end());

    ll cur = 0;
    ll res = 0;
    for(auto &i: qs) {
        while(cur < i.first) {
            auto f = *segs.begin(); segs.erase(f);
            ll cnt = f.second - f.first + 1;
            ll nid = min(cnt, i.first - cur);
            cur += nid;
            ll NL = f.first + nid;
            res = NL - 1;
            if(NL <= f.second) {
                segs.insert({NL, f.second});
            }
        }
        ans[i.second] = res;
    }

    for(int i = 0; i < q; ++i) {
        cout << ans[i] << ' ';
    }
    cout << '\n';


}
/*
4 10
1 2 6 7
1 2 3 4 5 6 7 8 10 11

 */