#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef long double ld;

ld eps = 1e-7;

ostream &operator<<(ostream &out, vector<int> &vec) {
    for (int el: vec) {
        out << el << ' ';
    }
    return out;
}

ostream &operator<<(ostream &out, vector<bool> &vec) {
    for (bool el: vec) {
        if (el)
            out << '#';
        else
            out << '.';
    }
    return out;
}

template<typename T>
ostream &operator<<(ostream &out, vector<T> &vec) {
    for (T el: vec) {
        out << el << '\n';
    }
    return out;
}

#define int long long
const ll INF = 1e18, mod = 1e9 + 7;

vector<vector<pair<int, int>>> g;

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    //freopen("input.txt", "r", stdin);
    int n, m, s, t, l;
    cin >> n >> m >> s >> t >> l;
    s--, t--;
    g.resize(n);
    int u, v, cost;
    for (int i = 0; i < m; i++) {
        cin >> u >> v >> cost;
        u--, v--;
        g[u].push_back({v, cost});
        g[v].push_back({u, cost});
    }
    vector<int> dist1(n, INF), dist2(n, INF);
    dist1[s] = 0;
    set<pair<int, int>> st;
    st.insert({0, s});
    while (!st.empty()) {
        auto now = *st.begin();
        v = now.second;
        st.erase(st.begin());
        for (auto gg: g[v]) {
            int to = gg.first, cost = gg.second;
            if (dist1[to] > dist1[v] + cost) {
                st.erase({dist1[to], to});
                dist1[to] = dist1[v] + cost;
                st.insert({dist1[to], to});
            }
        }
    }
    st.clear();

    dist2[t] = 0;
    st.insert({0, t});
    while (!st.empty()) {
        auto now = *st.begin();
        v = now.second;
        st.erase(st.begin());
        for (auto gg: g[v]) {
            int to = gg.first, cost = gg.second;
            if (dist2[to] > dist2[v] + cost) {
                st.erase({dist2[to], to});
                dist2[to] = dist2[v] + cost;
                st.insert({dist2[to], to});
            }
        }
    }
    //cout << dist1 << dist2;
    int best = dist1[t];
    int ans = 0;
    for (v = 0; v < n; v++) {
        for (auto gg: g[v]) {
            int to = gg.first;
            if (dist1[v] + dist2[v] == best) {
                if (dist1[v] + gg.second + dist2[to] == l) {
                    ans = (ans + 1) % mod;
                }
            }
        }
    }
    cout << ans;
}
