#include <bits/stdc++.h>

using namespace std;
typedef int64_t ll;
typedef long double ld;

void solve_a() {
    ld n, t;
    ld m;
    ld x, y;
    cin >> n >> t >> m >> x >> y;
    ld z = 0;
    ld ans = max(z, ((n - m) / y + m / x - t * 60) / 60);
    cout << ceil(ans);
}

struct node {
    int sum = 0;
    node *l = 0, *r = 0;

    void init() {
        if (!l) l = new node, r = new node;
    }

    void recalc() {
        sum = l->sum + r->sum;
    }
};

void make(int lx, int rx, node *v, int pos) {
    v->sum++;
    if (rx - lx == 1) return;
    int m = (lx + rx) / 2;
    v->init();
    pos < m ? make(lx, m, v->l, pos) : make(m, rx, v->r, pos);
}

int get(int lx, int rx, node *v, int k) {
    //cout << lx << " " << rx << " " << v->sum << " " << k << endl;
    if (rx - lx - v->sum < k) return -1;
    if (rx - lx == 1) return lx;
    int m = (lx + rx) / 2;
    v->init();
    int res = get(lx, m, v->l, k);
    return res == -1 ? get(m, rx, v->r, k - m + lx + v->l->sum) : res;
}

void solve_e() {
    int n, q;
    cin >> n >> q;
    int kol = 1;
    while (kol < 2e9) kol *= 2;
    node *root = new node;
    for (int i = 0; i < n; i++) {
        int x;
        cin >> x;
        make(0, kol, root, x);
    }
    for (int i = 0; i < q; i++) {
        int k;
        cin >> k;
        cout << get(0, kol, root, k) << " ";
    }
}

void solve_c() {
    int n;
    cin >> n;
    vector<ll> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    sort(a.begin(), a.end());
    int K = 50;
    ll bst = 100000000001;
    for (int i = 0; i < min(n - 1, K); i++) {
        ll mn = 100000000001;
        ll mx = 0;
        ll s = 0;
        int l = 0;
        int r = n - 1;
        while (r > l) {
            if (l == i) l++;
            if (r == i) r--;
            if (r <= l) break;
            s = a[l] + a[r];
            mn = min(mn, s);
            mx = max(mx, s);
            l++;
            r--;
        }
        bst = min(bst, mx - mn);
    }
    for (int i = n - 1; i > max(n - 1 - K, 0); i--) {
        ll mn = 100000000001;
        ll mx = 0;
        ll s = 0;
        int l = 0;
        int r = n - 1;
        while (r > l) {
            if (l == i) l++;
            if (r == i) r--;
            if (r <= l) break;
            s = a[l] + a[r];
            mn = min(mn, s);
            mx = max(mx, s);
            l++;
            r--;
        }
        bst = min(bst, mx - mn);
    }
    for (int I = 0; I < K; I++) {
        int i = rand();
        ll mn = 100000000001;
        ll mx = 0;
        ll s = 0;
        int l = 0;
        int r = n - 1;
        while (r > l) {
            if (l == i) l++;
            if (r == i) r--;
            if (r <= l) break;
            s = a[l] + a[r];
            mn = min(mn, s);
            mx = max(mx, s);
            l++;
            r--;
        }
        bst = min(bst, mx - mn);
    }

    cout << bst << '\n';
}

void solve_j() {
    int n;
    cin >> n;
    vector<vector<int>> a(n, vector<int>(3));
    vector<set<int>> b(10001);
    map<pair<int, int>, set<int>> m;
    map<vector<int>, vector<int>> M;
    for (int i = 0; i < n; i++) {
        cin >> a[i][0] >> a[i][1] >> a[i][2];
        b[a[i][0]].insert(i);
        b[a[i][1]].insert(i);
        b[a[i][2]].insert(i);
        m[{min(a[i][0], a[i][1]), max(a[i][0], a[i][1])}].insert(i);
        m[{min(a[i][2], a[i][1]), max(a[i][2], a[i][1])}].insert(i);
        m[{min(a[i][0], a[i][2]), max(a[i][0], a[i][2])}].insert(i);
        vector<int> q = a[i];
        sort(q.begin(), q.end());
        M[q].push_back(i);
    }
    for (int i = 0; i < n; i++) {
        for (int j: b[a[i][0]]) {
            if (i == j) continue;
            int J = 0;
            int I = 1;
            for (; a[j][J] != a[i][0]; J++);
            J = (J + 1) % 3;
            for (int k: m[{min(a[j][J], a[i][I]), max(a[j][J], a[i][I])}]) {
                if (k == i || k == j) continue;
                int j1 = 0;
                for (; a[k][j1] != a[j][J]; j1++);
                int j2 = 0;
                for (; a[k][j2] != a[i][I] || j1 == j2; j1++);
                int j3 = 3 - j1 - j2;
                vector<int> q = {a[i][3 - I], a[k][j3], a[j][(J + 1) % 3]};
                sort(q.begin(), q.end());
                for (int D: M[q]) {
                    if (D != i && D != j && D != k) {
                        cout << "Yes\n";
                        cout << i + 1 << ' ' << j + 1 << ' ' << k + 1 << ' ' << D + 1 << '\n';
                        return;
                    }
                }
            }
        }
    }
    cout << "No\n";
}

#define int long long

void solve_d() {

}

const ll INF = 1e18, MOD = 1e9+7;

void solve_b() {
    int n, m;
    cin >> n >> m;
    int s, t, l;
    cin >> s >> t >> l;
    vector<int> dst1(n, INF), dst2(n, INF);
    vector<pair<int, int>> vp[n];
    for (int i = 0; i < m; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        a--;
        b--;
        vp[a].push_back({b, c});
        vp[b].push_back({a, c});
    }
    set<pair<int, int>> st;
    st.insert({0, s - 1});
    dst1[s - 1] = 0;
    while (!st.empty()) {
        auto [cst, v] = *st.begin();
        st.erase(st.begin());
        for (auto [to, cost]: vp[v]) {
            if (dst1[to] > cst + cost) {
                st.erase({dst1[to], to});
                dst1[to] = dst1[v] + cost;
                st.insert({dst1[to], to});
            }
        }
    }
    st.insert({0, t - 1});
    dst2[t - 1] = 0;
    while (!st.empty()) {
        auto [cst, v] = *st.begin();
        st.erase(st.begin());
        for (auto [to, cost]: vp[v]) {
            if (dst2[to] > dst2[v] + cost) {
                st.erase({dst2[to], to});
                dst2[to] = dst2[v] + cost;
                st.insert({dst2[to], to});
            }
        }
    }
    set <pair<int, int>> q;
    vector <ll> dp(n, 0), dp1(n, 0);
    dp[s - 1] = 1;
    q.insert({0, s - 1});
    while(!q.empty()){
        auto [cst, k] = *q.begin();
        q.erase(q.begin());
        for(auto [i, c]:vp[k]){
            if(dst1[k] + c == dst1[i]){
                dp[i] += dp[k];
                dp[i] %= MOD;
                q.insert({dst1[i], i});
            }
        }
    }
    dp1[t - 1] = 1;
    q.insert({0, t - 1});
    while(!q.empty()){
        auto [cst, k] = *q.begin();
        q.erase(q.begin());
        for(auto [i, c]:vp[k]){
            if(c + dst2[k] == dst2[i]){
                dp1[i] += dp1[k];
                dp1[i] %= MOD;
                q.insert({dst1[i], i});
            }
        }
    }
    if (l == dst1[t - 1]) {
        cout << dp[t - 1];
    } else {
        ll cnt = 0;
        for (int i = 0; i < n; i++) {
            if (dst1[i] + dst2[i] == dst1[t - 1]) {
                for (auto [to, cost]: vp[i]) {
                    if (dst1[i] + cost + dst2[to] == l) {
                        cnt += dp[i] * dp1[to];
                        cnt %= MOD;
                    }
                }
            }
        }
        cout << cnt;
    }
}

/*
 * 6 7
1 6 12
1 2 2
1 3 4
2 5 2
3 5 4
2 4 4
4 6 6
5 6 4
 *
 */
signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
//    cin >> t;
    while (t--) {
        solve_b();
    }
    return 0;

}
