#include <bits/stdc++.h>

using namespace std;
typedef int64_t ll;
typedef long double ld;

void solve_a(){
    ld n, t;
    ld m;
    ld x ,y;
    cin >> n >> t >> m >> x >> y;
    ld z = 0;
    ld ans = max(z, ((n - m) / y + m / x - t * 60) / 60);
    cout << ceil(ans);
}
struct node
{
    int sum = 0;
    node *l=0,*r=0;
    void init()
    {
        if (!l) l = new node, r = new node;
    }
    void recalc()
    {
        sum = l->sum + r->sum;
    }
};
void make(int lx, int rx, node* v, int pos)
{
    v->sum++;
    if (rx - lx == 1) return;
    int m = (lx + rx) / 2;
    v->init();
    pos < m ? make(lx,m,v->l, pos) : make(m,rx,v->r, pos);
}
int get(int lx, int rx, node  *v, int k)
{
    //cout << lx << " " << rx << " " << v->sum << " " << k << endl;
    if (rx - lx - v->sum < k) return -1;
    if (rx - lx == 1) return lx;
    int m = (lx + rx) / 2;
    v->init();
    int res = get(lx,m,v->l,k);
    return res == -1 ? get(m,rx,v->r,k-m+lx+v->l->sum) : res;
}
void solve_e()
{
    int n, q;
    cin >> n >> q;
    int kol = 1;
    while (kol < 2e9) kol *= 2;
    node *root = new node;
    for (int i=0;i<n;i++)
    {
        int x;
        cin >> x;
        make(0, kol, root, x);
    }
    for (int i=0;i<q;i++)
    {
        int k;
        cin >> k;
        cout << get(0, kol, root, k) << " ";
    }
}
void solve_c(){
    int n;
    cin >> n;
    vector<ll> a(n);
    for(int i = 0; i < n; i++){
        cin >> a[i];
    }
    sort(a.begin(), a.end());

}

void solve_j(){
    int n;
    cin >> n;
    vector<vector<int>> a(n,vector<int> (3));
    vector<set<int>> b(10001);
    map<pair<int,int>, set<int>> m;
    map<vector<int>, vector<int>> M;
    for(int i = 0; i < n; i++){
        cin >> a[i][0] >> a[i][1] >> a[i][2];
        b[a[i][0]].insert(i);
        b[a[i][1]].insert(i);
        b[a[i][2]].insert(i);
        m[{min(a[i][0],a[i][1]),max(a[i][0],a[i][1])}].insert(i);
        m[{min(a[i][2],a[i][1]),max(a[i][2],a[i][1])}].insert(i);
        m[{min(a[i][0],a[i][2]),max(a[i][0],a[i][2])}].insert(i);
        vector<int> q = a[i];
        sort(q.begin(), q.end());
        M[q].push_back(i);
    }
    for(int i = 0; i < n; i++){
        for(int j: b[a[i][0]]){
            if(i == j) continue;
            int J = 0;
            int I = 1;
            for(; a[j][J] != a[i][0];J++);
            J = (J + 1) % 3;
            for(int k: m[{min(a[j][J], a[i][I]), max(a[j][J],a[i][I])}]){
                if(k == i || k == j) continue;
                int j1 = 0;
                for(; a[k][j1] != a[j][J];j1++);
                int j2 = 0;
                for(; a[k][j2] != a[i][I] || j1==j2;j1++);
                int j3 = 3 - j1 - j2;
                vector<int> q = {a[i][3 - I], a[k][j3], a[j][(J + 1) % 3]};
                sort(q.begin(), q.end());
                for(int D: M[q]){
                    if(D != i && D != j && D != k){
                        cout << "Yes\n";
                        cout << i + 1 << ' ' << j + 1 << ' ' << k + 1 << ' ' << D + 1 << '\n';
                        return;
                    }
                }
            }
        }
    }
    cout << "No\n";
}
signed main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
//    cin >> t;
    while(t--){
        solve_j();
    }
    return 0;

}
