#include <bits/stdc++.h>

#define ll long long

using namespace std;

const ll inf = 1e918;

int main()
{
    int n, m; cin >> n >> m;
    int s, t; ll l; cin >> s >> t >> l;
    vector<vector<pair<int, ll> > > g(n);
    vector<pair<pair<int, int>, ll> > e;
    for(int i = 0; i < m; ++i){
        int u, v, w; cin >> u >> v >> w;
        --u, --v;
        g[u].push_back({v, w});
        g[v].push_back({u, w});
        e.push_back({{v, u}, w});
        e.push_back({{u, v}, w});
    }
    vector<ll> d1(n, inf);
    vector<ll> cnt_path(n, 0);
    priority_queue<pair<ll, int> > q;
    q.push({0, s - 1});
    cnt_path[s - 1] = 1;
    d1[s - 1] = 0;
    while(!q.empty()){
        auto[w, u] = q.top(); q.pop();
        w = -w;
        if(d1[u] != w)
            continue;
        for(auto[v, ww] : g[u]){
            if(d1[v] > d1[u] + ww)
                d1[v] = d1[u] + ww, q.push({-d1[v], v}), cnt_path[v] = cnt_path[u];
            else if(d1[v] == d1[u] + ww)
                cnt_path[v] += cnt_path[u];
        }
    }

    vector<ll> d2(n, inf);
    q.push({0, t - 1});
    d2[t - 1] = 0;
    while(!q.empty()){
        auto[w, u] = q.top(); q.pop();
        w = -w;
        if(d2[u] != w)
            continue;
        for(auto[v, ww] : g[u])
            if(d2[v] > d2[u] + ww)
                d2[v] = d2[u] + ww, q.push({-d2[v], v});
    }
    //cout << cnt_path[t - 1] << '\n';
    if(l == d1[t - 1]){
        cout << cnt_path[t - 1];
        return 0;
    }
    int ans = 0;
    for(auto[a, w] : e){
        int u = a.first, v = a.second;
        if(d1[u] + d2[u] == d1[t - 1] && d1[u] + w + d2[v] == l)
            ++ans;
    }
    cout << ans << '\n';
    return 0;
}
