#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_map>

#define int long long

using namespace std;

signed main() {
    int n, q;
    cin >> n >> q;
    vector<int> a(n + 2), ans(q);
    vector<pair<int, int>> b(q);
    for (int i = 1, x; i <= n; ++i) {
        cin >> a[i];
        a[i] += 1;
    }
    a[0] = 0;
    a[n + 1] = 2e9;
    for (int i = 0; i < q; ++i) {
        cin >> b[i].first;
        b[i].second = i;
    }
    sort(b.begin(), b.end());

    int query = 0;
    int left_idx = 1, right_idx = a[1] - 1;
    int f = 0;
    while (query < q) {
        while (!(b[query].first <= right_idx and b[query].first >= left_idx)) {
            f += 1;
            left_idx = a[f] - (f - 1);
            right_idx = a[f + 1] - f - 1;
        }
        ans[b[query].second] = a[f] + (b[query].first - left_idx);
        query += 1;
    }
    for (int i = 0; i < q; ++i)
        cout << ans[i] << " ";
    return 0;
}
