#include <iostream>
#include <vector>
#include <set>
#include <iomanip>
#include <numeric>
#include <algorithm>
#include <cmath>
#include <random>

using namespace std;

#ifdef KROL
#define dbg(x) cerr << #x << ":\n " << x;
#else
#define dbg(x);
#endif

typedef long long ll;
typedef long double ld;

#define int ll
#define sz(x) int(x.size())

void solve() {
	int n, q;
	cin >> n >> q;

	vector<int> a(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}

	a.push_back(-1);
	sort(a.begin(), a.end());
	a.erase(unique(a.begin(), a.end()), a.end());

	a.push_back(10000000000000);

	vector<pair<int, int>> k(q);
	for (int i = 0; i < q; ++i) {
		cin >> k[i].first;
		k[i].second = i;
	}

	sort(k.begin(), k.end());

	vector<int> ans(q);
	int cnt = 0, i = 0;
	for (auto [x, ind] : k) {
		while (i < n && cnt + a[i + 1] - a[i] - 1 < x) {
			cnt += a[i + 1] - a[i] - 1;
			++i;
		}
		ans[ind] = a[i] + (x - cnt);
	}

	for (int x : ans) {
		cout << x << ' ';
	}
	cout << '\n';
}

signed main() {
	cin.tie(nullptr);
	ios::sync_with_stdio(false);
	cout << fixed << setprecision(20);

	int T = 1;
	//cin >> T;

	for (int t = 1; t <= T; ++t) {
		solve();
	}
}