#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

#define sz(v) v.size()
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()

mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    sort(all(a));

    multiset<int> sums;

    auto get = [&]() {
        int mx = *(--sums.end());
        int mn = *sums.begin();
        return mx - mn;
    };

    auto query = [&]() {
        sums.clear();
        for (int i = 0; i < n / 2; i++) {
            sums.insert(a[i] + a[n - 1 - i]);
        }
        int ans = get();
        int m = n / 2;

        int cur = m - 1;
        for (int i = m + 1; i < n; i++) {
            sums.erase(sums.find(a[cur] + a[i]));
            sums.insert(a[cur] + a[i - 1]);
            ans = min(ans, get());
            cur--;
        }

        return ans;
    };

    int res = query();
    reverse(all(a));
    res = min(res, query());
    cout << res;

    return 0;
}
