#include <iostream>
#include <algorithm>
#include <numeric>
#include <vector>
#include <set>
#include <map>
#include <deque>

using namespace std;

#define all(a) (a).begin(), (a).end()
typedef long long ll;

int main() {
    ll q,w,e;
    cin>>q>>w>>e;
    vector<pair<ll,ll>>v(q);

    for (auto &[j, i] : v)  cin>>j>>i;

    deque<pair<ll, ll>>mn;
    mn.push_back({v[0].second, 0});

    for (int i = 1; i < q; i++) {
        auto [x, p] = v[i];
         ll k = v[i].first - v[i - 1].first;
         ll dlt = 0;
        while (mn.size() && w / mn.front().first && dlt < k) {
            ll f = min({k - dlt, e - (v[i - 1].first + dlt - mn.front().second) , w / mn.front().first});
            w -= mn.front().first * max(0LL, f);
            dlt += max(0LL, f);
             if (f == e - (v[i - 1].first + dlt - mn.front().second)) mn.pop_front();
        }
        while (mn.size() && mn.back().first > p) mn.pop_back();
        mn.push_back({p, x});


         if (dlt != k) {
             cout << v[i - 1].first + dlt;
             return 0;
         }
    }

    ll dlt = 0;
    while (mn.size() && w / mn.front().first) {
        ll f = min({e - (dlt + v.back().first - mn.front().second), w / mn.front().first});
        w -= mn.front().first * max(0LL, f);
        dlt += max(0LL, f);
        if (f == e - (dlt + v.back().first - mn.front().second)) mn.pop_front();
    }
    cout << v.back().first + dlt;
}
