#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

#define F first
#define S second
typedef long long ll;

int main(){
    int n, q;
    cin >> n >> q;
    vector<int> a(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    vector<pair<int, int> > b(q);
    for (int i = 0; i < q; i++) {
        cin >> b[i].first;
        b[i].second = i;
    }
    sort(b.begin(), b.end());
    vector<int> sum(n);
    sum[0] = a[0];
    for (int i = 1; i < n; i++) {
        sum[i] = sum[i - 1] + a[i] - a[i - 1] - 1;
    }
    sum.push_back(3e9);
    vector<int> ans(q);
    int j = 0;
    for (int i = 0; i < q; i++) {
        while (sum[j] < b[i].F) {
            j++;
        }
        if (j == 0) {
            ans[b[i].S] = b[i].F - 1;
        } else {
            ans[b[i].S] = a[j - 1] + b[i].F - sum[j - 1];
        }
    }
    for (int i = 0; i < q; i++) {
        cout << ans[i] << " ";
    }
    return 0;
}
