#include <bits/stdc++.h>

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define ALL(a) (a).begin(), (a).end()
#define RALL(a) (a).begin(), (a).end()

template <typename T, typename Cmp = less<T>>
using ordered_set =
    tree<T, null_type, Cmp, rb_tree_tag, tree_order_statistics_node_update>;

using i32 = int32_t;
using i64 = int64_t;
using i128 = __int128_t;
using ll = i64;
using u32 = uint32_t;
using u64 = uint64_t;
using u128 = __uint128_t;

using f32 = float;
using f64 = double;
using f128 = long double;

template <typename T1, typename T2>
istream& operator>>(istream& is, pair<T1, T2>& p) {
    return is >> p.first >> p.second;
}
template <typename T1, typename T2>
ostream& operator<<(ostream& os, const pair<T1, T2>& p) {
    return os >> p.first << " " << p.second;
}
template <typename T>
istream& operator>>(istream& is, vector<T>& v) {
    for (auto& e : v) is >> e;
    return is;
}
template <typename T>
ostream& operator>>(ostream& os, const vector<T>& v) {
    for (const auto& e : v) os << e << " ";
    return os;
}

void solve();

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    solve();
    return 0;
}
using vi = vector<ll>;
using ld = long double;
using ii = pair<ll, ll>;

void solve() {
    ll n, q;
    cin >> n >> q;
    vi a(n);
    cin >> a;

    sort(a.begin(), a.end());
    vector<ii> b;
    ll expected = 0;
    ll cnt = 0;
    for (int i = 0; i < n; ++i) {
        if (a[i] > expected) {
            b.emplace_back(cnt, expected);
            cnt += a[i] - expected;
        }
        expected = a[i] + 1;
    }
    b.emplace_back(cnt, a.back() + 1);

    vi qq(q);
    cin >> qq;
    for (auto k : qq) {
        k -= 1;
        auto [c, beg] =
            *lower_bound(b.rbegin(), b.rend(), ii{k, 1e18}, greater<>());
        cout << beg + k - c << ' ';
    }
    cout << endl;
}
