
#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;

#define MOD ll(1e9+7)
#define INF ll(1e18)
#define SIZE 1040

#define pb push_back
#define ppb pop_back
#define f first
#define s second

#define all(x) x.begin(), x.end()
#define vout(x) for (auto u : x) cout << u << ' ';
#define rndm drist(rng)

#define loop(i, n) for (ll i = 0; i < n; i ++)
#define loopone(i, n) for (ll i = 1; i <= n; i++)
#define loopb(i, n) for (ll i = n-1; i >= 0; i--)
#define loopbone(i, n) for (ll i = n; i > 0; i--)

//mt19937_64 rng(time(0));
//uniform_int_distribution<ll> dist;

ll n, m, k, i, j, x, y, z;
string str, trash;

char mapa[SIZE][SIZE];
ll col[SIZE][SIZE];
ll X, Y;
pair<ll, ll> lst[SIZE];
char ans[SIZE][SIZE];
vector<pair<ll, ll>> go = { {-1, 0}, {1, 0}, {0, 1}, {0, -1} };
pair<ll, ll> from[2][SIZE][SIZE];

ll good = 1;
ll lake = 1;
ll mx = -INF;
ll mn = INF;
ll mxy = -INF;
ll mny = INF;

void dfs(ll x, ll y, ll c) {
    col[x][y] = c;
    if (mx < x) {
        mx = x;
        mxy = y;
    }
    if (mn > x) {
        mn = x;
        mny = y;
    }
    for (auto u : go) {
        ll a = u.f + x;
        ll b = u.s + y;
        if (mapa[a][b] == 'a') good = 0;
        if (mapa[a][b] == '.' and !col[a][b]) dfs(a, b, c);
    }
}


void bfs(ll x, ll y, ll ind) {
    queue<pair<ll, ll>> q;
    from[ind][x][y] = make_pair(-1, -1);
    q.push(make_pair(x, y));

    while (q.size()) {
        auto [x, y] = q.front();
        q.pop();

        if (X == x and Y == y) break;

        for (auto u : go) {
            ll a = u.f + x;
            ll b = u.s + y;

            if (mapa[a][b] == '#' and from[ind][a][b].f == 0 and
                a <= mx and a >= mn) {
                q.push(make_pair(a, b));
                from[ind][a][b] = { x, y };
            }
        }
    }
}


int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    memset(mapa, int('a'), sizeof(mapa));
    memset(ans, int('.'), sizeof(ans));

    cin >> n >> m;
    loopone(i, n) loopone(j, m) cin >> mapa[i][j];

    loopone(i, n) loopone(j, m) if (mapa[i][j] == '.' and !col[i][j]) {
        good = 1;
        mx = -INF;
        mn = INF;
        mny = INF;
        mxy = -INF;
        dfs(i, j, lake);
        if (good) { i = INF; j = INF; break; }
        lake++;
    }

    mx++;
    mn--;

    X = mn;
    Y = mny;
    bfs(mx, mxy, 0);


    pair<ll, ll> nw = make_pair(X, Y);
    while (nw.f != -1) {
        ans[nw.f][nw.s] = '#';
        pair<ll, ll> nx = from[0][nw.f][nw.s];
        from[1][nw.f][nw.s] = { 1, 1 };
        nw = nx;
    }

    from[1][X][Y] = make_pair(0, 0);
    bfs(mx, mxy, 1);

    nw = make_pair(X, Y);
    while (nw.f != -1) {
        ans[nw.f][nw.s] = '#';
        pair<ll, ll> nx = from[1][nw.f][nw.s];
        nw = nx;

    }
    from[1][X][Y] = make_pair(0, 0);

    loopone(i, n) { cout << '\n'; loopone(j, m) cout << ans[i][j]; }

};