#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<ll, ll> ii;
typedef string str;

#define all(x) x.begin(), x.end()
#define fast ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define int ll

const ll inf = 1e16;

const int MOD = 1e9 + 7;

vector<vector<pair<int, int>>> g;

pair<vector<ll>, vector<ll>> dj(int s) {
    int n = g.size();
    vector<int> d(n, inf);
    vector<int> cnt(n);
    cnt[s] = 1;
    d[s] = 0;
    set<pair<int, int>> st;
    st.insert({d[s], s});
    while (!st.empty()) {
        auto [dist, v] = *st.begin();
        d[v] = dist;
        st.erase(st.begin());
        for (auto [u, w] : g[v]) {

            if (d[v] + w == d[u]) {
                cnt[u] = (cnt[u] + cnt[v]) % MOD;
            }
            if (d[v] + w < d[u]) {
                st.erase({d[u], u});
                cnt[u] = cnt[v];
                d[u] = d[v] + w;
                st.insert({d[v]+w, u});
            }
        }
    }
    return {d, cnt};
}

signed main() {
    fast;
    int n, m;
    cin >> n >> m;
    g.resize(n);
    ll s, t, L;
    cin >> s >> t >> L;
    s--;t--;
    for (int i = 0; i < m; i++) {
        int u, v, w;
        cin >> u >> v >> w;
        u--;v--;
        g[u].push_back({v, w});
        g[v].push_back({u, w});
    }
    auto [ds, cnts] = dj(s);
    auto [dt, cntt] = dj(t);
    if (L == ds[t]) {
        cout << cnts[t] << '\n';
        return 0;
    }
    vector<bool> used(n);
    queue<int> q;
    q.push(s);
    ll ans = 0;
    while (!q.empty()) {
        auto v = q.front();
        q.pop();
        for (auto [u, w] : g[v]) {
            if(ds[v] + w == ds[u])
                q.push(u);
        }
        for (auto [u, w] : g[v]) {
            if (ds[v] + w + dt[u] == L) {
                ans = (ans + (cnts[v] * cntt[u]) % MOD) % MOD;
            }
        }
    }
    cout << ans;
}