#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#define ll long long
#define sc second
#define fr first
#define all(arr) arr.begin(), arr.end()
#define rall(arr) arr.rbegin(), arr.rend()
#define pb push_back

//template<typename T, typename T2>
//istream& operator>>(istream& in, pair<T, T2> &a) {
//    in >> a.first >> a.second;
//    return in;
//}
//template<typename T, typename T2>
//ostream& operator<<(ostream& out, pair<T, T2> a) {
//    out << a.first << " " << a.second;
//    return out;
//}

//mt19937 rnd(time(0));

using namespace std;
using namespace __gnu_pbds;

const int N = 1010;
char cell[N][N];
int used[N][N];
int n, m, si = -1, sj;
vector <vector <int>> path;
vector <pair <int, int>> _next = { {-1,0}, {0,1}, {1,0}, {0,-1} };
vector <vector <vector <int>>> d = { { {0,1,1}, {-1,0,0}, {0,-1,3}, {1,0,2}},
                                     { {1,0,2}, {0,1,1}, {-1,0,0}, {0,-1,3}},
                                     { {0,-1,3}, {1,0,2}, {0,1,1}, {-1,0,0}},
                                     { {-1,0,0}, {0,-1,3}, {1,0,2}, {0,1,1}}};

int valid(int i, int j)
{
    return (1 <= i && i <= n && 1 <= j && j <= m && cell[i][j] == '#');
}

void dfs(int i, int j, int dir)
{
    path.pb({i,j,dir});
    used[i][j] = 1;
    for (auto v : d[dir])
    {
        if (i+v[0] == si && j+v[1] == sj)
            return;
        if (valid(i+v[0], j+v[1]))
        {
            dfs(i+v[0], j+v[1], v[2]);
            return;
        }
    }
}

void solve() {
    cin >> n >> m;
    for (int i = 1; i <= n; ++i)
    {
        for (int j = 1; j <= m; ++j)
        {
            cin >> cell[i][j];
            if (cell[i][j] == '.' && i && cell[i-1][j] == '#' && si == -1)
                si = i-1, sj = j;
        }
    }
    dfs(si, sj, 1);
    for (int k = 0; k < path.size(); ++k)
    {
        if (k < path.size() - 1 && path[k][2] != path[k+1][2])
        {
            int dir = path[k][2];
            int i = path[k][0], j = path[k][1];
            while (valid(i+_next[dir].first, j+_next[dir].second) && !used[i+_next[dir].first][j+_next[dir].second])
            {

                i+=_next[dir].first, j+=_next[dir].second;
            }
            if (used[i+_next[dir].first][j+_next[dir].second])
            {
                for (int x = path[k][0]; x <= i; ++x)
                {
                    for (int y = path[k][1]; y <= j; ++y)
                        used[x][y] = 2;
                }
                ++k;
                while (k < path.size() && (path[k][0] != i || path[k][1] != j))
                {
                    ++k;
                }
            }
            else
                used[path[k][0]][path[k][1]] = 2;
        }
        else
        {
            used[path[k][0]][path[k][1]] = 2;
        }
    }
    for (int i = 1; i <= n; ++i)
    {
        for (int j = 1; j <= m; ++j)
        {
            cout << (used[i][j] == 2? '#':'.');
        }
        cout << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    int tt = 1;
//    cin >> t;
    while (tt--)
    {
        solve();
    }
}