#include <bits/stdc++.h>

using namespace std;

#define int long long
#define ld long double
#define VI vector<int>
#define PAR pair<int,int>
#define VP vector<PAR>
#define x first
#define y second

template<class T>
istream& operator>>(istream& in, vector<T>& v) {
    for (int i = 0; i < v.size(); ++i) {
        in >> v[i];
    }
    return in;
}

signed main() {
    cout.precision(16);

    int n, b, c;
    cin >> n >> b >> c;
    VI vx(n), vp(n);
    //cin >> vx >> vp;
    for (int i = 0; i < n; ++i) {
        cin >> vx[i] >> vp[i];
    }
    VI vnext(n);
    vector<pair<int, int>> stack;
    for (int i = 0; i < n; ++i) {
        int p = vp[i];
        while (!stack.empty() && stack.back().first > p) {
            vnext[stack.back().second] = i;
            stack.pop_back();
        }
        stack.emplace_back(p, i);
    }

    while (!stack.empty()) {
        vnext[stack.back().second] = n;
        stack.pop_back();
    }

    int currPos = 0, currFuel = 0;
    for (int i = 0; i < n; ++i) {
        if (currPos < vx[i]) break;
        int next = vnext[i];
        int avail = b / vp[i];
        if (next != n && vx[next] - currPos <= min(c, currFuel + avail)) {
            int dFuel = max(vx[next] - currPos - currFuel, 0ll);
            b -= dFuel * vp[i];
            currFuel += dFuel - (vx[next] - currPos);
            currPos = vx[next];
            i = next - 1;
        } else {
            int dFuel = min(c - currFuel, avail);
            b -= dFuel * vp[i];
            if (i != n - 1 && vx[i + 1] - currPos <= currFuel + dFuel) {
                currFuel += dFuel - (vx[i + 1] - currPos);
                currPos = vx[i + 1];
            } else currPos += currFuel + dFuel;
        }
        assert(b >= 0);
        assert(currFuel >= 0);
    }
    cout << currPos << endl;

    /*int n,q;
    cin>>n>>q;
    VI a(n);
    map<int,int> m;
    for(auto& i: a){
        cin>>i;
        m[i]=1;
    }
    VP qes(q);
    for(int i=0;i<q;++i){
        cin>>qes[i].x;
        qes[i].y=i;
    }

    VI ans(q,0);
    sort(qes.begin(),qes.end());
    int tec=0,pred=0;
    for(auto i:qes){
        i.x--;
        int dif=i.x-pred;
//        if(tec==-1){
//            int ind= upper_bound(a.begin(),a.end(),tec+dif)-upper_bound(a.begin(),a.end(),tec-1);
//        }
        int ind= upper_bound(a.begin(),a.end(),tec+dif)-upper_bound(a.begin(),a.end(),tec-1);
        tec+=dif+ind;
        while(m[tec]){
            tec++;
        }
        ans[i.y]=tec;
        pred=i.x;
    }
    for(auto i:ans){
        cout<<i<<' ';
    }
    cout<<endl;/*

    int n;
    cin >> n;
    VI va(n);
    cin >> va;
    sort(va.begin(), va.end());
    for (int i = 0; i < n; ++i) {
        int minp = 2000000000000;
        int maxp = 0;
        for (int j = 0; j < n; ++j) {
            int k = n - j - 1;
            if (j >= i) k++;
            if (j >= n - i) k--;
        }
    }
     */
    return 0;
}
