#include <bits/stdc++.h>

#define ff first
#define ss second
#define int long long
#define pb push_back
#define  all(x) x.begin(), x.end()
#define err(x) cerr << "["#x"] " << (x) << "\n"
#define errv(x) {cerr << "["#x"] "; for(auto &_ : (x)) cerr << _ << ", "; cerr << "\n";}
#define errvn(x, n) {cerr << "["#x"] "; for(int _ = 0;_ < n;_++) cerr << (x)[_] << ", "; cerr << "\n";}

using namespace std;
using ll = long long;
const int MOD = 1e9 + 7;
mt19937 rnd(std::chrono::high_resolution_clock::now().time_since_epoch().count());

template<typename T1, typename T2>
inline bool relaxmi(T1 &a, const T2 &b) {
    return a > b ? a = b, true : false;
}

/**
const int N = 1e5 + 7;
const int INF = 1e9 + 7;

pair<int, int> tree[2 * N];
pair<int, int> vec[N];

void build(int l = 0, int r = N, int x = 0) {
    if (r - l == 1) {
        tree[x] = {vec[l].second, l};
        return;
    }
    int mid = (l + r) / 2;
    build(l, mid, x + 1);
    build(mid, r, x + 2 * (mid - l));
    tree[x] = min(tree[x + 1], tree[x + 2 * (mid - l)]);
}

pair<int, int> get(int l, int r, int lx = 0, int rx = N, int x = 0) {
    if (l <= lx and rx <= r) {
        return tree[x];
    }
    if (lx >= r or l >= rx) {
        return {INF, INF};
    }
    int mid = (lx + rx) / 2;
    return min(get(l, r, lx, mid, x + 1), get(l, r, mid, rx, x + 2 * (mid - lx)));
}
**/

void solve() {
    int n;
    ll b, c;
    cin >> n >> b >> c;
    vector<pair<int, int> > a(n);
    for (int i = 0; i < n; ++i) {
        int x, p;
        cin >> x >> p;
        a[i] = {x, p};
    }
    ///build();
    vector<int> nxt(n, n);
    vector<int> st;
    for (int i = 0; i < n; ++i) {
        while (!st.empty() && a[st.back()].second >= a[i].second) {
            nxt[st.back()] = i;
            st.pop_back();
        }
        st.emplace_back(i);
    }
    ll have = 0;
    ll can = b;
    for (int i = 0; i < n - 1; ++i) {
        ///cout << i << ": " << can << ' ' << have << endl;
        if (c < a[i + 1].first - a[i].first || a[i + 1].first - a[i].first > can / a[i].ss + have) {
            cout << a[i].first + min(c, have + can / a[i].ss);
            ///cout << "first" << endl;
            return;
        }
        int j = nxt[i];
        ///cout << i << "->" << j << endl;
        if (j == n || c < a[j].first - a[i].first || a[j].first - a[i].first > can / a[i].ss + have) {
            ll delta = min(can / a[i].ss, c - have);
            have += delta;
            can -= delta * a[i].ss;
            have -= a[i + 1].first - a[i].first;
            continue;
        }
        ll add = max(0ll, a[j].first - a[i].first - have);
        ///cout << i << ":: " << add << endl;
        can -= add * a[i].ss;
        have += add;
        have -= a[j].first - a[i].first;
        i = j - 1;
        continue;
    }
    ///cout << c << ' ' << can << ' ' << have << endl;
    cout << a[n - 1].first + min(c, can / a[n - 1].ss + have);
    return;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr);
    cin.tie(nullptr);
    solve();
}