#include <bits/stdc++.h>

#define ff first
#define ss second
#define int long long
#define pb push_back
#define  all(x) x.begin(), x.end()
#define err(x) cerr << "["#x"] " << (x) << "\n"
#define errv(x) {cerr << "["#x"] "; for(auto &_ : (x)) cerr << _ << ", "; cerr << "\n";}
#define errvn(x, n) {cerr << "["#x"] "; for(int _ = 0;_ < n;_++) cerr << (x)[_] << ", "; cerr << "\n";}

using namespace std;
using ll = long long;
const int MOD = 1e9 + 7;
mt19937 rnd(std::chrono::high_resolution_clock::now().time_since_epoch().count());

template<typename T1, typename T2>
inline bool relaxmi(T1 &a, const T2 &b) {
    return a > b ? a = b, true : false;
}

const int N = 1e3 + 7;
char field[N][N];
char field2[N][N];

bool used_1[N][N];
int n, m;

void bfs1(int x, int y) {
    queue<pair<int, int>> que;
    que.push({x, y});
    used_1[x][y] = true;
    while (!que.empty()) {
        pair<int, int> now = que.front();
        que.pop();
        vector<int> dx = {0, 0, -1, 1}, dy = {-1, 1, 0, 0};
        for (int i = 0; i < 4; ++i) {
            int newx = dx[i] + now.first;
            int newy = dy[i] + now.second;
            if (newx >= n or newy >= m or newx < 0 or newy < 0) {
                continue;
            }
            if (used_1[newx][newy] or field[newx][newy] == '#' )continue;
            used_1[newx][newy] = true;
            que.push({newx, newy});
        }
    }
}

void solve() {
    cin >> n >> m;
    for (int i = 0; i < n; ++i) {
        for (int j= 0 ; j < m; ++j) {
            cin >> field[i][j];
        }
    }
    for (int i = 0; i < n; ++i) {
        if (field[i][0] == '.') bfs1(i, 0);
        if (field[i][m - 1] == '.') bfs1(i, m - 1);
    }
    for (int i = 0; i < m; ++i) {
        if (field[0][i] == '.') bfs1(0, i);
        if (field[n - 1][i] == '.') bfs1(n - 1, i);
    }
    queue<pair<int, int>> que;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
//            cout << used_1[i][j] << " ";
            que.push({i, j});
        }
//        cout << endl;
    }
    while (!que.empty()) {
        pair<int, int> now = que.front();
        que.pop();
        int i = now.first;
        int j = now.second;
        if (field[i][j] == '#') {
            int cnt = 0;
            vector<int> dx = {0, 0, -1, 1}, dy = {-1, 1, 0, 0};
            for (int k = 0; k < 4; ++k) {
                int newx = dx[k] + i;
                int newy = dy[k] + j;
                if (newx >= n or newy >= m or newx < 0 or newy < 0 or field[newx][newy] == '#') {
                    continue;
                }
                if (!used_1[newx][newy] ) {
                    cnt++;
                }
            }
            if (cnt >= 3) {
                field[i][j] = '.';
//                used_1[i][j] = true;
                for (int k = 0; k < 4; ++k) {
                    int newx = dx[k] + i;
                    int newy = dy[k] + j;
                    if (newx >= n or newy >= m or newx < 0 or newy < 0) {
                        continue;
                    }
                    que.push({newx, newy});
                }
            }
        }
    }

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
//            cout << field[i][j];
            field2[i][j] = '.';
        }
//        cout << endl;
    }

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (used_1[i][j] or field[i][j] == '#') continue;
            vector<int> dx = {0, 0, -1, 1}, dy = {-1, 1, 0, 0};
            for (int k = 0; k < 4; ++k) {
                int newx = dx[k] + i;
                int newy = dy[k] + j;
                if (newx >= n or newy >= m or newx < 0 or newy < 0) {
                    continue;
                }
                if (field[newx][newy] == '#') {
                    field2[newx][newy] = '#';
                }
            }
            vector<int> dx2 = {1, 1, -1, -1}, dy2 = {-1, 1, -1, 1};
            for (int k = 0; k < 4; ++k) {
                int newx = dx2[k] + i;
                int newy = dy2[k] + j;
                if (newx >= n or newy >= m or newx < 0 or newy < 0) {
                    continue;
                }
                if (field[newx][newy] == '#') {
                    field2[newx][newy] = '#';
                }
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cout << field2[i][j];
        }
        cout << "\n";
    }

}

signed main() {
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr);
    cin.tie(nullptr);
    solve();
}