#include <bits/stdc++.h>

#include <random>

#define ff first
#define ss second
#define int long long
#define pb push_back
#define  all(x) x.begin(), x.end()
#define err(x) cerr << "["#x"] " << (x) << "\n"
#define errv(x) {cerr << "["#x"] "; for(auto &_ : (x)) cerr << _ << ", "; cerr << "\n";}
#define errvn(x, n) {cerr << "["#x"] "; for(int _ = 0;_ < n;_++) cerr << (x)[_] << ", "; cerr << "\n";}

using namespace std;
using ll = long long;
const int MOD = 1e9 + 7;
mt19937 rnd(std::chrono::high_resolution_clock::now().time_since_epoch().count());

template<typename T1, typename T2>
inline bool relaxmi(T1 &a, const T2 &b) {
    return a > b ? a = b, true : false;
}


void solve() {
    int n;
    cin >> n;
    int here = 2 * sqrt(n);
    vector<int> razm;
    for (int i = 1; i < here; ++i) {
        razm.push_back(here / i);
    }
    vector<int> now(n);
    iota(now.begin(), now.end(), 0);
    razm.resize(unique(razm.begin(), razm.end()) - razm.begin());
    vector<vector<bool>> can(n, vector<bool> (n, true));
    for (int i = 0; i < 3; ++i) {
        vector<int> asks(n);
        shuffle(now.begin(), now.end(), std::mt19937(std::random_device()()));
        int ind = 0;
        int col = 0;
        for (auto c: now) {
            if (ind == razm.size()) {
                asks[c] = ind - 1;
            } else {
                asks[c] = ind;
                col++;
                if (col == razm[ind]) {
                    ind++;
                    col = 0;
                }
            }
        }
        if (ind == now.size()) ind--;
        cout << ind + 1 << " ";
        map<int, vector<int>> mp;
        int ind2 = 0;
        for (auto c : asks) {
            cout << c + 1 << " ";
            mp[c].push_back(ind2);
            ind2++;
        }
        cout << endl;
        for (int j = 0; j < ind + 1; ++j) {
            int s;
            cin >> s;
            vector<int> here2;
            for (int k =0; k < s; ++k) {
                int a;
                cin >> a;
                here2.push_back(a);
            }
            for (const auto& c : mp) {
                if (c.second.size() == s) {
                    vector<bool> here3(n, false);
                    for (int k2 = 0; k2 < s; ++k2) {
                        here3[here2[k2]] = true;
                    }
                    for (int k = 0; k < n; ++k) {
                        if (!here3[k]) {
                            can[i][k] = false;
                        }
                    }
                }
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        vector<int> now2;
        for (int j = 0; j < n; ++j) {
            if (can[i][j]) now2.push_back(j);
        }
        cout << now2[rnd() % now2.size()] + 1 << " ";
    }
}


signed main() {
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr);
    cin.tie(nullptr);
    solve();
}