#include<iostream>
#include<algorithm>
#include <vector>
#include <set>
#include <queue>
using namespace std;

typedef long long ll;

vector<vector<pair<ll, ll>>>g;
vector<vector<bool>>ban;

vector<ll> dei(ll s, vector<ll>& d) {
	d[s] = 0;
	set<pair<ll, ll>>q;
	q.insert({ 0, s });
	vector<ll>p;
	while (!q.empty()) {
		ll v = q.begin()->second;
		p.push_back(v);
		q.erase(q.begin());
		for (auto u : g[v]) {
			if (d[u.first] > d[v] + u.second) {
				q.erase({ d[u.first], u.first });
				d[u.first] = d[v] + u.second;
				q.insert({ d[u.first], u.first });
			}
		}
	}
	return p;
}
ll mod = 1e9 + 7;

ll inf = 1e18;
ll solve_B(ll n, ll m, ll s, ll t, ll L) {
	ban.resize(n);
	for (ll i = 0; i < n; i++) {
		ban[i].resize(g[i].size());
	}
	vector<ll>ds(n, inf), dt(n, inf);
	vector<ll>ps = dei(s, ds);
	vector<ll>pt = dei(t, dt);
	vector<ll>cnts(n, 0), cntt(n, 0);
	cntt[t] = 1;
	for (auto v : pt) {
		for (ll i = 0; i < g[v].size(); i++) {
			if (cntt[g[v][i].first] != 0 && g[v][i].second + dt[g[v][i].first] == dt[v]) {
				cntt[v] = (cntt[g[v][i].first] + cntt[v]) % mod;
			}
		}
	}
	cnts[s] = 1;
	for (auto v : ps) {
		for (ll i = 0; i < g[v].size(); i++) {
			if (cnts[g[v][i].first] != 0 && g[v][i].second + ds[g[v][i].first] == ds[v]) {
				cnts[v] = (cnts[g[v][i].first] + cnts[v]) % mod;
			}
		}
	}
	for (auto v : pt) {
		for (ll i = 0; i < g[v].size(); i++) {
			if (ds[v] + g[v][i].second + dt[g[v][i].first] == dt[s]) {
				ban[v][i] = true;
			}
		}
	}
	ll ans = 0;
	if (dt[s] == L)
		ans = cntt[s];
	for (ll v = 0; v < n; v++) {
		if (ds[v] + dt[v] == ds[t]) {
			for (ll i = 0; i < g[v].size(); i++) {
				if (ban[v][i])
					continue;
				if (ds[v] + g[v][i].second + dt[g[v][i].first] == L)
					ans = (ans + cnts[v] * cntt[g[v][i].first] % mod) % mod;
			}
		}
	}
	return ans;
}

int main() {
	ll n, m, s, t;
	ll L;
	cin >> n >> m >> s >> t >> L;
	s--, t--;
	g.resize(n);
	for (ll i = 0; i < m; i++) {
		ll v, u, c;
		cin >> v >> u >> c;
		v--, u--;
		g[v].push_back({ u, c });
		g[u].push_back({ v, c });
	}
	cout << solve_B(n, m, s, t, L);
	return 0;
}