#include<iostream>
#include<algorithm>
#include <vector>

using namespace std;

typedef long long ll;

int main() {
	int n, q;
	cin >> n >> q;
	vector<int>arr(n);
	for (auto& i : arr)
		cin >> i;
	sort(arr.begin(), arr.end());
	vector<pair<int, int>>len;
	if (arr[0] != 0)
		len.push_back({ -1, arr[0] });
	for (int i = 1; i < n; i++) {
		if (arr[i] - 1 != arr[i-1]) {
			len.push_back({ arr[i - 1], arr[i] - arr[i - 1] - 1 });
		}
	}
	vector<int>pref(len.size());
	for (int i = 0; i < len.size(); i++) {
		pref[i] = len[i].second + (i == 0 ? 0 : pref[i - 1]);
	}
	while (q--) {
		int ind; cin >> ind;
		if (pref.empty() || ind > pref.back()) {
			cout << arr.back() + ind - (pref.empty() ? 0 : pref.back()) << ' ';
			continue;
		}
		int l = -1, r = pref.size() + 1;
		while (l + 1 != r) {
			int m = (l + r) / 2;
			if (pref[m] >= ind)
				r = m;
			else
				l = m;
		}
		cout << len[r].first + (ind - (r == 0 ? 0 : pref[r - 1])) << ' ';
	}
	return 0;
}