#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;
using namespace std;

using ll = long long;
using ld = long double;

template<typename T>
using pqg = priority_queue<T, vector<T>, greater<T>>;


#define int long long
#define fastIo(a) ios_base::sync_with_stdio(a); cin.tie(a); cout.tie(a)
#define all(a) a.begin(), a.end()
#define F first
#define S second
#define sz(a) (int)a.size()

void solve() {
    int n, q;
    cin >> n >> q;

    vector<int> a(n + 2);
    for (int i = 1; i < n + 1; i++) {
        cin >> a[i];
    }

    a[0] = -1;
    a[n + 1] = 2e9;

    vector<pair<int, int>> d;

    for (int i = 1; i < n + 2; i++) {
        if (a[i] - a[i - 1] > 1) {
            d.emplace_back(a[i] - a[i - 1] - 1, a[i] - 1);
        }
    }

    vector<int> pref(d.size() + 1);
    pref[0] = 0;
    for (int i = 1; i < (int) d.size() + 1; i++) {
        pref[i] = pref[i - 1] + d[i - 1].first;
    }

    while (q--) {
        int k;
        cin >> k;
        int l = 0, r = (int) d.size();
        while (r - l > 1) {
            int m = l + (r - l) / 2;
            if (k <= pref[m]) {
                r = m;
            } else {
                l = m;
            }
        }

//        cout << l << "\n";

        cout << d[l].second - (pref[r] - k) << " ";
    }
    cout << "\n";
}

int32_t main() {
    cout << fixed << setprecision(20);
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}
