#include <bits/stdc++.h>

using namespace std;

#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

typedef long long ll;
typedef __int128 int128;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

//#define int ll

const char en = '\n';
const int INF = 1e9 + 7;
const int INFLL = 1e18;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

#ifdef LOCAL
#include "debug.h"
#else
#define debug(...) 42
#endif

void solve() {
    int n;
    cin >> n;
    vector<array<int, 3>> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i][0] >> a[i][1] >> a[i][2];
    }
    map<pair<pii, pii>, map<int, set<int>>> govno;

    auto add = [&](pii t1, pii t2, int c, int i, int j) {
        for (int iter1 = 0; iter1 < 2; ++iter1) {
            for (int iter2 = 0; iter2 < 2; ++iter2) {
                govno[{t1, t2}][c].emplace(i);
                govno[{t1, t2}][c].emplace(j);

                govno[{t2, t1}][c].emplace(i);
                govno[{t2, t1}][c].emplace(j);

                swap(t2.first, t2.first);
            }
            swap(t1.first, t2.first);
        }
    };

    auto make_t = [&](int i, int k) {
        pii t = {-1, -1};
        if (k == 0) {
            t = {a[i][1], a[i][2]};
        } else if (k == 1) {
            t = {a[i][0], a[i][2]};
        } else {
            t = {a[i][1], a[i][2]};
        }
        return t;
    };

    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            for (int k1 = 0; k1 < 3; ++k1) {
                for (int k2 = 0; k2 < 3; ++k2) {
                    if (a[i][k1] == a[j][k2]) {
                        pii t1 = make_t(i, k1);
                        pii t2 = make_t(j, k2);
                        add(t1, t2, a[i][k1], i, j);
                    }
                }
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        int A = a[i][0], B = a[i][1], C = a[i][2];
        for (int j = i + 1; j < n; ++j) {
            for (int k = 0; k < 3; ++k) {
                if (a[j][k] == A) {
                    auto t = make_t(j, k);
                    int D = t.first, F = t.second;
                    for (auto &mp : govno[{{B, D}, {C, F}}]) {
                        vector<int> kek;
                        for (auto &x : mp.second) {
                            if (x != i && x != j) {
                                kek.emplace_back(x);
                            }
                            if (sz(kek) == 2) {
                                break;
                            }
                        }
                        if (sz(kek) == 2) {
                            cout << "Yes" << en;
                            cout << i + 1 << ' ' << j + 1 << ' ';
                            cout << kek[0] + 1 << ' ' << kek[1] + 1 << en;
                            return;
                        }
                    }
                }
            }
        }
    }
    cout << "No" << en;
}

int32_t main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    solve();
    return 0;
}
