#include <bits/stdc++.h>

#define fr(i, a, b) for (int i = (a); i <= (b); ++i)
#define rf(i, a, b) for (int i = (a); i >= (b); --i)
#define fe(x, y) for (auto& x : y)

#define fi first
#define se second
#define pb push_back
#define mp make_pair
#define mt make_tuple

#define all(x) (x).begin(), (x).end()
#define sz(x) (int)(x).size()
#define pw(x) (1LL << (x))

using namespace std;

mt19937_64 rng(228);

#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;
template <typename T>
using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
#define fbo find_by_order
#define ook order_of_key

template <typename T>
bool umn(T& a, T b) {
    return a > b ? a = b, 1 : 0;
}
template <typename T>
bool umx(T& a, T b) {
    return a < b ? a = b, 1 : 0;
}

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
template <typename T>
using ve = vector<T>;

const int N = 4e5 + 5;

const int MOD = 1e9 + 7;

int add(int a, int b) {
    a += b;
    if (a >= MOD) {
        return a - MOD;
    }
    return a;
}

int mult(int a, int b) {
    return 1LL * a * b % MOD;
}

//int dp[N];

int n, m;
int s, t;
ll L;
ll dist[N], dist2[N];

int dp[N], dpR[N];
ve<pii> g[N];
ve<int> G[N];
ve<int> GR[N];
ve<array<int, 3>> e;

ve<int> order;
bool vis[N];

void tsort(int v) {
    vis[v] = 1;
    fe (to, G[v]) {
        if (vis[to]) continue;
        tsort(to);
    }
    order.pb(v);
}

void tsort2(int v) {
    vis[v] = 1;
    fe (to, GR[v]) {
        if (vis[to]) continue;
        tsort2(to);
    }
    order.pb(v);
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios::sync_with_stdio(0);
    cin.tie(0);
#endif

    cin >> n >> m;

    cin >> s >> t >> L;

    fr (i, 1, m) {
        int a, b, w;
        cin >> a >> b >> w;

        g[a].pb({b, w});
        g[b].pb({a, w});
        e.pb({a, b, w});
    }


    {
        set<pll> q;
        fill(dist, dist + 1 + n, ll(1e18));

        dist[s] = 0;
        q.insert({0LL, s});

        while (sz(q)) {
            int v = q.begin()->se;
            q.erase(q.begin());

            fe (to, g[v]) {
                if (dist[to.fi] > dist[v] + to.se) {
                    q.erase({dist[to.fi], to.fi});
                    dist[to.fi] = dist[v] + to.se;
                    q.insert({dist[to.fi], to.fi});
                }
            }
        }

        fe (cur, e) {
            if (dist[cur[0]] + cur[2] == dist[cur[1]]) {
                G[cur[0]].pb(cur[1]);
            }
            swap(cur[0], cur[1]);
            if (dist[cur[0]] + cur[2] == dist[cur[1]]) {
                G[cur[0]].pb(cur[1]);
            }
        }
    }

    fr (i, 1, n) {
        if (!vis[i]) {
            tsort(i);
        }
    }
    reverse(all(order));

    dp[s] = 1;

    fe (v, order) {
        fe (to, G[v]) {
            dp[to] = add(dp[to], dp[v]);
        }
    }

    {
        set<pll> q;
        fill(dist2, dist2 + 1 + n, ll(1e18));

        dist2[t] = 0;
        q.insert({0LL, t});

        while (sz(q)) {
            int v = q.begin()->se;
            q.erase(q.begin());

            fe (to, g[v]) {
                if (dist2[to.fi] > dist2[v] + to.se) {
                    q.erase({dist2[to.fi], to.fi});
                    dist2[to.fi] = dist2[v] + to.se;
                    q.insert({dist2[to.fi], to.fi});
                }
            }
        }

        fe (cur, e) {
            if (dist2[cur[0]] + cur[2] == dist2[cur[1]]) {
                GR[cur[0]].pb(cur[1]);
            }
            swap(cur[0], cur[1]);
            if (dist2[cur[0]] + cur[2] == dist2[cur[1]]) {
                GR[cur[0]].pb(cur[1]);
            }
        }
    }

//    return 0;
//    fr (i, 1, n) {
//        fe (to, GR[i]) {
//            cout << i << " " << to << "\n";
//        }
//    }

    order.clear();
    fill(vis + 1, vis + 1 + n, 0);
    fr (i, 1, n) {
        if (!vis[i]) {
            tsort2(i);
        }
    }
    reverse(all(order));

    dpR[t] = 1;
    fe (v, order) {
        fe (to, GR[v]) {
            dpR[to] = add(dpR[to], dpR[v]);
        }
    }

//    cout << sz(GR[6]) << "\n";
//    fr (i, 1, n) cout << dp[i] << " ";
//    cout << "\n";

    if (L == dist[t]) {
        cout << dp[t] << "\n";
        return 0;
    }

    int ans = 0;
    fe (cur, e) {
        ll w = dist[cur[0]] + cur[2] + dist2[cur[1]];

//        cout << w << "\n";

        if (cur[0] != t && dist2[cur[0]] + dist[cur[0]] == dist[t] && w == L) {
//            cout << cur[0] << " " << cur[1] << "\n";
            ans = add(ans, mult(dp[cur[0]], dpR[cur[1]]));
        }
        swap(cur[0], cur[1]);


        w = dist[cur[0]] + cur[2] + dist2[cur[1]];
//        cout << w << "\n";
        if (cur[0] != t && dist2[cur[0]] + dist[cur[0]] == dist[t] && w == L) {
//            cout << cur[0] << " " << cur[1] << "\n";
//            cout << dp[cur[0]] << " " << dpR[cur[1]] << "\n";
            ans = add(ans, mult(dp[cur[0]], dpR[cur[1]]));
        }
    }

    cout << ans << "\n";

    return 0;
}
