#include <iostream>
#include <iomanip>
#include <vector>

#include <algorithm>

using namespace std;

typedef long long ll;
typedef long double ld;

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	ll n, q;
	cin >> n >> q;

	vector<ll> a(n);
	for (auto& t : a)
		cin >> t;

	vector<pair<ll, ll>> k(q);
	vector<ll> res(q);
	for (ll i = 0; i < q; ++i) {
		cin >> k[i].first;
		k[i].second = i;
	}

	a.push_back(-1);
	a.push_back(1e17);
	n += 2;
	sort(a.begin(), a.end());
	sort(k.begin(), k.end());

	
	ll i = 0;
	ll cnt = 0;
	for (auto& [t, j] : k) {
		while (cnt + a[i + 1] - a[i] - 1 < t) {
			cnt += a[i + 1] - a[i] - 1;
			++i;
		}
		res[j] = a[i] + (t - cnt);
	}

	for (auto& t : res)
		cout << t << ' ';
}