#include <bits/stdc++.h>

#define all(x) (x).begin(), (x).end()
#define rep(i, a, b) for( auto i = a; i < b; i++)
#define forall(i, x) for(auto& i: x)
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) ((int)x.size())

using ll = long long;
using ld = long double;
using ull = unsigned long long;

using namespace std;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

int test = 0;

void fast() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
}

const ll N = 2e5;
const ll INF = 4e9;
ll a[N], pref[N];
pair<ll, ll> info[N];

void solve() {
    ll n, q;
    cin >> n >> q;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    ll lst = 0, SZ = 1;
    for (int i = 0; i < n; i++) {
        ll now = a[i] - 1;
        if (lst <= now) {
            info[SZ++] = {lst, now};
        }
        lst = a[i] + 1;
    }
    info[SZ++] = {lst, INF};
    for (int i = 1; i < SZ; i++) {
        if (i)
            pref[i] = pref[i - 1];
        pref[i] += info[i].second - info[i].first + 1;
    }

    for (int i = 0; i < q; i++) {
        ll k;
        cin >> k;
        ll l = 0, r = SZ; //MEOW
        while (r - l > 1) {
            ll mid = (r + l) / 2;
            if (pref[mid] < k)
                l = mid;
            else
                r = mid;
        }
        k -= pref[l];
        l++;
        cout << info[l].first + k - 1 << ' ';
    }
}

int main() {
    fast();
    int t = 1;
    if (test) cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
