#include <bits/stdc++.h>
#define int long long

using namespace std;
typedef long long ll;
typedef long double ld;

const ll INF = 1e18;
const ll MOD = 1e9 + 7;

void dijkstra(vector <vector <pair <int, ll>>> &graph, vector <ll> &distances, vector<ll> &niggers, int start) {
    distances[start] = 0;
    niggers[start] = 1;

    set <pair <ll, int>> ass;
    ass.emplace(0, start);

    while (!ass.empty()) {
        auto [d, u] = *ass.begin();
        ass.erase(ass.begin());

        for (auto [v, w]: graph[u]) {
            if (distances[v] > d + w) {
                ass.erase({distances[v], v});
                distances[v] = d + w;
                niggers[v] = niggers[u];
                ass.emplace(distances[v], v);
            } else if (distances[v] == d + w) {
                niggers[v] = (niggers[v] + niggers[u]) % MOD;
            }

        }
    }
}

void solve() {
    int n, m;
    cin >> n >> m;

    ll s, t, L;
    cin >> s >> t >> L;
    s--, t--;

    ll u, v, w;
    vector <vector <pair <int, ll>>> graph(n);
    for (int i = 0; i < m; i++) {
        cin >> u >> v >> w;
        u--, v--;

        graph[u].emplace_back(v, w);
        graph[v].emplace_back(u, w);
    }

    vector <ll> ds(n, INF), dt(n, INF), nigs(n), nigt(n);
    dijkstra(graph, ds, nigs, s);
    dijkstra(graph, dt, nigt, t);

    if (ds[t] == L) {
        cout << nigs[t] << '\n';
        return;
    }

    ll answer = 0;
    for (int i = 0; i < n; i++) {
        if (ds[i] + dt[i] != ds[t])
            continue;

        for (auto [v, w]:  graph[i]) {
            if (ds[i] + w + dt[v] == L) {
                answer = (answer + nigs[i] * nigt[v] % MOD) % MOD;
            }
        }
    }

    cout << answer << '\n';
}

signed main() {
    cin.tie(NULL);
    ios_base::sync_with_stdio(false);

    #ifdef local
    freopen("input", "r", stdin);
    #endif // local

    solve();
}
