#include <bits/stdc++.h>
#define int long long

using namespace std;
typedef long long ll;
typedef long double ld;

const ll INF = 1e18;
const ll MOD = 1e9 + 7;

void solve() {
    int n, B, C;
    cin >> n >> B >> C;

    map <int, int> x2p;
    vector <pair <int, int>> slaves(n);
    for (auto &[p, x]: slaves) {
        cin >> x >> p;
        x2p[x] = p;
    }

    sort(slaves.begin(), slaves.end());

    set <pair <int, int>> seen;
    for (auto &[p, x]: slaves) {
        auto it = seen.lower_bound({x, 0});

        int km = C;
        if (it != seen.end()) {
            auto [next_x, next_km] = *it;
            km = min(km, next_x - x);
        }

        if (it != seen.begin()) {
            auto [prev_x, prev_km] = *prev(it);

            if (prev_x + prev_km > x) {
                km -= ((prev_x + prev_km) - x);
            }
        }

        if (km <= 0)
            continue;

        seen.emplace(x, km);
    }

    int curr_x = 0;
    set <pair <int, int>> niggers;
    while (!seen.empty() || !niggers.empty()) {
        while (!seen.empty() && seen.begin()->first <= curr_x) {
            niggers.emplace(seen.begin()->second, seen.begin()->first);
            seen.erase(seen.begin());
        }

        if (niggers.empty())
            break;

        auto [km, x] = *niggers.begin();
        niggers.erase(niggers.begin());

        int p = x2p[x];
        int can_buy = B / p;

        km = min(km, can_buy);

        if (km <= 0)
            continue;

        curr_x += km;
        B -= km * p;
    }

    cout << curr_x << '\n';
}

signed main() {
    cin.tie(NULL);
    ios_base::sync_with_stdio(false);

    #ifdef local
    freopen("input", "r", stdin);
    #endif // local

    solve();
}
