#include <bits/stdc++.h>

using namespace std;

#define ld long double
#define int long long
#define ff first
#define ss second

const int INF = 1e18 + 5;
const int MOD = 1e9 + 7;

int k;
int mn;
vector<int> us;
vector< vector< pair<int, int> > > g;
vector< pair<int, int> > dpf, dps;

int ans = 0;

void dfs(int v) {
    us[v] = 1;
    for (auto &[to, w] : g[v]) {
        if (dps[to].ff + dpf[to].ff != mn)
            continue;
        if (w + dps[v].ff + dpf[to].ff == k) {
            (ans += (dps[v].ss * dpf[to].ss)) %= MOD;
            //cout << v << ' ' << to << '\n';
        }
        if (w + dps[to].ff + dpf[v].ff == k) {
            (ans += (dps[v].ss * dpf[to].ss)) %= MOD;
            //cout << v << ' ' << to << '\n';
        }
        if (us[to])
            continue;
        dfs(to);
    }
}

signed main() {
    int n, m;
    cin >> n >> m;
    int s, f;
    cin >> s >> f >> k;
    s--, f--;
    g.resize(n);
    for (int i = 0; i < m; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        a--, b--;
        g[a].push_back({b, c});
        g[b].push_back({a, c});
    }
    dpf.assign(n, {INF, 0});
    dpf[f] = {0, 1};
    set< pair<int, int> > st;
    st.insert({dpf[f].ff, f});
    while (!st.empty()) {
        int w = st.begin()->ss;
        st.erase(st.begin());
        for (auto &[to, c] : g[w]) {
            if (dpf[to].ff > dpf[w].ff + c) {
                if (st.find({dpf[to].ff, to}) != st.end()) {
                    st.erase({dpf[to].ff, to});
                }
                dpf[to] = {dpf[w].ff + c, 1};
                st.insert({dpf[to].ff, to});
            } else if (dpf[to].ff == dpf[w].ff + c) {
                dpf[to].ss++;
            }
        }
    }

    dps.assign(n, {INF, 0});
    dps[s] = {0, 1};
    st.clear();
    st.insert({dps[s].ff, s});
    while (!st.empty()) {
        int w = st.begin()->ss;
        //cout << w << '\n';
        st.erase(st.begin());
        for (auto &[to, c] : g[w]) {
            if (dps[to].ff > dps[w].ff + c) {
                if (st.find({dps[to].ff, to}) != st.end()) {
                    st.erase({dps[to].ff, to});
                }
                dps[to] = {dps[w].ff + c, 1};
                st.insert({dps[to].ff, to});
            } else if (dps[to].ff == dps[w].ff + c) {
                dps[to].ss++;
            }
        }
    }
    mn = dps[f].ff;
    for (auto &i : dps)
        cout << i.ff << ' ' << i.ss << '\n';
    cout << '\n';
    for (auto &i : dpf)
        cout << i.ff << ' ' << i.ss << '\n';
    cout << '\n';
    us.assign(n, 0);
    dfs(s);
    cout << ans % MOD << '\n';
    return 0;
}
