//77 team
#include <iostream>
#include<algorithm>
#include<cmath>
#include <vector>
#include <queue>
#include <stack>
using namespace std;
using ll = long long;
const ll INF = 1e18 + 7;
int main()
{
	cin.tie(0)->sync_with_stdio();
	ll n, b, c;
	cin >> n >> b >> c;
	vector<ll> pos(n), cost(n + 1);
	for (ll i = 0; i < n; i++) cin >> pos[i] >> cost[i];
	vector<ll> ans(n, n);
	ans[n - 1] = n;
	cost[n] = -INF;
	stack<ll> st;
	st.push(n);
	for (ll i = 0; i < n; i++)
	{
		while (cost[i] < cost[st.top()])
		{
			if (pos[i] - pos[st.top()] <= c)
			{
				ans[st.top()] = i;
			}
			st.pop();
		}
		if (st.top() != n && (cost[i] < cost[ans[st.top()]] || cost[ans[st.top()]] == -INF) && pos[i] - pos[st.top()] <= c) ans[st.top()] = i;
		st.push(i);
	}
	ll p = 0, money = b, dist = 0, fuel = 0;
	while (money != 0 && ans[p] != n)
	{
		ll d = pos[ans[p]] - pos[p];
		if (money / cost[p] + fuel < d)
		{
			break;
		}
		if (cost[p] > cost[ans[p]])
		{
			dist += min(money / cost[p]+fuel, d);
			money -= min(money, cost[p] * max(0LL, d - fuel));
			fuel = max(0LL, fuel - d);
		}
		else
		{
			dist += min(money / cost[p] + fuel, d);
			ll cnt = min(money / cost[p], c - fuel);
			fuel += cnt - d;
			money -= cnt * cost[p];
		}
		//cout << p << ' ' << ans[p] << ' ' << money << ' ' << dist << ' ' << fuel << ' ' << d << '\n';

		p = ans[p];
	}
	dist += fuel + min(money / cost[p], c - fuel);
	cout << dist << '\n';
}