#include <bits/stdc++.h>

using namespace std;

const int inf = 1e9 + 7;

pair<int, int> cache[402][402];

int mulmod(int a, int b) {
    return (a * 1ll * b) % inf;
}

int addmod(int a, int b) {
    if (a + b > inf) {
        return a + b - inf;
    }
    return a + b;
}

pair<int, int> f(int w, int h) {
    if (w > h) {
        swap(h, w);
    }
    for (int w_ = 1; w_ <= 2; w_++) {
        for (int h_ = w_; h_ <= h; h_++) {
            cache[w_][h_] = cache[h_][w_] = {1, mulmod(w_, h_)};
        }
    }

    for (int ww = 3; ww <= w; ww++) {
        for (int hh = 3; hh <= h; hh++) {
            int ans = 0, cur = 1;

            for (int w_ = 1; w_ < ww - 1; w_++) {
                for (int h_ = 1; h_ < hh - 1; h_++) {
                    auto dd = cache[w_][h_];
//
//                    if (w_ != h_) {
//
//                    }
                    int kek = mulmod((w_ != h_ ? 1 : 1), mulmod(ww - w_ - 1, hh - h_ - 1));
                    cur = addmod(cur, mulmod(dd.first, kek));
                    ans = addmod(ans, mulmod(dd.second, kek));
                }
            }
            ans = addmod(ans, mulmod(cur, mulmod(ww, hh)));
            cache[ww][hh] = cache[hh][ww] = {cur, ans};
        }
    }


//    for (int i = 0; i < 6; i++) {
//        for (int j = 0; j < 6; j++) {
//            cout << cache[i][j].second << ' ';
//        }
//        cout << endl;
//    }

    return cache[w][h];
}

signed main() {
#ifdef HOME
    freopen(R"(C:\work\vkopshppcppp\in.txt)", "r", stdin);
    freopen(R"(C:\work\vkopshppcppp\out.txt)", "w", stdout);
#endif

    int w, h;
    cin >> w >> h;
    cout << f(w, h).second;
}