#include <bits/stdc++.h>

using namespace std;

#define ll long long
//#define int long long
#define pb push_back

const int N = 1010;
int n, m;
bool used[N][N], was[N][N];
vector<pair<int,int>> d{{-1, 0}, {0, 1}, {0, -1}, {1, 0}};

bool check(int i, int j) {
    return i >= 0 && i < n && j >= 0 && j < m;
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios::sync_with_stdio(false);
    cin.tie(0);
    cin >> n >> m;
    vector<vector<char>> c(n, vector<char>(m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> c[i][j];
        }
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            deque<pair<int,int>> q;
            if (!used[i][j] && c[i][j] == '.') {
                q.pb({i, j});
                used[i][j] = 1;
                bool border = 0;
                deque<pair<int,int>> upd;
                while (q.size() > 0) {
                    auto p = q.front();
                    q.pop_front();
                    int x = p.first, y = p.second;
                    upd.pb({x, y});
                    for (auto to : d) {
                        if (!check(x + to.first, y + to.second)) {
                            border = 1;
                        }
                    }
                    for (auto to : d) {
                        x += to.first, y += to.second;
                        if (check(x, y) && c[x][y] == '.' && !used[x][y]) {
                            q.pb({x, y});
                            used[x][y] = 1;
                        }
                        x -= to.first, y -= to.second;
                    }
                }
                if (border) continue;
                while (upd.size() > 0) {
                    auto p = upd.front();
                    upd.pop_front();
                    int x = p.first, y = p.second;
                    if (c[x][y] == '.') {
                        if (!was[x][y]) {
                            for (auto to : d) {
                                if (check(x + to.first, y + to.second)) {
                                    upd.pb({x + to.first, y + to.second});
                                }
                            }
                        }
                        was[x][y] = 1;
                        continue;
                    }
                    int cnt = 0;
                    for (auto to : d) {
                        x += to.first, y += to.second;
                        if (check(x, y) && c[x][y] == '.') {
                            cnt++;
                        }
                        x -= to.first, y -= to.second;
                    }
                    if (cnt >= 3) {
                        if (!was[x][y]) {
                            for (auto to : d) {
                                if (check(x + to.first, y + to.second)) {
                                    upd.pb({x + to.first, y + to.second});
                                }
                            }
                        }
                        c[x][y] = '.';
                        was[x][y] = 1;
                    }
                }
                break;
            }
        }
    }
    vector<vector<char>> ans(n, vector<char>(m, '.'));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (was[i][j]) {
                for (int x = -1; x <= 1; x++) {
                    for (int y = -1; y <= 1; y++) {
                        if (check(x + i, y + j) && c[x + i][y + j] == '#') {
                            ans[x + i][y + j] = '#';
                        }
                    }
                }
            }
        }
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cout << ans[i][j];
        }
        cout << endl;
    }
    return 0;
}