#include <bits/stdc++.h>

using namespace std;

#define int long long
#define ll long long
#define pii pair<int, int>
#define dl double
#define all(v) v.begin(), v.end()
#define sz(v) (int)v.size()

const ll inf = 1e12, mod = 1e9 + 7, maxn = 2e5 + 1;

void solve() {
    int n, m, s, t, L;
    cin >> n >> m >> s >> t >> L, s--, t--;
    vector<vector<pii>>g(n);
    vector<tuple<int, int, int>>e;
    for (int i = 0; i < m; ++i) {
        int u, v, w;
        cin>>u>>v>>w, u--, v--;
        g[u].push_back({v, w});
        g[v].push_back({u, w});
        e.push_back({u, v, w});
        e.push_back({v, u, w});
    }
    set<pii>q;
    vector<int>ds(n, inf);
    vector<int>ks(n, 0);
    ds[s] = 0, ks[s] = 1, q.insert({0, s});
    while(!q.empty()){
        int v = q.begin()->second;
        q.erase(q.begin());
        for(auto[u, w]:g[v]){
            if(ds[u] >= ds[v] + w){
                if(ds[u] > ds[v] + w) ks[u] = ks[v];
                else ks[u] += ks[v], ks[u] %= mod;
                q.erase({ds[u], u});
                ds[u] = ds[v] + w;
                q.insert({ds[u], u});
            }
        }
    }

    vector<int>dt(n, inf);
    vector<int>kt(n, 0);
    dt[t] = 0, kt[t] = 1, q.insert({0, t});
    while(!q.empty()){
        int v = q.begin()->second;
        q.erase(q.begin());
        for(auto[u, w]:g[v]){
            if(dt[u] >= dt[v] + w){
                if(dt[u] > dt[v] + w) kt[u] = kt[v];
                else kt[u] += kt[v], kt[u] %= mod;
                q.erase({dt[u], u});
                dt[u] = dt[v] + w;
                q.insert({dt[u], u});
            }
        }
    }

    int ans = 0;
    for(auto[u, v, w]:e){
        int way = ds[u] + w + dt[v];
        if(way == L && dt[u] + ds[u] == ds[t]){
            //cout<<u+1<<' '<<v+1<<'\n';
            ans += ks[u] * kt[v];
            ans %= mod;
        }
    }
    cout<<ans;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int _ = 1;
    // cin>>_;
    while (_--) {
        solve();
        //    cout << endl;
    }
}
/*
 6 7
 1 6 12
 1 2 2
 1 3 4
 2 5 2
 3 5 4
 2 4 4
 4 6 6
 5 6 4
 */