#include <bits/stdc++.h>

using namespace std;

#define int long long
#define ll long long
#define pii pair<int, int>
#define dl double
#define all(v) v.begin(), v.end()
#define sz(v) (int)v.size()

const ll inf = 1e18, mod = 1e9 + 7, maxn = 2e5 + 1;
int n;
vector<int> a;

int del_ok(int r, int d) {
    vector<int> b;
    for (int i = 0; i < n; ++i) {
        if (d != i)b.push_back(a[i]);
    }
    int mn = inf, mx = -inf;
    int m = sz(b);
    for (int i = 0; i < m - i - 1; ++i) {
        mn = min(mn, b[i] + b[m - i - 1]);
        mx = max(mx, b[i] + b[m - i - 1]);
    }
    return mx - mn <= r;
}

int ok(int raz) {
    if (del_ok(raz, n / 2)) return 1;
    if (del_ok(raz, 0)) return 1;
    if (del_ok(raz, n - 1)) return 1;
    int l = 0, r = n - 1;
    int mn = inf, mx = -inf;
    int mn_l = 0, mn_r = n - 1, mx_l = 0, mx_r = n - 1;
    while (l < r) {
        if (a[l] + a[r] < mn) {
            mn = a[l] + a[r];
            mn_l = l, mn_r = r;
        }
        if (a[l] + a[r] > mx) {
            mx = a[l] + a[r];
            mx_l = l, mx_r = r;
        }
        if (mx - mn > raz) {
            int ok = 0;
            ok |= del_ok(raz, l);
            ok |= del_ok(raz, r);
            ok |= del_ok(raz, mn_l);
            ok |= del_ok(raz, mn_r);
            ok |= del_ok(raz, mx_l);
            ok |= del_ok(raz, mx_r);
            return ok;
        }
        l++, r--;
    }
    return 1;
}

void solve() {
    cin >> n;
    a.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    sort(all(a));
    int l = -1, r = mod;
    while (l < r - 1) {
        int m = (l + r) / 2;
        if (ok(m)) r = m;
        else l = m;
    }
    cout << r;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int _ = 1;
    //cin>>_;
    while (_--) {
        solve();
        cout << '\n';
    }
}