#include <bits/stdc++.h>
#define int long long
#define F first
#define S second
#define pb push_back
#define mp make_pair
using namespace std;

const int N = 1004;
const int mod = 1e9 + 7;

char c[N][N];
int dx[] = {1 , -1, 0 , 0,1,1,-1,-1};
int dy[] = {0,0, 1 , -1,  1,-1,1,-1,};
int u[N][N];
int ok = 0;
int u1[N][N];
int gran[N][N];
    int n, m;
int ans[N][N];

bool ch(int i , int j) {
    if(i >= 1 && i <= n && j >= 1 && j <= m) {
        if(u[i][j] == 0) {
            if(c[i][j] == '.') return true;
        }
    }
    return false;
}

bool ch1(int i , int j) {
    if(i >= 1 && i <= n && j >= 1 && j <= m) {
        if(u1[i][j] == 0) {
            if(c[i][j] == '.') return true;
        }
    }
    return false;
}

bool ch2(int i , int j) {
    if(i == 0 || i == n+1 || j == 0 || j == m+1) return true;
    if(u1[i][j] == 0 && gran[i][j] == 0) return true;
    return false;
}

void dfs(int i, int j) {
    u[i][j] = 1;
    if(i == n || j == m || i == 1 || j == 1) ok = 0;
    for(int k = 0; k < 4; k ++) {
        int ni = i+dx[k];
        int nj = j + dy[k];
        if(ch(ni,nj)) {
            dfs(ni,nj);
        }
    }
}

void go(int i , int j) {
    u1[i][j] = 1;
    for(int k = 0; k < 8; k ++) {
        int ni = i+dx[k];
        int nj = j + dy[k];
        if(c[ni][nj] == '#') {
            gran[ni][nj] = 1;
        }
    }
    for(int k = 0; k < 4; k ++) {
        int ni = i + dx[k];
        int nj = j + dy[k];
        if(ch1(ni,nj)) {
            go(ni,nj);
        }
    }
}

main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin >> n >> m;
    for(int i = 1; i <= n; i ++) {
        for(int j = 1; j <= m; j ++) {
            cin >> c[i][j];
        }
    }
    for(int i = 1; i <= n; i ++) {
        for(int j = 1; j <= m; j ++) {
            if(c[i][j] == '.' && u[i][j] == 0) {
                ok = 1;
                dfs(i , j);
                if(ok) {
                    go(i , j);
                    break;
                }
            }
        }
        if(ok) break;
    }
    for(int i = 1; i <= n; i ++) {
        for(int j = 1; j <= m; j ++) {
            if(gran[i][j] == 0) {
                cout << '.';
                continue;
            }
            int ok1 = 0;
            for(int k = 0; k < 8; k ++) {
                int ni = i + dx[k];
                int nj = j + dy[k];
                if(ch2(ni,nj)) {
                    ok1 = 1;
                    break;
                }
            }
            if(ok1) cout << '#';
            else cout << '.';
        }
        cout << '\n';
    }
}
/*
8 10
1 8 3
1 2 1
1 3 1
2 4 1
2 5 1
3 6 1
3 7 1
4 8 1
5 8 1
6 8 1
7 8 1
*/
