#include<bits/stdc++.h>

using namespace std;

const int N = (1 << 17);
typedef long long ll;

ll t[2 * N], B, C;
ll x[N], p[N];
ll dp[N];
ll n, ans;

ll get(ll ql, ll qr, ll l = 0, ll r = N - 1, ll v = 1) {
    if(r < ql || l > qr) {
        return 2e9;
    }
    if(ql <= l && r <= qr) {
        return t[v];
    }
    ll m = (l + r) / 2;
    return min(get(ql, qr, l, m, 2 * v), get(ql, qr, m + 1, r, 2 * v + 1));
}
void build(ll l = 0, ll r = N - 1, ll v = 1) {
    if(l == r) {
        if(l <= n) t[v] = p[l];
        else t[v] = 2e9;
        return;
    }
    ll m = (l + r) / 2;
    build(l, m, 2 * v);
    build(m + 1, r, 2 * v + 1);
    t[v] = min(t[2 * v], t[2 * v + 1]);
}

main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> B >> C;
    for(ll i = 1; i <= n; i++) {
        cin >> x[i];
        cin >> p[i];
    }
    build();

    dp[1] = 0;
    ans = min(B / p[1], C);
    x[n + 1] = 2e9 ;
    p[n + 1] = 1 ;
    for(ll i = 2; i <= n + 1; i++) {
        if(x[i] - x[i - 1] > C) break;
        ll l = 0, r = i;
        while(r - l > 1) {
            ll m = (l + r) / 2;
            if(x[i] - x[m] <= C) r = m;
            else l = m;
        }
        ll v = get(r, i - 1);
        dp[i] = dp[i - 1] + v * (x[i] - x[i - 1]);
        if(dp[i] <= B) {
            ll g = min(C - x[i] + x[i - 1], (B - dp[i]) / v);
            ans = max(ans, x[i] + g + max(0ll, min(C, (B - dp[i] - g * v) / p[i])));
        }
    }
    cout << ans;
}
