
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#define ll long long
#define int ll
#define ld long double
#define ins insert
#define FOR(x, y, z) for (int x = y; x <= z; x++)
#define lb lower_bound
#define pii pair<int, int>
#define ub upper_bound

using namespace std;
using namespace __gnu_pbds;

typedef tree < int, null_type, less < int >, rb_tree_tag, tree_order_statistics_node_update > ordered_set;

const int N = 1e5 + 40, T = 4 * N, inf = 1e9 + 7;

int n, b, c, x[N], p[N];
pii t[4 * N];

pii calc(pii a, pii b)
{
    if (a.first < b.first)
        return a;
    return b;
}

void build(int v, int tl, int tr)
{
    if (tl == tr)
    {
        t[v] = {p[tl], tl};
        return;
    }
    int tm = tl + tr >> 1;
    build(v + v, tl, tm);
    build(v + v + 1, tm + 1, tr);
    t[v] = calc(t[v + v], t[v + v + 1]);
}

pii get(int v, int tl, int tr, int l, int r)
{
    if (r < tl || tr < l)
        return {inf, inf};
    if (l <= tl && tr <= r)
    {
        return t[v];
    }
    int tm = tl + tr >> 1;
    return calc(
               get(v + v, tl, tm, l, r),
               get(v + v + 1, tm + 1, tr, l, r));
}

pii get(int l, int r)
{
    return get(1, 1, n, l, r);
}

void solve()
{
    cin >> n >> b >> c;
    FOR(i, 1, n)
    {
        cin >> x[i] >> p[i];
    }
    build(1, 1, n);
    int curc = 0;
    int id = 1;
    while (id < n)
    {
        int d = min(b / p[id] + curc, c);
        int pos = x[id] + d;
        int mx = ub(x + 1, x + n + 1, pos) - x - 1;
        if (mx <= id)
        {
            cout << pos;
            return;
        }
        pii res = get(id + 1, mx);
        int nxt = res.second;
        int price = res.first;
        int cost = 0;
        int diff = 0;
        if (curc >= x[nxt] - x[id])
        {
            diff = x[nxt] - x[id];
        }
        else
        {
            cost = (x[nxt] - x[id] - curc) * p[id];
            diff = curc;
        }
        if (price <= p[id])
        {
            if (cost > b)
            {
                cout << 1 / 0;
            }
            b -= cost;

                curc -= diff;
        }
        else
        {
            int cnt = min(c - curc, b / p[id]);
            b -= cnt * p[id];
            curc += cnt;
            curc += -x[nxt] + x[id];
        }
        id = nxt;
//        cout << id << ' ' << b << ' ' << curc << "\n";
    }
    cout << x[id] + min(b / p[id] + curc, c);
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // LOCAL

    solve();
}
