#include "bits/stdc++.h"

using namespace std;
#define int long long
#define ff first
#define ss second
const int N = 1e5 + 1;
const int M = 2e9;
vector< pair<int ,int> > a(N);
int n, B,c;
pair<int, int> tree[4 * N];


pair<int, int> combine(pair<int, int> a, pair<int, int> b){
    if(a.ff > b.ff) return a;
    if(b.ff > a.ff)return a;
    if(a.ss>b.ss)return b;
    return a;
}

void build(int v, int vl, int vr){
    if(vl == vr){
        if(vl > n) tree[v] = {M, 1LL};
        else tree[v] = {a[vl].ss, vl};
        return;
    }
    int mid = (vl + vr)>>1;
    build(v<<1|1, vl, mid);
    build(v*2+2, mid+1, vr);
    tree[v] = combine(tree[v<<1|1], tree[v*2+2]);
}

pair<int, int> get_min(int l, int r, int v, int vl, int vr){
    if(l > vr or vl > r) return {M, 1};
    if(l <= vl and r >= vr) return tree[v];
    int mid = (vl + vr)>>1;
    pair<int, int> L = get_min(l, r, v<<1|1, vl, mid);
    pair<int, int> R = get_min(l, r, (v * 2)+2, mid+1, vr);
    return combine(L,R);
}
main () {
    cin >> n >> B >> c;
    vector<int> x(n);
    for(int i = 0; i < n; i ++) cin >> a[i].first >> a[i].second;
    for(int i = 0;i < n; i++){
        x[i] = a[i].ff;
    }
    build(0, 0, n);
    priority_queue <pair <int,int>> q;
    q.push({0, 0});
    vector <int> dist(n, M);
    dist[0] = 0;
    while(!q.empty()){
        int v = q.top().second;
        q.pop();
        int L = upper_bound(x.begin(), x.end(), a[v].ff + c) - x.begin();
        L--;
        int i;
        if(L > v){
            pair<int, int> to = get_min(min(n-1, v+1), L, 0, 0, n);
            i = to.ff;
            i = min(i, n-1);
            if((a[i].first - a[v].first) * a[v].second <= B-dist[v]
             && a[i].first - a[v].first <= c
            && (a[i].first - a[v].first) * a[v].second < dist[i]) {
                dist[i] = dist[v] + (a[i].first - a[v].first);
                q.push({-dist[i], i});
            }
        }
        if(v + 1 < n){
            i = v+1;
            if((a[i].first - a[v].first) * a[v].second <= B-dist[v]
             && a[i].first - a[v].first <= c
            && (a[i].first - a[v].first) * a[v].second < dist[i]) {
                dist[i] = dist[v] + (a[i].first - a[v].first);
                q.push({-dist[i], i});
            }
        }
    }
    int ans = 0;
    for(int i = 0; i < n; i ++) {
            //cout << dist[i] << " ";
        if(dist[i] == M) continue;
        ans = max(ans, a[i].first + min(c, (B - dist[i]) / a[i].second));
    }
   // cout << endl;
    cout << ans;
    return 0;
}
