#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <string>
#include <random>
#include <bitset>
#include <vector>
#include <string>
#include <stack>
#include <queue>
#include <algorithm>
#include <cmath>
#include <map>
#include <unordered_map>
#include <set>
#include <iterator>
#include <unordered_set>
#include <assert.h>
#include <fstream>
using namespace std;

typedef long long ll;
typedef vector<int> vi;
typedef vector<ll> vll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef map<int, int> mii;
typedef map<ll, ll> mll;
typedef unordered_map<int, int> umap;

#define pb push_back
#define fi first
#define se second
#define mpr make_pair
#define MOD 1000000007
#define MOD2 998244353
#define oo 1000000000
#define ool 1000000000000000000LL
#define all(x) (x).begin(), (x).end()
#define sz(x) (x).size()
#define yes cout << "YES\n"
#define no cout << "NO\n"

void setprecision(int x) {

    cout.setf(ios::fixed | ios::showpoint);
    cout.precision(x);
}

void fastio() {

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}

const int N = 500005;
ll a[N], b[N];
ll mn[4 * N], mx[4 * N];

void bld(int tl, int tr, int pos) {
    if (tl == tr) {
        mn[pos] = mx[pos] = b[tl];
        return;
    }
    int tm = (tl + tr) / 2;
    bld(tl, tm, pos * 2);
    bld(tm + 1, tr, pos * 2 + 1);
    mn[pos] = min(mn[pos * 2], mn[pos * 2 + 1]);
    mx[pos] = max(mx[pos * 2], mx[pos * 2 + 1]);
}

void updmn(int tl, int tr, int pos, int ind, ll val) {
    if (tl == tr) {
        mn[pos] = val;
        return;
    }
    int tm = (tl + tr) / 2;
    if (ind <= tm) {
        updmn(tl, tm, pos * 2, ind, val);
    }
    else {
        updmn(tm + 1, tr, pos * 2 + 1, ind, val);
    }
    mn[pos] = min(mn[pos * 2], mn[pos * 2 + 1]);
}

void updmx(int tl, int tr, int pos, int ind, ll val) {
    if (tl == tr) {
        mx[pos] = val;
        return;
    }
    int tm = (tl + tr) / 2;
    if (ind <= tm) {
        updmx(tl, tm, pos * 2, ind, val);
    }
    else {
        updmx(tm + 1, tr, pos * 2 + 1, ind, val);
    }
    mx[pos] = max(mx[pos * 2], mx[pos * 2 + 1]);
}

//ll qrymn(int tl, int tr, int l, int r, int pos) {
//    if (l > r) {
//        return ool;
//    }
//    if (tl == l && tr == r) {
//        return mn[pos];
//    }
//    int tm = (tl + tr) / 2;
//    return min(qrymn(tl, tm, l, min(r, tm), pos * 2),
//        qrymn(tm + 1, tr, max(l, tm + 1), r, pos * 2 + 1));
//}
//
//ll qrymx(int tl, int tr, int l, int r, int pos) {
//    if (l > r) {
//        return 0;
//    }
//    if (tl == l && tr == r) {
//        return mx[pos];
//    }
//    int tm = (tl + tr) / 2;
//    return min(qrymx(tl, tm, l, min(r, tm), pos * 2),
//        qrymx(tm + 1, tr, max(l, tm + 1), r, pos * 2 + 1));
//}

void solve() {
    int n;
    cin >> n;
    for (int i = 1; i <= n; ++i) {
        cin >> a[i];
    }
    sort(a + 1, a + n + 1);
    int ind = n / 2;
    for (int i = 1; i <= ind; ++i) {
        b[i] = a[i] + a[ind * 2 - i + 1];
    }
    bld(1, ind, 1);
    ll ans = ool;
    for (int i = n; i >= 1; --i) {
        ll cur1 = mn[1], cur2 = mx[1];
        ans = min(ans, abs(cur1 - cur2));
        if (i == 1) {
            break;
        }
        int cur;
        if (i > ind + 1) {
            cur = n - i + 1;
        }
        else {
            cur = i - 1;
        }
        b[cur] = b[cur] - a[i - 1] + a[i];
        updmn(1, ind, 1, cur, b[cur]);
        updmx(1, ind, 1, cur, b[cur]);
    }
    cout << ans << "\n";
}

void precalc() {

    return;
}

int main()
{
    fastio();
    precalc();
    int t = 1;
    //int t;
    //cin >> t;
    while (t--) {
        solve();
    }
}