#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <string>
#include <random>
#include <bitset>
#include <vector>
#include <string>
#include <stack>
#include <queue>
#include <algorithm>
#include <cmath>
#include <map>
#include <unordered_map>
#include <set>
#include <iterator>
#include <unordered_set>
#include <assert.h>
#include <fstream>
using namespace std;

typedef long long ll;
typedef vector<int> vi;
typedef vector<ll> vll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef map<int, int> mii;
typedef map<ll, ll> mll;
typedef unordered_map<int, int> umap;

#define pb push_back
#define fi first
#define se second
#define mpr make_pair
#define MOD 1000000007
#define MOD2 998244353
#define oo 1000000000
#define ool 1000000000000000000LL
#define all(x) (x).begin(), (x).end()
#define sz(x) (x).size()
#define yes cout << "YES\n"
#define no cout << "NO\n"

void setprecision(int x) {

    cout.setf(ios::fixed | ios::showpoint);
    cout.precision(x);
}

void fastio() {

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}

const int N = 100005;
vll xx, cc;
int t[4 * N];

int get(int pos1, int pos2) {
    if (pos1 == oo) {
        return pos2;
    }
    if (pos2 == oo) {
        return pos1;
    }
    if (cc[pos1] <= cc[pos2])
        return pos1;
    else {
        return pos2;
    }
}

void bld(int tl, int tr, int pos) {
    if (tl == tr) {
        t[pos] = tl;
        return;
    }
    int tm = (tl + tr) / 2;
    bld(tl, tm, pos * 2);
    bld(tm + 1, tr, pos * 2 + 1);
    t[pos] = get(t[pos * 2], t[pos * 2 + 1]);
}

int qry(int tl, int tr, int l, int r, int pos) {
    if (l > r) {
        return oo;
    }
    if (tl == l && tr == r) {
        return t[pos];
    }
    int tm = (tl + tr) / 2;
    return get(qry(tl, tm, l, min(r, tm), pos * 2),
        qry(tm + 1, tr, max(l, tm + 1), r, pos * 2 + 1));
}

void solve() {
    int n;
    ll b, c;
    cin >> n >> b >> c;
    xx.resize(n); cc.resize(n);
    vi ind(n);
    for (int i = 0; i < n; ++i) {
        cin >> xx[i] >> cc[i];
    }
    xx.push_back(ool);
    cc.push_back(ool);
    bld(0, n, 1);
    stack<int> st;
    for (int i = 0; i < n; ++i) {
        while (!st.empty()) {
            int ind0 = st.top();
            if (cc[ind0] > cc[i]) {
                ind[ind0] = i;
                st.pop();
            }
            else {
                break;
            }
        }
        st.push(i);
    }
    while (!st.empty()) {
        int ind0 = st.top();
        ind[ind0] = n;
        st.pop();
    }
    ll zap = 0;
    int i = 0;
    while (1) {
        int ind0 = ind[i];
        ll her = xx[ind0] - xx[i];
        //cout << i << ' ' << b << ' ' << zap << "\n";
        if (zap >= her) {
            i = ind0;
            zap -= her;
            continue;
        }
        if (her <= c) {
            if (b / cc[i] + zap <= her) {
                cout << xx[i] + zap + b / cc[i];
                return;
            }
            else {
                b -= (her - zap) * cc[i];
                zap = 0;
                i = ind0;
                continue;
            }
        }
        if (b / cc[i] + zap <= c) {
            cout << xx[i] + zap + b / cc[i] << "\n";
            return;
        }
        //yes;
        ll mx = xx[i] + c;
        int j = upper_bound(all(xx), mx) - xx.begin() - 1;
        //cout << j << "\n";
        if (j == i) {
            cout << xx[i] + c << "\n";
            return;
        }
        ind0 = qry(0, n, i + 1, j, 1);
        //cout << ind0 << "\n";
        her = xx[ind0] - xx[i];
        b -= (c - zap) * cc[i];
        zap = c - her;
        i = ind0;
    }
}

void precalc() {

    return;
}

int main()
{
    fastio();
    precalc();
    int t = 1;
    //int t;
    //cin >> t;
    while (t--) {
        solve();
    }
}