#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <set>
#include <stack>
#include <cassert>
#include <queue>
using namespace std;
using ll = long long;
vector<pair<ll, ll>> v[200005];
priority_queue <pair<ll, ll>> q;
ll sdist[200005];
ll sqan[200005];
ll sc[200005];
ll tdist[200005];
ll tqan[200005];
ll tc[200005];

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	ll n, i, j, x, y, m, s, t;
	ll l, c;
	cin >> n >> m;
	cin >> s >> t >> l;
	for ( i = 0; i < m; i++)
	{
		cin >> x >> y >> c;
		v[x].push_back({ y, c });
		v[y].push_back({ x, c });
	}
	ll oo = 1000000000000000000LL;
	ll mod = 1e9 + 7;
	for ( i = 1; i <= n; i++)
	{
		sdist[i] = oo;
		tdist[i] = oo;
	}
	sdist[s] = 0;
	sqan[s] = 1;
	tdist[t] = 0;
	tqan[t] = 1;
	q.push({ 0, s });
	while (!q.empty())
	{
		pair<ll, ll> xx = q.top();
		xx.first *= -1;
		q.pop();
		if (sc[xx.second])continue;
		sc[xx.second] = 1;
		for (auto to: v[xx.second])
		{
			if (xx.first + to.second < sdist[to.first])
			{
				sdist[to.first] = xx.first + to.second;
				q.push({ -sdist[to.first], to.first });
				sqan[to.first] = sqan[xx.second];
			}
			else if (xx.first + to.second == sdist[to.first])
			{
				sqan[to.first] += sqan[xx.second];
				sqan[to.first] %= mod;
			}
		}
	}
	///
	q.push({ 0, t });
	while (!q.empty())
	{
		pair<ll, ll> xx = q.top();
		xx.first *= -1;
		q.pop();
		if (tc[xx.second])continue;
		tc[xx.second] = 1;
		for (auto to : v[xx.second])
		{
			if (xx.first + to.second < tdist[to.first])
			{
				tdist[to.first] = xx.first + to.second;
				q.push({ -tdist[to.first], to.first });
				tqan[to.first] = tqan[xx.second];
			}
			else if (xx.first + to.second == tdist[to.first])
			{
				tqan[to.first] += tqan[xx.second];
				tqan[to.first] %= mod;
			}
		}
	}
	//
	if (sdist[t] == l)
	{
		cout << sqan[t];
		return 0;
	}
	if (sdist[t] == oo)
	{
		cout << 0;
		return 0;
	}
	ll ans = 0;
	for ( i = 1; i <= n; i++)
	{
		if (i != t && sdist[i] + tdist[i] == sdist[t])
		{
			for (auto to: v[i])
			{
				if (sdist[i] + to.second + tdist[to.first] == l)
				{
					ans = (ans + (sqan[i] * tqan[to.first]) % mod)%mod;
				}
			}
		}
	}
	cout << ans;
	return 0;
}