#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <set>
using namespace std;

const int N = 100005, Q = 100005;
long long a[N], k[Q];
int n, q;

vector<long long> v, ans, p;

vector<pair<long long, long long>> vv;

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int i, j;

	cin >> n >> q;

	long long curr = 0, last = -1;

	//vv.push_back(make_pair(curr, last));

	for (i = 1; i <= n; i++) {
		long long x;
		cin >> x;

		v.push_back(x);

		if (x == last + 1) {
			last++;
			continue;
		}

		vv.push_back(make_pair(curr, last));

		curr = x - last - 1;
		last = x;
	}

	if (curr) vv.push_back(make_pair(curr, last));

	long long s = 0;

	for (i = 0; i < vv.size(); i++) {
		//cout << vv[i].first << ' ' << vv[i].second << "\n";
		s += vv[i].first;
		p.push_back(s);
	}

	for (i = 1; i <= q; i++) {
		long long k;
		cin >> k;

		j = lower_bound(p.begin(), p.end(), k) - p.begin();
		j--;

		long long res = vv[j].second;
		res += (k - p[j]);

		ans.push_back(res);
	}

	for (i = 0; i < q; i++) {
		cout << ans[i] << ' ';
	}
	cout << "\n";

	return 0;
}