#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <set>
#include <stack>
#include <cassert>
#include <queue>
using namespace std;
using ll = long long;
char c[1005][1005];
int color[1005][1005];
pair<int, int> papa[1005][1005];
int dist[1005][1005];
int arj[1005][1005];


int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int n, i, j, m, x = 0, y = 0;
	cin >> n >> m;
	for ( i = 1; i <= n; i++)
	{
		for ( j = 1; j <= m; j++)
		{
			cin >> c[i][j];
		}
	}
	for ( i = 0; i < n; i++)
	{
		color[i][0] = 1;
		color[i][m + 1] = 1;
	}
	for ( i = 0; i < m; i++)
	{
		color[0][i] = 1;
		color[n + 1][i] = 1;
	}
	for ( i = 1; i <= n; i++)
	{
		for (j = 1; j <= m; j++)
		{
			if (i == 1 || j == 1 || i == n || j == m)
			{
				if (color[i][j] == 0 && c[i][j] == '.')
				{
					queue<pair<int, int>> q;
					while (!q.empty())
					{
						x = q.front().first;
						y = q.front().second;
						color[x][y] = 1;
						q.pop();
						if (color[x + 1][y] == 0 && c[x + 1][y] == '.')
						{
							q.push({ x + 1, y });
						}
						if (color[x - 1][y] == 0 && c[x - 1][y] == '.')
						{
							q.push({ x - 1, y });
						}
						if (color[x][y - 1] == 0 && c[x][y - 1] == '.')
						{
							q.push({ x, y - 1 });
						}
						if (color[x][y + 1] == 0 && c[x][y + 1] == '.')
						{
							q.push({ x, y + 1 });
						}
					}
				}
			}
		}
	}
	int xx = -1, yy = -1;
	for ( i = 1; i <= n; i++)
	{
		for ( j = 1; j <= m; j++)
		{
			if (color[i][j] == 0 && c[i][j] == '.')
			{
				if (yy < j)
				{
					xx = i;
					yy = j;
				}
			}
		}
	}
	for ( i = 1; i <= n; i++)
	{
		for ( j = 1; j <= m; j++)
		{
			color[i][j] = 0;
		}
	}
	yy++;
	queue <pair<pair<int, int>, int>> q;
	q.push({ {xx, yy}, 0 });
	int ansx, ansy;
	while (!q.empty())
	{
		pair<pair<int, int>, int> gag = q.front();
		x = gag.first.first;
		y = gag.first.second;
		arj[x][y] = gag.second;
		color[x][y] = 1;
		q.pop();
		if (gag.second == 0)
		{
			if (color[x + 1][y] == 0 && c[x + 1][y] == '#')
			{
				q.push({ {x + 1, y}, -1 });
				dist[x + 1][y] = dist[x][y] + 1;
				papa[x + 1][y] = { x, y };
			}
			if (color[x - 1][y] == 0 && c[x - 1][y] == '#')
			{
				q.push({{x - 1, y}, 1});
				dist[x - 1][y] = dist[x][y] + 1;
				papa[x - 1][y] = { x, y };
			}
			if (color[x][y - 1] == 0 && c[x][y - 1] == '#')
			{
				q.push({ {x, y - 1}, 0 });
				dist[x][y - 1] = dist[x][y] + 1;
				papa[x][y - 1] = { x, y };
			}
			if (color[x][y + 1] == 0 && c[x][y + 1] == '#')
			{
				q.push({ {x, y + 1}, 0 });
				dist[x][y + 1] = dist[x][y] + 1;
				papa[x][y + 1] = { x, y };
			}
		}
		else
		{
			if (color[x + 1][y] == 0 && c[x + 1][y] == '#')
			{
				q.push({ {x + 1, y}, gag.second });
				dist[x + 1][y] = dist[x][y] + 1;
				papa[x + 1][y] = { x, y };
			}
			if (color[x - 1][y] == 0 && c[x - 1][y] == '#')
			{
				q.push({ {x - 1, y}, gag.second });
				dist[x - 1][y] = dist[x][y] + 1;
				papa[x - 1][y] = { x, y };
			}
			if (color[x][y - 1] == 0 && c[x][y - 1] == '#')
			{
				q.push({ {x, y - 1}, gag.second });
				dist[x][y - 1] = dist[x][y] + 1;
				papa[x][y - 1] = { x, y };
			}
			if (color[x][y + 1] == 0 && c[x][y + 1] == '#')
			{
				q.push({ {x, y + 1}, gag.second });
				dist[x][y + 1] = dist[x][y] + 1;
				papa[x][y + 1] = { x, y };
			}
			//
			if (color[x + 1][y] == 1 && c[x + 1][y] == '#')
			{
				if (arj[x + 1][y] == gag.second * -1)
				{

				}
			}
			if (color[x - 1][y] == 1 && c[x - 1][y] == '#')
			{
				q.push({ {x - 1, y}, gag.second });
			}
			if (color[x][y - 1] == 1 && c[x][y - 1] == '#')
			{
				q.push({ {x, y - 1}, gag.second });
			}
			if (color[x][y + 1] == 1 && c[x][y + 1] == '#')
			{
				q.push({ {x, y + 1}, gag.second });
			}
		}
	}
	return 0;
}