#include <bits/stdc++.h>
#define int long long
#define pii pair<int, int>
#define X first
#define Y second
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
using namespace std;

template<typename T>
bool rmax(T& a, T b) {
    if (a < b) {
        a = b;
        return 1;
    }
    return 0;
}

template<typename T>
bool rmin(T& a, T b) {
    if (b < a) {
        a = b;
        return 1;
    }
    return 0;
}

template<typename T>
istream& operator >> (istream& in, vector<T>& a) {
    for (auto &it : a) {
        in >> it;
    }
    return in;
}

template<typename T>
ostream& operator << (ostream& in, vector<T>& a) {
    for (auto &it : a) {
        in << it << ' ';
    }
    return in;
}

const int INF = 1e3 + 1;
vector<pii> good = {{-1, 0}, {1, 0}, {0, 1}, {0, -1}};
int used[INF][INF];
pii pr[INF][INF];
char matr[INF][INF];
int n;
int m;
vector<vector<pii>> lake;

bool check(int x, int y) {
    return (x >= 0 && x < n && y >= 0 && y < n);
}

void dfs(int x, int y, int col) {
    used[x][y] = col;

//    cout << x << ' ' << y << ' ' << col << endl;
    for (auto &it : good) {
        int x1 = x + it.X;
        int y1 = y + it.Y;

        if (check(x1, y1) && used[x1][y1] == -1 && matr[x1][y1] == '.') {
            dfs(x1, y1, col);
        }
    }
}

void bfs(pii x, pii y) {
    queue<pii> q;
    q.push(x);
    pr[x.X][x.Y] = {-1, -1};

    while (!q.empty()) {
        pii v = q.front();
        q.pop();

        int x1 = v.X;
        int y1 = v.Y;

        used[x1][y1] = -2;

        for (auto &it : good) {
            int nx = x1 + it.X;
            int ny = y1 + it.Y;

            pii fg = {nx, ny};
            if (v == x && fg == y) {
                cout << "bad\n";
                continue;
            }

            if (check(nx, ny) && used[nx][ny] != -2 && matr[nx][ny] == '#' && nx >= x.X) {
                q.push({nx, ny});
                pr[nx][ny] = v;
                used[nx][ny] = -2;
            }
        }
    }
}

void func(vector<int>& a, int& ans){
    int n = a.size();
    multiset<int> m;
    for(int i = 0; i < n / 2; i++){
        m.insert(a[i] + a[n - 2 - i]);
    }
    ans = min(ans, *--m.end() - *m.begin());
    for(int tec = n - 2; tec >= n / 2; tec--){
        int prev = a[tec] + a[n - 2 - tec];
        m.erase(m.find(prev));
        m.insert(a[n - 2 - tec] + a[tec + 1]);
        ans = min(ans, *--m.end() - *m.begin());
    }
}

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    cin >> a;
    sort(all(a));
    int ans = 3e9;
    func(a, ans);
    reverse(all(a));
    func(a, ans);
    cout << ans;
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

#ifdef LOCAL
    freopen("..\\input.txt", "r",  stdin);
    freopen("..\\output.txt", "w", stdout);
#endif

    int t  = 1;
//    cin >> t;

    while (t--) {
        solve();
    }
}