#include <iostream>
#include <cmath>
#include <vector>
#include <set>
#include <algorithm>
#include<map>
using namespace std;
typedef long long ll;
void solve(){
    ll n, q;
    cin >> n >> q;
    vector<ll> nums(n);
    for(int i = 0; i < n; i++)
        cin >> nums[i];
    nums.push_back(-1);
    nums.push_back((ll)10 * INT_MAX);
    sort(nums.begin(), nums.end());
    map<ll, ll> ans;
    set<ll> dif;
    vector<ll> que(q);
    for(int i = 0; i < q; i++){
        cin >> que[i];
        dif.insert(que[i]);
    }
    ll was = 0, pos = 0;
    for(ll num : dif){
        while(was + nums[pos + 1] - nums[pos] - 1 < num){
            was += nums[pos + 1] - nums[pos] - 1;
            pos++;
        }
        ans[num] = nums[pos] + num - was;
    }
    for(ll num : que)
        cout << ans[num] << " ";
}
int main() {
    ll t = 1;
    //cin >> t;
    while(t--)
        solve();
    return 0;
}
/*
 int n;
    cin >> n;
    vector<ll> a(n);
    for (int i = 0; i < n; i ++)
        cin >> a[i];
    set<ll> s1, s2;
    for (int i = 1; i < n / 2 + 1; i ++){
        s2.insert(a[i] + a[n - i - 1]);
    }
    ll mn = 1e12;
    for (int i = 0; i < n - 1; i ++){
        mn = min(*s2.rbegin() - *s2.begin(), mn);

    }
 */