#include <bits/stdc++.h>

using namespace std;

#define int long long
#define ll long long
#define ld long double
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define loop(start, end, var) for (int var = start; var <= end; var++)
#define loopDown(start, end, var) for (int var = start; var >= end; var--)
#define sz(x) (int)((x).size())
#define pb push_back
#define F first
#define S second
#define mp make_pair
#define pw(x) (1ll << (x))

typedef pair<int, int> pi;
typedef pair<int, int> pii;
typedef vector<int> vi;

const int mod = 1e9 + 7;
inline int add (int &a, int b) { a += b; if (a >= mod) a -= mod; return a; }
inline int mult (int a, int b) { return (a * 1ll * b) % mod; }

void solve() {
	int n, m; cin >> n >> m;
	int s, t, L; cin >> s >> t >> L; --s, --t;
	vector <vector <pii>> g (n);
	vector <array <int, 3>> edge (m);
	for (int i = 0; i < m; ++i) {
		int u, v, c; cin >> u >> v >> c; --v, --u;
		g[u].pb({v, c});
		g[v].pb({u, c});
		edge[i] = {u, v, c};
	}
	const int inf = 1e18 + 127;
	vector <int> dps (n), dpt (n);
	vector <int> dists (n, inf), distt (n, inf);
	dists[s] = 0; dps[s] = 1;
	priority_queue <pii, vector <pii>, greater <pii>> pq; pq.push({0, s});
	while (sz(pq)) {
		auto [d, v] = pq.top(); pq.pop();
		if (d > dists[v]) continue;
		if (v == t) continue;
		for (auto [u, w] : g[v]) {
			if (dists[u] > d + w) {
				dists[u] = d + w;
				pq.push({dists[u], u});
			}
		}
	}

	queue <int> q; q.push(s);
	vector <bool> used (n, 0); used[s] = 1;
	while (sz(q)) {
		int v = q.front(); q.pop();
		if (v == t) continue;
		for (auto [u, w] : g[v]) {
			if (!used[u]) q.push(u), used[u] = 1;
			if (dists[v] + w == dists[u]) add(dps[u], dps[v]);
		}
	}

	distt[t] = 0; dpt[t] = 1;
	pq.push({0, t});
	while (sz(pq)) {
		auto [d, v] = pq.top(); pq.pop();
		if (d > distt[v]) continue;
		if (v == s) continue;
		for (auto [u, w] : g[v]) {
			if (distt[u] > d + w) {
				distt[u] = d + w;
				pq.push({distt[u], u});
			}
		}
	}

	q.push(t);
	fill(all(used), 0); used[t] = 1;
	while (sz(q)) {
		int v = q.front(); q.pop();
		if (v == s) continue;
		for (auto [u, w] : g[v]) {
			if (!used[u]) q.push(u), used[u] = 1;
			if (distt[v] + w == distt[u]) add(dpt[u], dpt[v]);
		}
	}

	int ans = 0;
	for (auto [u, v, w] : edge) {
		if (dists[u] > dists[v]) swap(u, v);
		if (dists[u] + distt[v] + w == L) add(ans, mult(dps[u], dpt[v]));
	}
	cout << ans;
}

signed main(){
	ios_base::sync_with_stdio(0);
	cout.tie(0);
	cin.tie();
	#ifdef ON_PC
		freopen("input.txt", "r", stdin);
		freopen("output.txt", "w", stdout);
	#endif // ON_PC
	int T = 1;
	while (T--){
		solve();
	}
}

