
#include <bits/stdc++.h>

#define ll long long
#define ld long double
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

using namespace std;

void solve(){
	int n, q;
	cin >> n >> q;
	vector<ll> a(n + 2);
	a[0] = -1;
	for (int i = 1; i <= n; i++){
		cin >> a[i];
	}
	a[n + 1] = 2e9;
	vector<ll> pref(n + 2);
	for (int i = 1; i <= n + 1; i++){
		pref[i] = pref[i - 1] + a[i] - a[i - 1] - 1;
	}
	for (int id = 0; id < q; id++){
		int k;
		cin >> k;
		int l = 0, r = n + 2;
		while (r - l > 1){
			int m = (l + r) / 2;
			if (pref[m] >= k){
				r = m;
			} else {
				l = m;
			}
		}
		cout << a[r - 1] + k - pref[r - 1] << " ";
	}
}

signed main(){
	ios_base::sync_with_stdio(0);
	cout.tie(0);
	cin.tie();
	#ifdef ON_PC
		freopen("input.txt", "r", stdin);
		freopen("output.txt", "w", stdout);
	#endif // ON_PC
	int T = 1;
	while (T--){
		solve();
	}
}
