#include <iostream>
#include <vector>
#include <set>
#include <string>
#include <algorithm>

using namespace std;

typedef vector<int> vi;
typedef long long ll;
typedef vector<long long> vll;
typedef pair<int, int> pii;

//#define int long long 

void solve() {
	int n, m; cin >> n >> m;
	vi v(n);
	for (int i = 0; i < n; ++i)
		cin >> v[i];
	vector<pii> q(m);
	for (int i = 0; i < m; ++i) {
		cin >> q[i].first;
		q[i].second = i;
	}
	vi r(m);
	sort(v.begin(), v.end());
	sort(q.begin(), q.end());
	int cnt = 0, f = 0, fq = 0;
	for (int i = 0; i <= 1e9 + n + 10; ++i) {
		if (f >= n || v[f] > i) {
			++cnt;
		}
		if (f < n && v[f] == i) {
			++f;
		}
		bool ok = 0;
		while (cnt == q[fq].first) {
			r[q[fq].second] = i;
			++fq;
			if (fq >= m) {
				ok = 1;
				break;
			}
		}
		if (ok)
			break;
	}
	for (auto i : r)
		cout << i << " ";
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
	}
}
