#define _CRT_SECURE_NO_WARNINGS
#include<iostream>
#include<algorithm>
#include<vector>
#include<set>
#include<map>
#include<vector>
#include<queue>
#include<deque>
#include<bitset>
#include<random>

using namespace std;
using ll = long long;
using ld = long double;

#define int long long
#define all(v) v.begin(), v.end()
#define endl '\n'

const int N = 1e6 + 9;
const ll INF = 1e18 + 9, MOD = 1e9+7;

struct Edge {
	int u, w;
};

int n, m, s, t, L;
int ds[N], cnts[N], dt[N], cntt[N];
vector<Edge> edges[N];
void Dijkstra(int v, int* d, int* cnt) {
	set<pair<int, int> > s;
	s.clear();
	for (int i = 1; i <= n; i++) {
		d[i] = INF;
		s.insert({ d[i], i });
		cnt[i] = 0;
	}
	s.erase({ d[v], v });
	d[v] = 0;
	s.insert({ d[v], v });
	cnt[v] = 1;
	while (s.size()) {
		int cur = s.begin()->second;
		for (auto e : edges[cur]) {
			if (e.w + d[cur] == d[e.u]) {
				cnt[e.u] += cnt[v];
				cnt[e.u] %= MOD;
			}
			if (e.w + d[cur] < d[e.u]) {
				s.erase({ d[e.u], e.u });
				d[e.u] = e.w + d[cur];
				s.insert({ d[e.u], e.u });
				cnt[e.u] = cnt[cur];
			}
		}
		s.erase({d[cur], cur});
	}
}


signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#else
	cin.tie(0);
	ios_base::sync_with_stdio(0);
#endif
	cin >> n >> m >> s >> t >> L;
	for (int i = 0; i < m; i++) {
		int u, v, w;
		cin >> u >> v>> w;
		edges[u].push_back({ v,w });
		edges[v].push_back({ u,w });
	}
	Dijkstra(s, ds, cnts);
	Dijkstra(t, dt, cntt);
	if (L == ds[t]) {
		cout << cnts[t] << "\n";
		return 0;
	}
	if (L < ds[t]) {
		cout << 0;
		return 0;
	}
	int mn = ds[t];
	int answ = 0;
	for (int v = 1; v <= n; v++) {
		if (ds[v] + dt[v] == mn) {
			for (auto u : edges[v]) {
				if (ds[v] + u.w + dt[u.u] == L) {
					int kek = cnts[v] * cntt[u.u];
					kek %= MOD;
					answ += kek;
					answ %= MOD;
				}
			}
		}
	}
	cout << answ << "\n";
}