#include <algorithm>
#include <iostream>
#include <vector>
using namespace std;

#define int long long
constexpr int mod = 1e9 + 7;

int N = 400;
pair<int, int> dp[401][401];
pair<int, int> pref[401][401];

int bindeg(int a, int deg) {
	if (deg == 0) return 1;
	if (deg % 2) return (a * bindeg(a, deg - 1)) % mod;
	int x = bindeg(a, deg / 2);
	return (x * x) % mod;
}

int32_t main() {
	int h, w;
	cin >> h >> w;

	vector<int> smth(1000, 1);
	for (int i = 0; i < 1000; i++) {
		smth[i] = bindeg(i, mod - 2);
	}

	for (int j = 1; j <= N; j++) {
		for (int i = 1; i <= N; i++) {
			if (i <= 2 || j <= 2) {
				dp[i][j] = { 1, i * j };
				continue;
			}

			for (int l = 1; l <= i - 2; l++) {
				dp[i][j].first = dp[i][j].first + (pref[l][j - 2].first * (i - l - 1))%mod;
				dp[i][j].second = dp[i][j].second + (pref[l][j - 2].second * (i - l - 1))%mod;
			}

			dp[i][j].first = (dp[i][j].first + 1)%mod;
			dp[i][j].second = (dp[i][j].second + (i * j) * dp[i][j].first)%mod;
		}

		for (int h_ = 1; h_ <= N; h_++) {
			for (int w_ = 1; w_ <= j - 1; w_++) {
				pref[h_][w_].first = (dp[h_][w_].first * (j - w_) + pref[h_][w_ - 1].first) % mod;
				pref[h_][w_].second = (dp[h_][w_].second * (j - w_) + pref[h_][w_ - 1].second) % mod;
			}
		}
	}

	cout << dp[h][w].second << endl;
}