#include <bits/stdc++.h>

using namespace std;
const int INF = 1e9 + 10;

void solve() {
    int n;
    cin >> n;
    vector <int> a(n);
    for (int i = 0; i < n; ++i) cin >> a[i];
    vector <pair <int, int>> all;
    for (int i = 0; i < n; ++i) {
        all.emplace_back(a[i], i);
    }
    sort(all.rbegin(), all.rend());
    int q;
    cin >> q;
    vector <int> curl(q), curr(q, INF);
    vector <pair <int, int>> flex(q);
    for (int i = 0; i < q; ++i) {
        cin >> flex[i].first >> flex[i].second; --flex[i].first; --flex[i].second;
    }
    while (true) {
        bool ok = false;
        vector <pair <int, int>> all_q;
        for (int i = 0; i < q; ++i) {
            if (curl[i] + 1 == curr[i]) continue;
            ok = true;
            all_q.emplace_back((curl[i] + curr[i]) / 2, i);
        }
        if (!ok) break;
        sort(all_q.rbegin(), all_q.rend());
        vector <set <int>> s(2);
        int now = 0;
        for (auto i : all) {
            while (now < (int)all_q.size() && i.first < all_q[now].first) {
                int l = flex[all_q[now].second].first;
                int r = flex[all_q[now].second].second;
                int m = all_q[now].first;
                int ind = all_q[now].second;
                ++now;
                if (a[l] < m) {
                    auto it = s[(l & 1) ^ 1].lower_bound(l);
                    if (it != s[(l & 1) ^ 1].end() && *it + 1 <= r) {
                        l = *it + 1;
                    } else {
                        curr[ind] = m;
                        continue;
                    }
                }
                if (a[r] < m) {
                    auto it = s[(r & 1)].lower_bound(r + 1);
                    if (it != s[r & 1].begin()) {
                        it = prev(it);
                        if (*it >= l) {
                            curl[ind] = m;
                        } else {
                            curr[ind] = m;
                        }
                        continue;
                    } else {
                        curr[ind] = m;
                        continue;
                    }
                }
                curl[ind] = m;
            }
            if (i.second < n - 1 && a[i.second + 1] >= i.first) s[i.second & 1].insert(i.second);
            if (i.second > 0 && a[i.second - 1] >= i.first) s[(i.second - 1) & 1].insert(i.second - 1);
        }
        while (now < (int)all_q.size()) {
            curl[all_q[now].second] = all_q[now].first;
            now++;
        }
    }
    for (int i = 0; i < q; ++i) cout << curl[i] << "\n";
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    while (t--) {
        solve();
    }
    return 0;
}

/*
3 10 5
0 3
1 1
4 2
 */