#include <bits/stdc++.h>

using namespace std;
#define ll long long
#define int long long


const ll mod = 1e9 + 7;

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int h, w;
    cin >> h >> w;
    vector<vector<ll>> dp(h + 1, vector<ll>(w + 1, 0));
    vector<vector<ll>> cnt(h + 1, vector<ll>(w + 1, 0));
    for(int h2 = 1; h2 <= h; h2 += 1){
        for(int w2 = 1; w2 <= w; w2 += 1){
            dp[h2][w2] = 0;
            cnt[h2][w2] = 1;
        }
        for(int h1 = 1; h1 + 2 <= h2; h1 += 1){
            ll sm1 = 0;
            ll sm2 = 0;
            ll smc1 = 0;
            ll smc2 = 0;
            for(int w2 = 3; w2 <= w; w2 += 1){
                int w1 = w2 - 2;
                sm1 = (sm1 + dp[h1][w1]) % mod;
                sm2 = (sm2 + dp[h1][w1] * (w1 + 1)) % mod;
                smc1 = (smc1 + cnt[h1][w1]) % mod;
                smc2 = (smc2 + cnt[h1][w1] * (w1 + 1)) % mod;
                cnt[h2][w2] = (cnt[h2][w2] + (h2 - h1 - 1) * ((w2 * smc1 - smc2) % mod)) % mod;
                dp[h2][w2] = (dp[h2][w2] + (h2 - h1 - 1) * ((w2 * sm1 - sm2) % mod)) % mod;
                if(dp[h2][w2] < 0){
                    dp[h2][w2] += mod;
                }
                if(cnt[h2][w2] < 0){
                    cnt[h2][w2] += mod;
                }
            }
        }
        for(int w2 = 1; w2 <= w; w2 += 1){
            dp[h2][w2] = (dp[h2][w2] + cnt[h2][w2] * h2 * w2) % mod;
        }
    }
    cout << dp[h][w] << "\n";
    return 0;
}

/*
3 10 5
0 3
1 1
4 2
 */