#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;
#define int long long
#define ll int
signed main() {
    cin.tie(nullptr)->sync_with_stdio(0);

    int n; cin >> n;
    vector<int> a(n);
    for (int& x : a)
        cin >> x;

    int res = int(1e9) + 10;

    sort(a.begin(), a.end());
    for (int _ : { 0, 1 }) {
        multiset<int> mn, mx;

        auto add = [&](int x) {
            mn.insert(x);
            mx.insert(x);
        };
        auto remove = [&](int x) {
            mn.erase(mn.find(x));
            mx.erase(mx.find(x));
        };

        for (int i = 1; i <= n / 2; i++) {
            add(a[i] + a[n - i]);
        }

        res = min(res, *(--mx.end()) - *mn.begin());

        for (int i = 0; i < n / 2; i++) {
            remove(a[i + 1] + a[n - (i + 1)]);
            add(a[i] + a[n - (i + 1)]);
            res = min(res, *(--mx.end()) - *mn.begin());
        }

        reverse(a.begin(), a.end());
    }

    cout << res << "\n";
}
