#include <bits/stdc++.h>

using namespace std;

#define int long long
#define pi pair<int, int>

vector<string> m;
vector<vector<int>> vis;
vector<pair<int, int>> k;
int h, w, b = 0;

void dfs(int x, int y) {
    if (vis[x][y]) return;
    if (x < 0 || y < 0 || x >= h || y >= w) return;
    if (m[x][y] == '#') return;
    vis[x][y] = 1;
    k.push_back({x, y});
    if (x == 0 || y == 0 || x == h - 1 || y == w - 1) b = 1;
    dfs(x - 1, y);
    dfs(x + 1, y);
    dfs(x, y - 1);
    dfs(x, y + 1);

}

signed main() {
    ios::sync_with_stdio(false);
    cout.tie(0);
    cin >> h >> w;
    m.resize(h);
    vis.resize(h, vector<int>(w));
    int b1 = 1;
    for (int i = 0; i < h; i++) cin >> m[i];
    for (int i = 0; i < h; i++) {
        if (!b1) break;
        for (int j = 0; j < w; j++) {
            if (!vis[i][j]) {
                b = 0;
                k.clear();
                dfs(i, j);
                if (!b && k.size() != 0) {
                    b1 = 0;
                    break;
                }
            }
        }
    }
    pair<int, int> ld = {-1, 1e9}, lu = {1e9, 1e9}, ru = {1e9, -1}, rd = {-1, -1};
    for (int i = 0; i < k.size(); i++) {
        int x = k[i].first, y = k[i].second;
        if (ld.first <= x + 1 && ld.second >= y - 1) {
            ld = {x + 1, y - 1};
        }
        if (lu.first >= x - 1 && lu.second >= y - 1) {
            lu = {x - 1, y - 1};
        }
        if (ru.first >= x - 1 && ru.second <= y + 1) {
            ru = {x - 1, y + 1};
        }
        if (rd.first <= x + 1 && rd.second <= y + 1) {
            rd = {x + 1, y + 1};
        }
    }
    deque<pair<int, int>> q;
    q.push_back({lu.first, lu.second});
    vis.clear();
    vis.resize(h, vector<int>(w));
    vis[lu.first][lu.second] = 1;
    vector<vector<pair<int, int>>> p(h, vector<pair<int, int>>(w));
    while (!q.empty()) {
        int x = q.front().first, y = q.front().second;
        q.pop_front();
        if (x < 0 || y < 0 || x >= h || y >= w) continue;
        if (m[x][y] == '.') continue;
        vis[x][y] = 1;
        if (x != 0 && !vis[x - 1][y]) {
            vis[x - 1][y] = 1;
            p[x - 1][y] = {x, y};
            q.push_back({x - 1, y});
        }
        if (y != 0 && !vis[x][y - 1]) {
            vis[x][y - 1] = 1;
            p[x][y - 1] = {x, y};
            q.push_back({x, y - 1});
        }
        if (x != h - 1 && !vis[x + 1][y]) {
            vis[x + 1][y] = 1;
            p[x + 1][y] = {x, y};
            q.push_back({x + 1, y});
        }
        if (y != w - 1 && !vis[x][y + 1]) {
            vis[x][y + 1] = 1;
            p[x][y + 1] = {x, y};
            q.push_back({x, y + 1});
        }
    }
    vector<vector<char>> ans(h, vector<char>(w, '.'));
    int tx = ld.first, ty = ld.second;
    while (tx != lu.first || ty != lu.second) {
        ans[tx][ty] = '#';
        int t1 = p[tx][ty].first, t2 = p[tx][ty].second;
        tx = t1;
        ty = t2;
    }
    tx = ru.first, ty = ru.second;
    while (tx != lu.first || ty != lu.second) {
        ans[tx][ty] = '#';
        int t1 = p[tx][ty].first, t2 = p[tx][ty].second;
        tx = t1;
        ty = t2;
    }
    ans[tx][ty] = '#';
    q.push_back({rd.first, rd.second});
    vis.clear();
    vis.resize(h, vector<int>(w));
    vis[rd.first][rd.second] = 1;
    p.clear();
    p.resize(h, vector<pair<int, int>>(w));
    while (!q.empty()) {
        int x = q.front().first, y = q.front().second;
        q.pop_front();
        if (x < 0 || y < 0 || x >= h || y >= w) continue;
        if (m[x][y] == '.') continue;
        vis[x][y] = 1;
        if (x != 0 && !vis[x - 1][y]) {
            vis[x - 1][y] = 1;
            p[x - 1][y] = {x, y};
            q.push_back({x - 1, y});
        }
        if (y != 0 && !vis[x][y - 1]) {
            vis[x][y - 1] = 1;
            p[x][y - 1] = {x, y};
            q.push_back({x, y - 1});
        }
        if (x != h - 1 && !vis[x + 1][y]) {
            vis[x + 1][y] = 1;
            p[x + 1][y] = {x, y};
            q.push_back({x + 1, y});
        }
        if (y != w - 1 && !vis[x][y + 1]) {
            vis[x][y + 1] = 1;
            p[x][y + 1] = {x, y};
            q.push_back({x, y + 1});
        }
    }
    tx = ld.first, ty = ld.second;
    while (tx != rd.first || ty != rd.second) {
        ans[tx][ty] = '#';
        int t1 = p[tx][ty].first, t2 = p[tx][ty].second;
        tx = t1;
        ty = t2;
    }
    tx = ru.first, ty = ru.second;
    while (tx != rd.first || ty != rd.second) {
        ans[tx][ty] = '#';
        int t1 = p[tx][ty].first, t2 = p[tx][ty].second;
        tx = t1;
        ty = t2;
    }
    ans[tx][ty] = '#';
    for (int i = 0; i < h; i++) {
        for (int j = 0; j < w; j++) {
            cout << ans[i][j];
        }
        cout << '\n';
    }
}
