import sys
import math
from collections import Counter, deque, defaultdict
import heapq


def II():
    return int(sys.stdin.readline())


def I():
    return [int(i) for i in sys.stdin.readline().split()]


def S():
    return sys.stdin.readline().split()


def get_angle(a, b, c):
    return math.acos((a ** 2 + b ** 2 - c ** 2) / (2 * a * b))


def main():
    n = II()
    points = [I() for i in range(n)]

    st_one, st_two = set(), set()
    main_set = set()
    for i in range(n):
        g = points[i]
        g.sort()
        st_one |= set(g)
        st_two |= {(g[0], g[2]), (g[0], g[1]), (g[1], g[2])}
        main_set.add(tuple(g))
    main_dict = dict([(i, []) for i in main_set])
    two_points_dict = dict([(i, []) for i in st_two])
    one_point_dict = dict([(i, []) for i in st_one])
    for i in range(n):
        g = points[i]
        g.sort()
        one_point_dict[g[0]].append((i, 0))
        one_point_dict[g[1]].append((i, 1))
        one_point_dict[g[2]].append((i, 2))
        two_points_dict[(g[0], g[1])].append((i, 2))
        two_points_dict[(g[0], g[2])].append((i, 1))
        two_points_dict[(g[1], g[2])].append((i, 0))
        main_dict[tuple(g)].append(i)

    for i in range(n):
        pts = points[i]
        for j in range(3):
            for idx, p in one_point_dict[pts[j]]:
                if idx != i:
                    idx1 = [0, 1, 2]
                    idx1.remove(j)
                    idx2 = [0, 1, 2]
                    idx2.remove(p)
                    for i1, i2 in [[0, 0], [0, 1], [1, 0], [1, 1]]:
                        pair = [points[idx][idx2[i2]], points[i][idx1[i1]]]
                        pair.sort()
                        pair = tuple(pair)
                        i1r = i1 ^ 1
                        i2r = i2 ^ 1
                        a1, a2 = get_angle(points[i][i1], points[i][j], points[i][i1r]),\
                                 get_angle(points[idx][i2], points[idx][p], points[idx][i2r])
                        a3 = 2 * math.pi - a1 - a2
                        max_st = (points[i][i1] ** 2 + points[idx][i2] ** 2 - 2 * math.cos(a3) * points[i][i1] * points[idx][i2]) ** 0.5
                        if pair in st_two:
                            for idx_last, p_last in two_points_dict[pair]:
                                if points[idx_last][p_last] < max_st and idx_last not in [i, idx]:
                                    last = [points[idx_last][p_last], points[i][i1r], points[idx][i2r]]
                                    last.sort()
                                    last = tuple(last)
                                    if last in main_set:
                                        for idx_t in main_dict[last]:
                                            if idx_t not in [idx_last, i, idx]:
                                                ans = [idx_last, i, idx, idx_t]
                                                ans = [i + 1 for i in ans]
                                                ans.sort()
                                                print('Yes')
                                                print(*ans)
                                                return
    print('No')


if __name__ == '__main__':
    main()