#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>

#pragma GCC optimize("Ofast")
#pragma GCC target("avx2")

#define ll long long
#define ld long double

using namespace std;

void solve() {
    int n;
    cin>>n;
    vector <ll> v(n);
    for(int i=0; i<n; i++) cin>>v[i];
    sort(v.begin(), v.end());
    if(n==3) {
        ll ans=0;
        ans=v[2]-v[1];
        ans=min(ans, v[2]-v[0]);
        ans=min(ans, v[1]-v[0]);
        cout<<ans;
        return;
    }
    ll ans=1e9+1;
    ll minn=1e9+1;
    ll maxx=0;
    for(int i=1; i<=n/2; i++) {
        if(minn>v[i]+v[n-i]) {
            minn=v[i]+v[n-i];
        }
        if(maxx<v[i]+v[n-i]) {
            maxx=v[i]+v[n-i];
        }
    }
    ans=min(ans, maxx-minn);
    minn=1e9+1, maxx=0;
    for(int i=0; i<n/2; i++) {
        if (minn > v[i] + v[n - i - 2]) {
            minn = v[i] + v[n - i - 2];
        }
        if (maxx < v[i] + v[n - i - 2]) {
            maxx = v[i] + v[n - i - 2];
        }
    }
    ans=min(ans, maxx-minn);
    minn=1e9+1, maxx=0;
    for(int i=0; i<n/2; i++) {
        if(minn>v[i]+v[n-i-1]) {
            minn=v[i]+v[n-i-1];
        }
        if(maxx<v[i]+v[n-i-1]) {
            maxx=v[i]+v[n-i-1];
        }
    }
    ans=min(ans, maxx-minn);
    cout<<ans;

}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    solve();
    return 0;
}
