#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include <iostream>
#include <cmath>
#include <vector>
#include <set>
#include <algorithm>
#include <set>

using namespace std;

typedef long long ll;
typedef long double ld;

const ll INF = 1e18;

int main() {
    ios_base::sync_with_stdio(false), cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n;
    cin >> n;
    vector<int> a(n);
    for (auto &i : a) {
        cin >> i;
    }
    sort(a.begin(), a.end());
    multiset<int> m_otr, m;
    for (int i = 1; i <= n / 2; ++i) {
        m.insert(a[i] + a[n - i]);
        m_otr.insert(-a[i] - a[n - i]);
    }
    /*for (auto i : m) {
        cout << i << ' ';
    }
    cout << endl;
    for (auto i : m_otr) {
        cout << i << ' ';
    }
    cout << endl;
    cout << "SMILE :)" << endl;*/
    ll ans = INF;
    for (int i = 0; i < n / 2; ++i) {
        int p1 = *m.begin();
        int p2 = -*m_otr.begin();
        ans = min(ans, (ll) p2 - p1);
        //cout << ans << ' ' << p1 << ' ' << p2 << endl;
        m.erase(m.find(a[i + 1] + a[n - i - 1]));
        m_otr.erase(m_otr.find(- a[i + 1] - a[n - i - 1]));
        m.insert(a[i] + a[n - i - 1]);
        m_otr.insert(- a[i] - a[n - i - 1]);
    }
    //cout << "SMILE :)" << endl;
    for (int i = n / 2; i < n; ++i) {
        int p1 = *m.begin();
        int p2 = -*m_otr.begin();
        ans = min(ans, (ll) p2 - p1);
        if (i != n - 1) {
            m.erase(m.find(a[i + 1] + a[n - i - 2]));
            m_otr.erase(m_otr.find(- a[i + 1] - a[n - i - 2]));
            m.insert(a[i] + a[n - i - 2]);
            m_otr.insert(- a[i] - a[n - i - 2]);
        }
    }
    cout << ans;
}
