#include <bits/stdc++.h>
using namespace std;
#define int long long
#define pb push_back

void run() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}
const int INF = INT_MAX-1;

const int NMAX = 100001;
const int MOD = 1000000007;
int n, m, s, t, l;
vector<vector<pair<int, int>>> g;


signed main() {
    run();
    cin >> n >> m >> s >> t >> l;
    s--; t--;
    g.resize(n, vector<pair<int, int>>());
    int x, y, w;
    for (int i = 0; i < m; i++) {
        cin >> x >> y >> w;
        x--; y--;
        g[x].pb({w, y});
        g[y].pb({w, x});
    }

    vector<int> d(n, INF);
    d[t] = 0;
    set<pair<int, int>> q;
    vector<int> cnt(n, 1);
    q.insert({0, t});
    while(!q.empty()) {
        auto fir = q.begin();
        q.erase(q.begin());
        int v = fir->second;
        w = fir->first;
        if(d[v] == INF) break;
        for (int i = 0; i < g[v].size(); i++) {
            pair<int, int> to = g[v][i];
            if (d[to.second] > d[v] + to.first) {
                d[to.second] = d[v] + to.first;
                int sz = q.size();
                q.insert({d[to.second], to.second});
                if(q.size() == sz) {
                    cnt[to.second]++;
                }
            }
        }
    }

    vector<int> d2(n, INF);
    d2[s] = 0;
    q.clear();
    vector<int> cnt2(n, 1);
    q.insert({0, s});
    while(!q.empty()) {
        auto fir = q.begin();
        q.erase(q.begin());
        int v = fir->second;
        w = fir->first;
        if(d2[v] == INF) break;
        for (int i = 0; i < g[v].size(); i++) {
            pair<int, int> to = g[v][i];
            if (d2[to.second] > d2[v] + to.first) {
                d2[to.second] = d2[v] + to.first;
                int sz = q.size();
                q.insert({d2[to.second], to.second});
                if(q.size() == sz) {
                    cnt2[to.second]++;
                }
            }
        }
    }

//    cout << "CNT\n";
//    for (int i = 0; i < n; i++) {
//        cout << cnt[i] << ' ';
//    }
//    cout << '\n';
//    for (int i = 0; i < n; i++) {
//        cout << cnt2[i] << ' ';
//    }
//    cout << '\n';
//    cout << "DIST\n";
//    for (int i = 0; i < n; i++) {
//        cout << d[i] << ' ';
//    }
//    cout << '\n';
//    for (int i = 0; i < n; i++) {
//        cout << d2[i] << ' ';
//    }
//    cout << '\n';

    int ans = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < g[i].size(); j++) {
            int to = g[i][j].second;
            if (d[i] + d2[i] == d[s] && d2[i] + g[i][j].first + d[to] == l) {
//                cout << "FIR " << i + 1 << ' ' << to + 1 << ' ' << d2[i] << ' ' << g[i][j].first << ' ' << d[to] << '\n';
                ans = (ans + (cnt[i] * cnt2[to]) % MOD) % MOD;
            }
//            if (d[i] + d2[to] + 2 * g[i][to].first == l) {
//                cout << "SEC " << i + 1 << ' ' << to + 1 << '\n';
//                ans = (ans + (cnt[i] * cnt2[to]) % MOD) % MOD;
//            }
        }
    }

    cout << ans;
    return 0;
}
