import random
from sys import setrecursionlimit
from bisect import bisect_left, bisect_right
import threading

setrecursionlimit(10 ** 9)
threading.stack_size(67108864)

# old_print = print
# old_input = input
# _in = []
# _out = []
#
#
#
# def print(*args):
#     _out.extend(args)
#
#
# def input():
#     return _in.pop()


def main():
    n, q = map(int, input().split())
    a = (list(map(int, input().split())))
    a_s = set(a)
    ks = map(int, input().split())

    ans = []

    for k in ks:
        b = bisect_left(a, k)
        number = k - b  # k
        val = k - 1
        while number != k:
            val += 1
            if val not in a_s:
                number += 1
        ans.append(val)

    print(*ans)


"""
4 10
1 2 6 7
1 2 3 4 5 6 7 8 10 11

4 10
0 1 2 4 5 9
2
"""

# if __name__ == '__main__':
#     from random import randint
#     _in.append(" ".join([str(random.randint(5, 400)) for _ in range(40)]))
#     _in.append("".join([str(random.randint(5, 400)) for _ in range(10)]))
#     _in.append(" ".join([str(random.randint(5, 400)) for _ in range(2)]))
#     main()
#     old_print(_out)

thread = threading.Thread(target=main)
thread.start()
