#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
//#include <bits/stdc++.h>
typedef long long ll;
typedef long double ld;
#define loop(i, n) for(ll i = 0; i < n; i++)
#define all(x) x.begin(), x.end()
#define pb push_back
#define f first
#define s second
#define inf 1e12

using namespace std;
ll INF = 1e12;


ll find_hex_cnt(ll x, vector<ll> &a) {
    ll l = 0, r = a.size() - 1;
    while(l + 1 != r) {
        ll m = (l + r) / 2;
        if (m + x < a[m])
            r = m;
        else
            l = m;
    }
    return r;
}


void solve_c() {
    int n; cin >> n;
    vector<int> a;
    for (int i = 0; i < n; i++) {
        int x; cin >> x;
        a.push_back(x);
    }
    sort(a.begin(), a.end());
    ll mnp = 1e18, mxp = -1, ans;
    for (int j = 0; j < n / 2; j++) {
        ll p = a[j] + a[n - j - 2];
        mnp = min(mnp, p);
        mxp = max(mxp, p);
        ans = min(ans, mxp - mnp);
    }
    ll m = n / 2;
    for (int i = 1; i < m; i++) {
        ll p1, p2;
        p1 = a[n - i] + a[i - 1];
        p2 = a[n - i - 2] + a[i];
        mxp = max(max(p2, p1), mxp);
        mnp = min(min(p2, p1), mnp);
        cout << mxp << ' ' << mnp << endl;
        ans = min(mxp - mnp, ans);
        p1 = a[n - i] + a[i - 1];
        p2 = a[n - i - 2] + a[i];
        mxp = max(max(p2, p1), mxp);
        mnp = min(min(p2, p1), mnp);
        cout << mxp << ' ' << mnp << endl;
        ans = min(mxp - mnp, ans);
    }
    cout << ans;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    //-------DATA-------
    ll n; cin >> n;
    ll q; cin >> q;
    vector<ll> a(n);
    loop(i, n) {
        cin >> a[i];
    } a.pb(inf);
    //------------------
    //-------ALG--------
    loop(i, q) {
        ll k; cin >> k; k--;
        ll dx = find_hex_cnt(k, a);
        if (k < a[0])
            cout << k << ' ';
        else
            cout << k + dx << ' ';
    }
    //------------------


}
