#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
int main() {
    ios_base::sync_with_stdio(false);
    cout.tie(0);
    cin.tie(0);
    int n;
    cin >> n;
    vector <int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    sort(a.begin(), a.end());
    int min_res = -1;
    for (int i = 0; i < n; i++) {
        int l = 0;
        int r = n - 1;
        int max_s = -1;
        int max_r = -1;
        while (r - l > 0) {
            if (i == l) {
                l++;
            } else if (i == r) {
                r--;
            }
            if (max_s == -1 || max_s > a[l] + a[r]) {
                max_s = a[l] + a[r];
            }
            if (max_r == -1 || max_r < a[l] + a[r]) {
                max_r = a[l] + a[r];
            }
            l++;
            r--;
        }
        if (min_res == -1 || min_res > max_r - max_s) {
            min_res = max_r - max_s;
        }
    }
    cout << min_res;
}
