#include <bits/stdc++.h>
#define int long long
#define ld long double

using namespace std;
const int mod = 1e9 + 7;
int add(int a, int b) {
    if ((a + b) >= mod) {
        return a + b - mod;
    }
    return a + b;
}
int mul(int a, int b) {
    return (a * b) % mod;
}
int sub(int a, int b) {
    if (a - b < 0) return a - b + mod;
    return a - b;
}

const int inf = 1e18;

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m;
    cin >> n >> m;
    int s, t, L;
    cin >> s >> t >> L;
    s--, t--;
    vector<vector<pair<int, int>>> g(n);
    vector<pair<int, int>> edg;
    for (int i = 0; i < m; i++) {
        int x, y, w;
        cin >> x >> y >> w;
        x--, y--;
        g[x].push_back({y, w});
        g[y].push_back({x, w});
    }
    function<pair<vector<int>, vector<int>>(int)> dij = [&](int start) {
        vector<int> dist(n, inf), cnt(n, 0);
        cnt[start] = 1;
        dist[start] = 0;
        set<pair<int, int>> st;
        st.insert({0, start});
        while (!st.empty()) {
            int v = st.begin()->second;
            st.erase(st.begin());
            for (auto [u, w] : g[v]) {
                if (dist[u] > dist[v] + w) {
                    st.erase({dist[u], u});
                    cnt[u] = cnt[v];
                    dist[u] = dist[v] + w;
                    st.insert({dist[u], u});
                } else if (dist[u] == dist[v] + w) {
                    cnt[u] = add(cnt[u], cnt[v]);
                }
            }
        }
        return make_pair(dist, cnt);
    };
    auto res_s = dij(s), res_t = dij(t);
    vector<int> ds = res_s.first, cs = res_s.second;
    vector<int> dt = res_t.first, ct = res_t.second;
    int ans = 0;
    if (L == dt[s]) {
        cout << ct[s] << "\n";
        return 0;
    }
    for (int v = 0; v < n; v++) {
        if (v == t) continue;
        for (auto [u, w]: g[v]) {
            if (ds[v] + dt[v] != ds[t]) continue;
            if (ds[v] + w + dt[u] != L) continue;
            ans = add(ans, mul(cs[v], ct[u]));
        }
    }
    cout << ans << "\n";
}
